@REM Created by Nicholas "Tiger" Gautier
@REM Contact: SibTiger_And_Life@Hotmail.com
@REM Website: http://tigersfiles.webs.com/
@REM Details: This program [the core], is designed as a front-end program that sets the environment for any compatible module.  This program depends on external scripts to carry out any specific task or operations the user requests, such external modules can depend on the environment that this program provides to make life easier for both the end-user and the programmer.
@REM ==========================================

@ECHO OFF
ECHO Executing %0...
ECHO.
REM Before we begin the initial program, check the host operating system.
GOTO :IncompatibilityOS_Check




REM =====================================================================
REM Terms of Agreement (AKA Legal Crap)
REM ----------------------------
REM Self explanatory....
REM =====================================================================


REM I have removed the code and the terms of agreement wording from this section.  I am sure that it is not accurate and I am not a lawyer, but instead I am just a creator.  I have created this program for several reasons:
REM    A} To make some tedious tasks - less tedious and expeditious
REM    B} To help others get the job[s] finished
REM    C} Allow everyone to use this program and even further expand it for their reasons or purposes
REM
REM In exchange all that I ask for those wanting to create a script or module [I can't force anyone to follow these]:
REM    A} When you create a module or script that is designed for this program, do NOT mislead the user.  Thus, do not cause intentional harm to the user our their system.
REM    B} Modules and scripts source code should always be available.  With batch, that shouldn't be much of a problem as the scripts are already readable.
REM
REM If someone wishes to take this entire program and up[date|grade] it or change it for whatever reasons, feel free to-do so.  Do not, however, charge users (currency wise) for using and retrieving the program.  I [the creator of this program] would like _some_ credit for the main work, the meaning of _some_ can be a simple comment within the program.




REM =====================================================================
REM Startup Driver
REM ----------------------------
REM When starting the program, this section will help aid the program to start up correctly and properly set the environment before allowing the user to take control.
REM =====================================================================


REM # =============================================================================================
REM # Documentation: Startup procedure function; this will help guide the program to startup correctly.
REM # =============================================================================================
:Startup_Driver
REM Change the users working directory, if necessary.
CALL :ClientWorkingDirectorySetup_Driver
IF %ERRORLEVEL% GEQ 1 (GOTO :Startup_ManageErrHook)
REM ---- ---- ----
REM Pass through the Environment setup
CALL :EnvironmentSetup_Switch StartUp
REM ---- ---- ----
CALL :ClearBuffer 1
GOTO :MainScreen



REM # =============================================================================================
REM # Documentation: When the Environment Hooking reaches an error, this function will call the 'Kill' function.
REM # =============================================================================================
:Startup_ManageErrHook
IF %ErrorLevel% EQU 1 CALL :Kill Hook_Operation ExtCMD
IF %ErrorLevel% EQU 2 CALL :Kill Hook_Operation WDFailure




REM =====================================================================
REM Host System Compatibility Check
REM ----------------------------
REM Windows 9x\ME batch version will _NOT_ work correctly with this program, and as such - if this program detects that the OS is Windows 9x or Windows ME, the program will terminate.
REM
REM Notes:
REM MS_DOS == Possibly earlier releases before Windows 95, Windows 95, Windows 98, Windows ME
REM Windows_NT == Windows 2000, Windows XP, Windows Vista, Windows 7, Windows 8, Windows 8.1
REM =====================================================================


REM # =============================================================================================
REM # Documentation: This function will check the host system's variable [ %OS% - System Variable ] and determine if the host system is compatible with the program.  As a safety precaution, if the OS is not compatible, immediately stop the program from running any further.  However, if the OS is in fact compatible the program, then start the execution process.
REM # =============================================================================================
:IncompatibilityOS_Check
IF "%OS%" EQU "Windows_NT" (
    SET IncompatibleOS=False
    REM Begin the initial program.
    GOTO :Startup_Driver
) ELSE (
    REM MS_DOS or not supported
    REM Host is not compatible
    SET IncompatibleOS=True
    GOTO :Kill
)




REM =====================================================================
REM Global Functions
REM ----------------------------
REM These functions listed below is used to reduce redundancy within the program by having these functions to be generally used within the code.
REM =====================================================================


REM # =============================================================================================
REM # Parameters: [{Bool} FlushData]
REM # Documentation: This function simply clears the terminal buffer, and depending on the parameter this can also clear the StandardIn [STDIN] identifier.
REM # =============================================================================================
:ClearBuffer
CLS
REM Clear the STDIN
IF %1 EQU 1 SET STDIN=
GOTO :EOF


REM # =============================================================================================
REM # Documentation: This function will simply clear the STDIN variable
REM # =============================================================================================
:ClearSTDIN
SET STDIN=
GOTO :EOF



REM # =============================================================================================
REM # Documentation: This function captures the user's input from the keyboard.
REM # =============================================================================================
:UserInput
ECHO.
ECHO %SeparatorSmall%
SET /P STDIN=^>^>^>^> 
GOTO :EOF



REM # =============================================================================================
REM # Documentation: This function will call the main Dashboard function directly, this is if the user has enabled the Dashboard functionality within the program.
REM # =============================================================================================
:DashboardDisplay
IF %DashboardViewerTool% EQU True CALL :Dashboard
GOTO :EOF



REM # =============================================================================================
REM # Parameters: [{String} Target]
REM # Documentation: This function will call the Windows Explorer and open the destination that is given when calling this function with a parameter.
REM # =============================================================================================
:Call_WindowsExplorer
EXPLORER "%~1"
GOTO :EOF



REM # =============================================================================================
REM # Parameters: [{String} File]
REM # Documentation: This function will update the title of the core and display what script is being executed.
REM # =============================================================================================
:UpdateCoreTitleExecutingScript
SET "ProcessVarA=%core.Title% [Running: %~n1]"
TITLE %ProcessVarA%
REM ProcessVarA is left as is so the caller (that called this function) can utilize it if needed
GOTO :EOF



REM # =============================================================================================
REM # Documentation: This function will only display a read error message when the user requests to install a script.
REM # =============================================================================================
:CantInstallScriptErrorMessage
ECHO The directory could not be found!  It is not possible to install or even execute any scripts!
ECHO.
ECHO Possible Solutions:
ECHO 1) Check user permissions on the system.
ECHO 2) The program [%ProgramName%] is not in a tightly limited permissive directory
ECHO 3) Hardware faults; check for File System corruptions and health of the Secondary Storage device [HDD and\or SDD]
GOTO :EOF



REM # =============================================================================================
REM # Documentation: This function will be called when the user's input does not meet the criteria that the program was wanting.  This is typically used when using the menu selections.
REM # =============================================================================================
:BadInput
ECHO.&ECHO.
ECHO ^<!^>    Invalid Input    ^<!^>
ECHO %Separator%
ECHO.
ECHO !ERR: Incorrect feedback from the user.
ECHO User Feedback: "%STDIN%"
ECHO.
PAUSE
CALL :ClearBuffer 1
GOTO :EOF




REM =====================================================================
REM Dashboard
REM ----------------------------
REM The dashboard here is to only highlight important and display what the user needs to know for the program to work correctly.
REM The idea of this dashboard, is to NOT be so verbose or full of details, but only display quick and brief details.
REM This feature - within the core - does not require so much intensive work as there is not write into memory, but only reads.  Turning this feature off will not really help aid the program performance sakes.
REM =====================================================================


REM # =============================================================================================
REM # Documentation: This function is the central point for the Dashboard Viewer tool.
REM # =============================================================================================
:Dashboard
CALL :Dashboard_HeaderBorder
ECHO                  Dashboard Viewer
ECHO Ver: %ProgramVersion%                           %ProgramReleaseDate%
ECHO Preset: %UserConfigurationLoaded%
CALL :Dashboard_FooterBorder
CALL :Dashboard_ExtraLineBreaks
GOTO :EOF



REM # =============================================================================================
REM # Documentation: After displaying the dashboard, this will add a few extra lines.  This will help keep the dashboard's contents from being smashed against other content.
REM # =============================================================================================
:Dashboard_ExtraLineBreaks
ECHO.&ECHO.&ECHO.
GOTO :EOF



REM # =============================================================================================
REM # Documentation: Display the header for the Dashboard Viewer tool
REM # =============================================================================================
:Dashboard_HeaderBorder
ECHO %SeparatorLong%
GOTO :EOF



REM # =============================================================================================
REM # Documentation: Display the footer for the Dashboard Viewer tool
REM # =============================================================================================
:Dashboard_FooterBorder
ECHO %SeparatorLong%
ECHO %SeparatorLong%
GOTO :EOF




REM =====================================================================
REM Environment Hooking
REM ----------------------------
REM Hook the client's working directory to be exactly the same as the program's absolute path.
REM This entire feature is necessary if in case the program is executed with Root access (Administrator access) which the user's working directory will be exactly: %SystemRoot%\system32.  Additionally, for those that use the terminal on Windows and invoke the program from a different working directory that is not the program's path.  In order for this program to work efficiently, we simply must alter the users current working directory to match with the program's working directory.  Once the program has be terminated [safely], the previous working directory is restored -- The user will never know that their working directory has been changed while using this program.
REM =====================================================================


REM # =============================================================================================
REM # Documentation: This function manages the entire 'Environment Hooking' functionality.
REM # =============================================================================================
:ClientWorkingDirectorySetup_Driver
REM Cache the directory locations for processing
CALL :ClientWorkingDirectorySetup_SetupPathVariables
REM Compare the working dir. and program dir.
CALL :ClientWorkingDirectorySetup_ComparePaths
IF %ERRORLEVEL% EQU 0 (
    REM Hooking passed
    GOTO :ClientWorkingDirectorySetup_Successful
)
REM From here, there was a mismatch.
REM -----
REM when we need update the users WD, this driver is going to manage the entire procedure.
CALL :ClientWorkingDirectorySetup_ChangeUserWD
IF %ERRORLEVEL% EQU 1 (
    EXIT /B 1
)
CALL :ClientWorkingDirectorySetup_ComparePaths
IF %ERRORLEVEL% EQU 0 (
    REM Hooking passed
    GOTO :ClientWorkingDirectorySetup_Successful
) ELSE (
    REM Kill the program
    CALL :ClientWorkingDirectorySetup_Failed
    EXIT /B 2
)



REM # =============================================================================================
REM # Documentation: Cache the directory locations into variables that will be used for processing.
REM # =============================================================================================
:ClientWorkingDirectorySetup_SetupPathVariables
REM cache the current Program Directory.
SET Hook_ProgramDir=%~dp0
REM This caches the filename of the program.
SET ProgramFileName=%~n0
REM Set the users current working directory to memory, regardless if necessary.
SET HookingUserWDCache=%CD%
GOTO :EOF



REM # =============================================================================================
REM # Documentation: Display the stored contents on the terminal when a serious error occurs.  Ideally, this function is meant to be displayed before the program completely terminates due to a failed hooking operation.
REM # =============================================================================================
:ClientWorkingDirectorySetup_DisplayPaths
ECHO Current Directory Path Setup
ECHO ----------------------------------------
ECHO %ProgramFileName% Directory is:
ECHO   %Hook_ProgramDir%
ECHO %UserName%'s Working Directory is:
ECHO   %CD%\
ECHO.
GOTO :EOF



REM # =============================================================================================
REM # Documentation: Compare the users working directory against the program's directory.
REM # =============================================================================================
:ClientWorkingDirectorySetup_ComparePaths
ECHO ^> Comparing the user's working directory with the program's directory...
REM Do we need to change the users working directory?
IF "%CD%\" EQU "%Hook_ProgramDir%" (
    REM Match
    ECHO The user's working directory matches with the program's working directory!
    EXIT /B 0
) ELSE (
    REM Mismatch
    ECHO !ERR: The user's working directory does not match with the program's directory!
    EXIT /B 1
)



REM # =============================================================================================
REM # Documentation: Change the user's working directory to match with the program's directory.
REM # =============================================================================================
:ClientWorkingDirectorySetup_ChangeUserWD
ECHO ^> Changing the user's working directory...
CD /D "%Hook_ProgramDir%" || EXIT /B 1
EXIT /B 0



REM # =============================================================================================
REM # Documentation: This function will notify the parent function that this operation was successful.
REM # =============================================================================================
:ClientWorkingDirectorySetup_Successful
SET Hook_Operation=1
ECHO Operation Successful!
EXIT /B 0



REM # =============================================================================================
REM # Documentation: This function will notify the parent function that this operation failed.
REM # =============================================================================================
:ClientWorkingDirectorySetup_Failed
SET Hook_Operation=0
GOTO :EOF




REM =====================================================================
REM Environment Setup Manager
REM ----------------------------
REM This entire section sets the programs environment as well as declarations that is used within this program, this will also set a default configuration for the user.  Within this section, it is also possible to write the identifiers information in to a file, which is specifically for saving the user configuration, and also printing the current value within the terminal.
REM When passing through this section, it is crucially important to look over the EnvironmentSetup_Switch.  This function demands a parameter to work correctly, otherwise the return result will be an error.
REM =====================================================================


REM # =============================================================================================
REM # Parameters: [{int} Mode]
REM # Documentation: This driver determines the action to take within the initialization field.
REM # Parameter details:
REM # 0 = Initialize
REM # 1 = Save User Variables
REM # 2 = Debug
REM # =============================================================================================
:EnvironmentSetup_Switch
IF "%1" EQU "StartUp" (
    REM When the program is starting up
    CALL :EnvironmentSetup_Core
    CALL :EnvironmentSetup_TerminalUpdates
    CALL :EnvironmentSetup_UserSettings 0
    CALL :EnvironmentSetup_DirectoryCheck
    CALL :EnvironmentSetup_Find_dotNETFoundations
    CALL :EnvironmentSetup_CheckEnvironmentPrivileges
    CALL :EnvironmentSetup_Setup_Time-and-Date
    EXIT /B 0
)
IF "%1" EQU "Restart" (
    REM When the program is requested to reset its already declared and assigned variables
    CALL :EnvironmentSetup_TerminalUpdates
    CALL :EnvironmentSetup_UserSettings 0
    CALL :EnvironmentSetup_DirectoryCheck
    CALL :EnvironmentSetup_Find_dotNETFoundations
    CALL :EnvironmentSetup_Setup_Time-and-Date
    EXIT /B 0
)
REM ----
IF "%1" EQU "UserConfigSave" (
    REM Save user configuration
    CALL :EnvironmentSetup_UserSettings 1 "%DirSavePresets%\%STDIN%"
    EXIT /B 0
)
REM ----
IF "%1" EQU "DebugUser" (
    REM Display the user's variables on screen
    CALL :EnvironmentSetup_UserSettings 2
    EXIT /B 0
)
IF "%1" EQU "Thrash" (
    REM When the program terminates, clear some sensitive variables.
    CALL :EnvironmentSetup_UninitializeVars
    EXIT /B 0
)
IF "%1" EQU "PathRestore" (
    REM When the user wishes to restore a program path to the original state
    CALL :EnvironmentSetup_UserSettings "%~2"
    EXIT /B 0
)
IF "%1" EQU "PartialReset" (
    REM When a script finishes, this will reset some of the environment that could have changed.
    CALL :EnvironmentSetup_TerminalUpdates
    EXIT /B 0
)
IF "%1" EQU "UserConfigLoad" (
    REM When loading a configuration, check wither the directory and program targets can still be detected.
    CALL :EnvironmentSetup_DirectoryCheck
    EXIT /B 0
)
IF "%1" EQU "CheckExternalResources" (
    REM Check the directory and program targets and determine if they exist.
    CALL :EnvironmentSetup_DirectoryCheck
    EXIT /B 0
)
REM ----
REM Error; Either the parameter wasn't correct or there was no parameter.
CALL :EnvironmentSetup_SwitchError
EXIT /B 1



REM # =============================================================================================
REM # Documentation: If the EnvironmentSetup_Switch reaches an error, this function will merely return an error.
REM # =============================================================================================
:EnvironmentSetup_SwitchError
REM The Switch method was invoked with an improper or unsupported parameter type.
ECHO !ERR: The Environment Switch was called with an improper setting!
PAUSE
GOTO :EOF



REM # =============================================================================================
REM # Documentation: This function houses static declarations for the core environment.
REM # =============================================================================================
:EnvironmentSetup_Core
SET ProgramName=Bootless Star
SET ProgramVersion=1.5.5
SET ProgramReleaseDate=26.March.2024
SET CodeName=Aditi
REM Program Title
SET core.Title=%ProgramName% %ProgramVersion% ^(%CodeName%^)
REM Borders
SET Separator=-------------------------
SET SeparatorLong=--------------------------------------------------
SET SeparatorSmall=-------------
REM Bell Character
SET SND_BELL=
REM User Input
SET STDIN=NULL
REM Set the ExitCode to 3; This value means: unexpected error or crash-out
SET ExitCode=3
REM Modules ExitCode
SET scriptExitCode=0
REM Working Variables - adjacent to Intel's CISC working registries [AX, BX, CX, DX]
SET ProcessVarA=NULL
SET ProcessVarB=NULL
SET ProcessVarC=NULL
SET ProcessVarD=NULL
REM Dedicated Directories
REM  User Configurations
SET DirSavePresets=.\Presets
REM  Stand-alone scripts
SET DirSubScripts=.\Scripts
REM  Documentation
SET DirDocuments=.\Documents
REM  Core Compatible scripts [Designed to work with this program]
SET DirProjects=.\Projects
REM  Preset Configuration Name
SET UserConfigurationLoaded=coreDefault
REM  Preset Configuration Unique Key Chain Token
REM    When the user saves a configuration, they will gain a new token number - which should remain unique to the user.  The token number is what is going to be the filename for all of the modules that the user executes with this program.
SET UserConfigurationKeyChainToken=0
REM  Is the OS compatible with this program?
SET IncompatibleOS=False
REM  Toggle ECHO mode; view all of the code in Real Time
SET DebugMode=False
REM Detection identifiers
SET Detect_SVN=False
SET Detect_Git=False
SET Detect_7Zip=False
SET Detect_InnoSetup=False
SET Detect_MinGW=False
SET Detect_MSHTMLWorkShop=False
SET Detect_MSVS120COMMTOOLS=False
SET Detect_MSVS110COMMTOOLS=False
SET Detect_MSVS100COMMTOOLS=False
SET Detect_MSVS90COMMTOOLS=False
SET Detect_MSVS80COMMTOOLS=False
SET Detect_MicrosoftVisualStudio=False
SET Detect_dotNET1=False
SET Detect_dotNET1.1=False
SET Detect_dotNET2=False
SET Detect_dotNET2-64=False
SET Detect_dotNET3=False
SET Detect_dotNET3-64=False
SET Detect_dotNET3.5=False
SET Detect_dotNET3.5-64=False
SET Detect_dotNET4=False
SET Detect_dotNET4-64=False
REM NOTE: Robocopy was never included into Windows [officially] until Vista [6.0]; Windows XP [5.1] and earlier never had Robocopy.
SET Detect_Robocopy=False
SET Detect_Python3=False
SET Detect_Python2=False
GOTO :EOF



REM # =============================================================================================
REM # Documentation: This function houses settings that are to be part of the environment.
REM # =============================================================================================
:EnvironmentSetup_TerminalUpdates
TITLE %core.Title%
GOTO :EOF



REM # =============================================================================================
REM # Parameters: [{string} Mode]
REM # Documentation: This function houses the users configuration.  This function also has multiple purposes within the user declaration field.
REM # Parameter details:
REM # 0 = Set the default Value
REM # 1 = Save the information into a preset configuration.
REM # 2 = Display the value on the terminal screen.
REM # =============================================================================================
:EnvironmentSetup_UserSettings
REM Dashboard Viewer Functionality
IF %1 EQU 0 SET DashboardViewerTool=True
IF %1 EQU 1 (ECHO REM When true, this will allow the Dashboard Viewer tool to be displayed in the program.)>> "%~2"
IF %1 EQU 1 (ECHO SET DashboardViewerTool=%DashboardViewerTool%)>> "%~2"
IF %1 EQU 2 ECHO DashboardViewerTool -^> %DashboardViewerTool%
REM ----
REM Open Windows File Manager and perform simple tasks [highlight an object, for example]
IF %1 EQU 0 SET CallExplorerCommands=True
IF %1 EQU 1 (ECHO REM When true, this will allow modules to call Windows Explorer.  This can allow modules to open windows and highlight objects within the desktop environment.)>> "%~2"
IF %1 EQU 1 (ECHO SET CallExplorerCommands=%CallExplorerCommands%)>> "%~2"
IF %1 EQU 2 ECHO CallExplorerCommands -^> %CallExplorerCommands%
REM ----
REM Default duplicating software
IF %1 EQU 0 SET CopyMethod=XCOPY
IF %1 EQU 1 (ECHO REM Default copying software to use within the program and modules.)>> "%~2"
IF %1 EQU 1 (ECHO SET CopyMethod=%CopyMethod%)>> "%~2"
IF %1 EQU 2 ECHO CopyMethod -^> %CopyMethod%
REM ----
REM XCOPY Argument Set
IF %1 EQU 0 SET XCopyArg=/V /C /Y /Z
IF %1 EQU 1 (ECHO REM XCopy's parameters.)>> "%~2"
IF %1 EQU 1 (ECHO SET XCopyArg=%XCopyArg%)>> "%~2"
IF %1 EQU 2 ECHO XCopyArg -^> %XCopyArg%
REM ----
REM XCopy Switch: Verify
IF %1 EQU 0 SET ParametersXCopy.Verify=True
IF %1 EQU 1 (ECHO REM Batch External Command XCopy; Switch: Verify)>> "%~2"
IF %1 EQU 1 (ECHO SET ParametersXCopy.Verify=%ParametersXCopy.Verify%)>> "%~2"
IF %1 EQU 2 ECHO ParametersXCopy.Verify -^> %ParametersXCopy.Verify%
REM ----
REM XCopy Switch: Continue operation regardless of errors
IF %1 EQU 0 SET ParametersXCopy.Continue=True
IF %1 EQU 1 (ECHO REM Batch External Command XCopy; Switch: Continue even with errors)>> "%~2"
IF %1 EQU 1 (ECHO SET ParametersXCopy.Continue=%ParametersXCopy.Continue%)>> "%~2"
IF %1 EQU 2 ECHO ParametersXCopy.Continue -^> %ParametersXCopy.Continue%
REM ----
REM XCopy Switch: Encrypt files to destination even if destination does not support it
IF %1 EQU 0 SET ParametersXCopy.Encrypt=False
IF %1 EQU 1 (ECHO REM Batch External Command XCopy; Switch: Encrypt files to destination)>> "%~2"
IF %1 EQU 1 (ECHO SET ParametersXCopy.Encrypt=%ParametersXCopy.Encrypt%)>> "%~2"
IF %1 EQU 2 ECHO ParametersXCopy.Encrypt -^> %ParametersXCopy.Encrypt%
REM ----
REM XCopy Switch: Suppress warning messages
IF %1 EQU 0 SET ParametersXCopy.Suppress=True
IF %1 EQU 1 (ECHO REM Batch External Command XCopy; Suppress warning messages)>> "%~2"
IF %1 EQU 1 (ECHO SET ParametersXCopy.Suppress=%ParametersXCopy.Suppress%)>> "%~2"
IF %1 EQU 2 ECHO ParametersXCopy.Suppress -^> %ParametersXCopy.Suppress%
REM ----
REM XCopy Switch: Network Restartable Mode
IF %1 EQU 0 SET ParametersXCopy.Restart=True
IF %1 EQU 1 (ECHO REM Batch External Command XCopy; Switch: Network Restartable Mode)>> "%~2"
IF %1 EQU 1 (ECHO SET ParametersXCopy.Restart=%ParametersXCopy.Restart%)>> "%~2"
IF %1 EQU 2 ECHO ParametersXCopy.Restart -^> %ParametersXCopy.Restart%
REM ----
REM Robocopy Switch: Network Restart Mode (Backup Mode if failure)
IF %1 EQU 0 SET ParametersRobocopy.RestartBackup=True
IF %1 EQU 1 (ECHO REM Batch External Command Robocopy; Switch: Network Restart Mode - Backup Mode if Permission Failure)>> "%~2"
IF %1 EQU 1 (ECHO SET ParametersRobocopy.RestartBackup=%ParametersRobocopy.RestartBackup%)>> "%~2"
IF %1 EQU 2 ECHO ParametersRobocopy.RestartBackup -^> %ParametersRobocopy.RestartBackup%
REM ----
REM Robocopy Switch: Restrict Deep Paths
IF %1 EQU 0 SET ParametersRobocopy.RestrictDeepPaths=False
IF %1 EQU 1 (ECHO REM Batch External Command Robocopy; Switch: Restrict Deep Paths)>> "%~2"
IF %1 EQU 1 (ECHO SET ParametersRobocopy.RestrictDeepPaths=%ParametersRobocopy.RestrictDeepPaths%)>> "%~2"
IF %1 EQU 2 ECHO ParametersRobocopy.RestrictDeepPaths -^> %ParametersRobocopy.RestrictDeepPaths%
REM ----
REM Robocopy Switch: No Junction Pointers
IF %1 EQU 0 SET ParametersRobocopy.NoJunctionPoints=True
IF %1 EQU 1 (ECHO REM Batch External Command Robocopy; Switch: No Junction Pointers)>> "%~2"
IF %1 EQU 1 (ECHO SET ParametersRobocopy.NoJunctionPoints=%ParametersRobocopy.NoJunctionPoints%)>> "%~2"
IF %1 EQU 2 ECHO ParametersRobocopy.NoJunctionPoints -^> %ParametersRobocopy.NoJunctionPoints%
REM ----
REM Robocopy Switch: Display Full Path Location
IF %1 EQU 0 SET ParametersRobocopy.FullPath=True
IF %1 EQU 1 (ECHO REM Batch External Command Robocopy; Switch: Display Full Path Location)>> "%~2"
IF %1 EQU 1 (ECHO SET ParametersRobocopy.FullPath=%ParametersRobocopy.FullPath%)>> "%~2"
IF %1 EQU 2 ECHO ParametersRobocopy.FullPath -^> %ParametersRobocopy.FullPath%
REM ----
REM Robocopy Switch: Verbose Mode
IF %1 EQU 0 SET ParametersRobocopy.Verbose=True
IF %1 EQU 1 (ECHO REM Batch External Command Robocopy; Switch: Verbose Mode)>> "%~2"
IF %1 EQU 1 (ECHO SET ParametersRobocopy.Verbose=%ParametersRobocopy.Verbose%)>> "%~2"
IF %1 EQU 2 ECHO ParametersRobocopy.Verbose -^> %ParametersRobocopy.Verbose%
REM ----
REM Robocopy Switch: Display File Sizes in Bytes
IF %1 EQU 0 SET ParametersRobocopy.BytesFileSize=False
IF %1 EQU 1 (ECHO REM Batch External Command Robocopy; Switch: Show File Size in Bytes)>> "%~2"
IF %1 EQU 1 (ECHO SET ParametersRobocopy.BytesFileSize=%ParametersRobocopy.BytesFileSize%)>> "%~2"
IF %1 EQU 2 ECHO ParametersRobocopy.BytesFileSize -^> %ParametersRobocopy.BytesFileSize%
REM ----
REM Robocopy Switch: Do Not Display Progress
IF %1 EQU 0 SET ParametersRobocopy.NoProgress=False
IF %1 EQU 1 (ECHO REM Batch External Command Robocopy; Switch: Do Not Display Progress)>> "%~2"
IF %1 EQU 1 (ECHO SET ParametersRobocopy.NoProgress=%ParametersRobocopy.NoProgress%)>> "%~2"
IF %1 EQU 2 ECHO ParametersRobocopy.NoProgress -^> %ParametersRobocopy.NoProgress%
REM ----
REM Robocopy Switch: Display Estimated Time of Arrival
IF %1 EQU 0 SET ParametersRobocopy.ETA=True
IF %1 EQU 1 (ECHO REM Batch External Command Robocopy; Switch: Display Estimated Time of Arrival)>> "%~2"
IF %1 EQU 1 (ECHO SET ParametersRobocopy.ETA=%ParametersRobocopy.ETA%)>> "%~2"
IF %1 EQU 2 ECHO ParametersRobocopy.ETA -^> %ParametersRobocopy.ETA%
REM ----
REM Robocopy Switch: Maximum Retries
IF %1 EQU 0 SET ParametersRobocopy.Retry=20
IF %1 EQU 1 (ECHO REM Batch External Command Robocopy; Switch: Max Retries)>> "%~2"
IF %1 EQU 1 (ECHO SET ParametersRobocopy.Retry=%ParametersRobocopy.Retry%)>> "%~2"
IF %1 EQU 2 ECHO ParametersRobocopy.Retry -^> %ParametersRobocopy.Retry%
REM ----
REM Robocopy Switch: Maximum Wait Time
IF %1 EQU 0 SET ParametersRobocopy.Wait=30
IF %1 EQU 1 (ECHO REM Batch External Command Robocopy; Switch: Maximum Wait Time)>> "%~2"
IF %1 EQU 1 (ECHO SET ParametersRobocopy.Wait=%ParametersRobocopy.Wait%)>> "%~2"
IF %1 EQU 2 ECHO ParametersRobocopy.Wait -^> %ParametersRobocopy.Wait%
REM ----
REM Robocopy Switch: Multithreading
IF %1 EQU 0 SET ParametersRobocopy.Multithread=2
IF %1 EQU 1 (ECHO REM Batch External Command Robocopy; Switch: Multithreading)>> "%~2"
IF %1 EQU 1 (ECHO SET ParametersRobocopy.Multithread=%ParametersRobocopy.Multithread%)>> "%~2"
IF %1 EQU 2 ECHO ParametersRobocopy.Multithread -^> %ParametersRobocopy.Multithread%
REM ----
REM Robocopy Argument Set
IF %1 EQU 0 SET RoboCopyArg=/ZB /XD /FP /V /BYTES /ETA /R:%ParametersRobocopy.Retry% /W:%ParametersRobocopy.Wait% /MT:%ParametersRobocopy.Multithread%
IF %1 EQU 1 (ECHO REM ROBOCOPY's paramenters.)>> "%~2"
IF %1 EQU 1 (ECHO SET RoboCopyArg=%RoboCopyArg%)>> "%~2"
IF %1 EQU 2 ECHO RoboCopyArg -^> %RoboCopyArg%
REM ----
REM IntCMD Copy Argument Set Compiled
IF %1 EQU 0 SET CopyIntCMDArg=/V /Y /Z
IF %1 EQU 1 (ECHO REM Batch Internal Command - Copy's parameters [compiled].)>> "%~2"
IF %1 EQU 1 (ECHO SET CopyIntCMDArg=%CopyIntCMDArg%)>> "%~2"
IF %1 EQU 2 ECHO CopyIntCMDArg -^> %CopyIntCMDArg%
REM ----
REM IntCMD Copy Switch: Decrypt
IF %1 EQU 0 SET ParametersCopy.Decrypt=False
IF %1 EQU 1 (ECHO REM Batch Internal Command Copy; Switch: Decrypt)>> "%~2"
IF %1 EQU 1 (ECHO SET ParametersCopy.Decrypt=%ParametersCopy.Decrypt%)>> "%~2"
IF %1 EQU 2 ECHO ParametersCopy.Decrypt -^> %ParametersCopy.Decrypt%
REM ----
REM IntCMD Copy Switch: Verify
IF %1 EQU 0 SET ParametersCopy.Verify=True
IF %1 EQU 1 (ECHO REM Batch Internal Command Copy; Switch: Verify)>> "%~2"
IF %1 EQU 1 (ECHO SET ParametersCopy.Verify=%ParametersCopy.Verify%)>> "%~2"
IF %1 EQU 2 ECHO ParametersCopy.Verify -^> %ParametersCopy.Verify%
REM ----
REM IntCMD Copy Switch: Suppress Overwrite Prompts
IF %1 EQU 0 SET ParametersCopy.Suppress=True
IF %1 EQU 1 (ECHO REM Batch Internal Command Copy; Switch: Suppress)>> "%~2"
IF %1 EQU 1 (ECHO SET ParametersCopy.Suppress=%ParametersCopy.Suppress%)>> "%~2"
IF %1 EQU 2 ECHO ParametersCopy.Suppress -^> %ParametersCopy.Suppress%
REM ----
REM IntCMD Copy Switch: Network Restart Mode
IF %1 EQU 0 SET ParametersCopy.Restart=True
IF %1 EQU 1 (ECHO REM Batch Internal Command Copy; Switch: Network Restart Mode)>> "%~2"
IF %1 EQU 1 (ECHO SET ParametersCopy.Restart=%ParametersCopy.Restart%)>> "%~2"
IF %1 EQU 2 ECHO ParametersCopy.Restart -^> %ParametersCopy.Restart%
REM ----
REM Default Copying duplicating software parameter set.
IF %1 EQU 0 SET CopyArg=%XCopyArg%
IF %1 EQU 1 (ECHO REM Default parameters that should be used when calling the default copying software.)>> "%~2"
IF %1 EQU 1 (ECHO SET CopyArg=%CopyArg%)>> "%~2"
IF %1 EQU 2 ECHO CopyArg -^> %CopyArg%
REM ----
REM Default arguments to be used with MSBuild
IF %1 EQU 0 SET "MSVSArg=/t:Rebuild /p:Configuration=Release;Platform=x86 /v:quiet"
IF %1 EQU 1 (ECHO REM Parameters to be used when using MSBuild from Microsoft Visual Studio packages.)>> "%~2"
IF %1 EQU 1 (ECHO SET "MSVSArg=%MSVSArg%")>> "%~2"
IF %1 EQU 2 ECHO MSVSArg -^> %MSVSArg%
REM ----
REM Default arguments to be used with VCUpgrade
IF %1 EQU 0 SET "MSVSArgVPO=/p:Configuration=Release;Platform=Win32 /v:quiet"
IF %1 EQU 1 (ECHO REM Parameters to be used when using VCUpgrade from Microsoft Visual Studio packages.)>> "%~2"
IF %1 EQU 1 (ECHO SET "MSVSArgVPO=%MSVSArgVPO%")>> "%~2"
IF %1 EQU 2 ECHO MSVSArgVPO -^> %MSVSArgVPO%
REM ----
REM Module logging
IF %1 EQU 0 SET ToggleLog=False
IF %1 EQU 1 (ECHO REM When true, this will allow modules to log their activity or progress to a logfile.)>> "%~2"
IF %1 EQU 1 (ECHO SET ToggleLog=%ToggleLog%)>> "%~2"
IF %1 EQU 2 ECHO ToggleLog -^> %ToggleLog%
REM ----
REM Logfile Name [NUL == NULL]
IF %1 EQU 0 SET STDOUT=NUL
IF %1 EQU 1 (ECHO REM Logfile name)>> "%~2"
IF %1 EQU 1 (ECHO SET STDOUT=%STDOUT%)>> "%~2"
IF %1 EQU 2 ECHO STDOUT -^> %STDOUT%
REM ----
REM Terminal Alarm [BELL]
REM {0=Disable|1=One beep compile & Two beeps for errors|2=Two beeps for errors only}
IF %1 EQU 0 SET UseBell=1
IF %1 EQU 1 (ECHO REM Terminal Alarm or Bell.)>> "%~2"
IF %1 EQU 1 (ECHO SET UseBell=%UseBell%)>> "%~2"
IF %1 EQU 2 ECHO UseBell -^> %UseBell%
REM ----
REM Microsoft's 'Help' compiling tool.
IF %1 EQU 0 CALL :EnvironmentSetup_FindDefault_HTMLWorkshop
IF %1 EQU 1 (ECHO REM Directory path to Microsoft's HTML Workshop software.  Do NOT include the extension, the software itself dislikes that....)>> "%~2"
IF %1 EQU 1 (ECHO SET "PathMSHTMLWorkShop=%PathMSHTMLWorkShop%")>> "%~2"
IF %1 EQU 2 ECHO PathMSHTMLWorkShop -^> %PathMSHTMLWorkShop%
IF "%~1" EQU "HTML Workshop" CALL :EnvironmentSetup_FindDefault_HTMLWorkshop
REM ----
REM General Kernel request Priority.
IF %1 EQU 0 SET PriorityGeneral=Normal
IF %1 EQU 1 (ECHO REM General priority for operations.  When the priority is higher, the system may become unstable or will have performance issues)>> "%~2"
IF %1 EQU 1 (ECHO SET PriorityGeneral=%PriorityGeneral%)>> "%~2"
IF %1 EQU 2 ECHO PriorityGeneral -^> %PriorityGeneral%
REM ----
REM Here, we are looking for 'common tools' that is included with Visual Studio 2005.
IF %1 EQU 0 SET "PathMSVS2005=%VS80COMNTOOLS%"
IF %1 EQU 1 (ECHO REM Directory path to: Microsoft Visual Studio 2005' VSVars32.bat)>> "%~2"
IF %1 EQU 1 (ECHO SET "PathMSVS2005=%PathMSVS2005%")>> "%~2"
IF %1 EQU 2 ECHO PathMSVS2005 -^> %PathMSVS2005%
IF %1 EQU "Visual Studio 2005" SET "PathMSVS2005=%VS80COMNTOOLS%"
REM ----
REM Here, we are looking for 'common tools' that is included with Visual Studio 2008.
IF %1 EQU 0 SET "PathMSVS2008=%VS90COMNTOOLS%"
IF %1 EQU 1 (ECHO REM Directory path to: Microsoft Visual Studio 2008' VSVars32.bat)>> "%~2"
IF %1 EQU 1 (ECHO SET "PathMSVS2008=%PathMSVS2008%")>> "%~2"
IF %1 EQU 2 ECHO PathMSVS2008 -^> %PathMSVS2008%
IF %1 EQU "Visual Studio 2008" SET "PathMSVS2008=%VS90COMNTOOLS%"
REM ----
REM Here, we are looking for 'common tools' that is included with Visual Studio 2010.
IF %1 EQU 0 SET "PathMSVS2010=%VS100COMNTOOLS%"
IF %1 EQU 1 (ECHO REM Directory path to: Microsoft Visual Studio 2010' VSVars32.bat)>> "%~2"
IF %1 EQU 1 (ECHO SET "PathMSVS2010=%PathMSVS2010%")>> "%~2"
IF %1 EQU 2 ECHO PathMSVS2010 -^> %PathMSVS2010%
IF %1 EQU "Visual Studio 2010" SET "PathMSVS2010=%VS100COMNTOOLS%"
REM ----
REM Here, we are looking for 'common tools' that is included with Visual Studio 2012.
IF %1 EQU 0 SET "PathMSVS2012=%VS110COMNTOOLS%"
IF %1 EQU 1 (ECHO REM Directory path to: Microsoft Visual Studio 2012' VSVars32.bat)>> "%~2"
IF %1 EQU 1 (ECHO SET "PathMSVS2012=%PathMSVS2012%")>> "%~2"
IF %1 EQU 2 ECHO PathMSVS2012 -^> %PathMSVS2012%
IF %1 EQU "Visual Studio 2012" SET "PathMSVS2012=%VS110COMNTOOLS%"
REM ----
REM Here, we are looking for 'common tools' that is included with Visual Studio 2013.
IF %1 EQU 0 SET "PathMSVS2013=%VS120COMNTOOLS%"
IF %1 EQU 1 (ECHO REM Directory path to: Microsoft Visual Studio 2013' VSVars32.bat)>> "%~2"
IF %1 EQU 1 (ECHO SET "PathMSVS2013=%PathMSVS2013%")>> "%~2"
IF %1 EQU 2 ECHO PathMSVS2013 -^> %PathMSVS2013%
IF %1 EQU "Visual Studio 2013" SET "PathMSVS2013=%VS120COMNTOOLS%"
REM ----
REM MinGW path, for those that prefer or need MinGW support.
IF %1 EQU 0 SET "PathMinGW=.\MinGW\"
IF %1 EQU 1 (ECHO REM Directory path for MinGW)>> "%~2"
IF %1 EQU 1 (ECHO SET "PathMinGW=%PathMinGW%")>> "%~2"
IF %1 EQU 2 ECHO PathMinGW -^> %PathMinGW%
IF %1 EQU "MinGW" SET "PathMinGW=.\MinGW\"
REM ----
REM Inno Setup
IF %1 EQU 0 CALL :EnvironmentSetup_FindDefault_InnoSetup
IF %1 EQU 1 (ECHO REM Directory path to Inno Setup Builder)>> "%~2"
IF %1 EQU 1 (ECHO SET "PathInnoSetup=%PathInnoSetup%")>> "%~2"
IF %1 EQU 2 ECHO PathInnoSetup -^> %PathInnoSetup%
IF %1 EQU "Inno Installer" CALL :EnvironmentSetup_FindDefault_InnoSetup
REM ----
REM Python v3
IF %1 EQU 0 CALL :EnvironmentSetup_FindDefault_Python3
IF %1 EQU 1 (ECHO REM Directory path to Python v3)>> "%~2"
IF %1 EQU 1 (ECHO SET "PathPython3=%PathPython3%")>> "%~2"
IF %1 EQU 2 ECHO PathPython3 -^> %PathPython3%
IF %1 EQU "Python3" CALL :EnvironmentSetup_FindDefault_Python3
REM ----
REM Python v2.7
IF %1 EQU 0 CALL :EnvironmentSetup_FindDefault_Python2
IF %1 EQU 1 (ECHO REM Directory path to Python v2.7)>> "%~2"
IF %1 EQU 1 (ECHO SET "PathPython2=%PathPython2%")>> "%~2"
IF %1 EQU 2 ECHO PathPython2 -^> %PathPython2%
IF %1 EQU "Python2" CALL :EnvironmentSetup_FindDefault_Python2
REM ----
REM 7Zip
IF %1 EQU 0 CALL :EnvironmentSetup_FindDefault_7Zip
IF %1 EQU 1 (ECHO REM Directory path to 7zip)>> "%~2"
IF %1 EQU 1 (ECHO SET "Path7Zip=%Path7Zip%")>> "%~2"
IF %1 EQU 2 ECHO Path7Zip -^> %Path7Zip%
IF %1 EQU "Seven Zip" CALL :EnvironmentSetup_FindDefault_7Zip
REM ----
REM 7Zip Archive Password
IF %1 EQU 0 SET SevZipKey=
IF %1 EQU 1 (ECHO REM 7Zip: Archive password to use with 7zip. [NOT ENCRYPTED])>> "%~2"
IF %1 EQU 1 (ECHO SET SevZipKey=%SevZipKey%)>> "%~2"
IF %1 EQU 2 ECHO SevZipKey -^> %SevZipKey%
REM ----
REM 7Zip Archive Password Toggle
IF %1 EQU 0 SET SevZipUseKey=False
IF %1 EQU 1 (ECHO REM 7Zip: When true, this will allow 7Zip [if called] to enable the use of encrypting the archive file with a password.)>> "%~2"
IF %1 EQU 1 (ECHO SET SevZipUseKey=%SevZipUseKey%)>> "%~2"
IF %1 EQU 2 ECHO SevZipUseKey -^> %SevZipUseKey%
REM ----
REM 7Zip Archive Format
IF %1 EQU 0 SET SevZipArchiveFormat=7z
IF %1 EQU 1 (ECHO REM 7Zip: Archive format)>> "%~2"
IF %1 EQU 1 (ECHO SET SevZipArchiveFormat=%SevZipArchiveFormat%)>> "%~2"
IF %1 EQU 2 ECHO SevZipArchiveFormat -^> %SevZipArchiveFormat%
REM ----
REM 7Zip file extension
IF %1 EQU 0 SET SevZipFileExtension=7z
IF %1 EQU 1 (ECHO REM 7Zip: Archive filename extension)>> "%~2"
IF %1 EQU 1 (ECHO SET SevZipFileExtension=%SevZipFileExtension%)>> "%~2"
IF %1 EQU 2 ECHO SevZipFileExtension -^> %SevZipFileExtension%
REM ----
REM 7Zip Compression
IF %1 EQU 0 SET SevZipCompressionPass=5
IF %1 EQU 1 (ECHO REM 7Zip: Compression rate to be used when compacting the data.  Higher the compression rate, the slower it builds.)>> "%~2"
IF %1 EQU 1 (ECHO SET SevZipCompressionPass=%SevZipCompressionPass%) >> "%~2"
IF %1 EQU 2 ECHO SevZipCompressionPass -^> %SevZipCompressionPass%
REM ----
REM 7Zip Copy algorithm
IF %1 EQU 0 SET SevZipCopyFormat=Deflate
IF %1 EQU 1 (ECHO REM 7Zip: Copy Format)>> "%~2"
IF %1 EQU 1 (ECHO SET SevZipCopyFormat=%SevZipCopyFormat%)>> "%~2"
IF %1 EQU 2 ECHO SevZipCopyFormat -^> %SevZipCopyFormat%
REM ----
REM 7Zip CPU Multithreading
IF %1 EQU 0 CALL :EnvironmentSetup_CheckCPULogicalProcessors
IF %1 EQU 1 (ECHO REM 7Zip: When on, this will allow the 7Zip program to use more than one thread from the CPU, which will allow the program to finish expeditiously.  DO NOT enable this if the CPU one has one core and one thread!)>> "%~2"
IF %1 EQU 1 (ECHO SET SevZipMultiThreadingCPU=%SevZipMultiThreadingCPU%)>> "%~2"
IF %1 EQU 2 ECHO SevZipMultiThreadingCPU -^> %SevZipMultiThreadingCPU%
REM ----
REM 7Zip Encryption
IF %1 EQU 0 SET SevZipEncryptionAlgorithm=ZipCrypto
IF %1 EQU 1 (ECHO REM 7Zip: When password protecting the archive file, these algorithms will strengthen the encryption of the file.)>> "%~2"
IF %1 EQU 1 (ECHO SET SevZipEncryptionAlgorithm=%SevZipEncryptionAlgorithm%)>> "%~2"
IF %1 EQU 2 ECHO SevZipEncryptionAlgorithm -^> %SevZipEncryptionAlgorithm%
REM ----
REM 7Zip Testing
IF %1 EQU 0 SET SevZipVerify=True
IF %1 EQU 1 (ECHO REM 7Zip: When true, this will allow modules to verify the archive file contents to assure that everything was generated accurately.)>> "%~2"
IF %1 EQU 1 (ECHO SET SevZipVerify=%SevZipVerify%)>> "%~2"
IF %1 EQU 2 ECHO SevZipVerify -^> %SevZipVerify%
REM ----
REM Modules Execute in a shared window with the core.
IF %1 EQU 0 SET ModuleExecuteSharingWindow=True
IF %1 EQU 1 (ECHO REM When false, this will allow modules to be executed in their own window environment -- this allows multitasking.)>> "%~2"
IF %1 EQU 1 (ECHO SET ModuleExecuteSharingWindow=%ModuleExecuteSharingWindow%)>> "%~2"
IF %1 EQU 2 ECHO ModuleExecuteSharingWindow -^> %ModuleExecuteSharingWindow%
REM ----
REM Finished
GOTO :EOF



REM # =============================================================================================
REM # Documentation: Within this function, this will check wither the targets can be found within the filesystem.  If the target can not be found, simply change the target status to false.
REM # =============================================================================================
:EnvironmentSetup_DirectoryCheck
REM Visual Studio 2005
IF EXIST "%PathMSVS2005%" (
    SET Detect_MSVS80COMMTOOLS=True
    IF %Detect_MicrosoftVisualStudio% EQU False SET Detect_MicrosoftVisualStudio=True
) ELSE (
    SET Detect_MSVS80COMMTOOLS=False
)

REM Visual Studio 2008
IF EXIST "%PathMSVS2008%" (
    SET Detect_MSVS90COMMTOOLS=True
    IF %Detect_MicrosoftVisualStudio% EQU False SET Detect_MicrosoftVisualStudio=True
) ELSE (
    SET Detect_MSVS90COMMTOOLS=False
)

REM Visual Studio 2010
IF EXIST "%PathMSVS2010%" (
    SET Detect_MSVS100COMMTOOLS=True
    IF %Detect_MicrosoftVisualStudio% EQU False SET Detect_MicrosoftVisualStudio=True
) ELSE (
    SET Detect_MSVS100COMMTOOLS=False
)

REM Visual Studio 2012
IF EXIST "%PathMSVS2012%" (
    SET Detect_MSVS110COMMTOOLS=True
    IF %Detect_MicrosoftVisualStudio% EQU False SET Detect_MicrosoftVisualStudio=True
) ELSE (
    SET Detect_MSVS110COMMTOOLS=False
)

REM Visual Studio 2013
IF EXIST "%PathMSVS2013%" (
    SET Detect_MSVS120COMMTOOLS=True
    IF %Detect_MicrosoftVisualStudio% EQU False SET Detect_MicrosoftVisualStudio=True
) ELSE (
    SET Detect_MSVS120COMMTOOLS=False
)

REM Microsoft HTML Workshop
IF EXIST "%PathMSHTMLWorkShop%.exe" (
    SET Detect_MSHTMLWorkShop=True
) ELSE (
    SET Detect_MSHTMLWorkShop=False
)

REM MinGW
IF EXIST "%PathMinGW%" (
    SET Detect_MinGW=True
) ELSE (
    SET Detect_MinGW=False
)

REM Inno Setup
IF EXIST "%PathInnoSetup%" (
    SET Detect_InnoSetup=True
) ELSE (
    SET Detect_InnoSetup=False
)

REM 7Zip
IF EXIST "%Path7Zip%" (
    SET Detect_7Zip=True
) ELSE (
    SET Detect_7Zip=False
)

REM This is treated differently as it could be invoked while in %PATH%
REM Python v3
IF %Detect_Python3% EQU False (
    IF EXIST "%PathPython3%" SET Detect_Python3=True
)

REM Python v2
IF EXIST "%PathPython2%" (
    SET Detect_Python2=True
) ELSE (
    SET Detect_Python2=False
)

REM SVN
REM Besides checking the filesystem, just do an invoke check.
SVN 2> NUL 1> NUL
IF %ERRORLEVEL% EQU 1 (
    SET Detect_SVN=True
) ELSE (
    SET Detect_SVN=False
)

REM Git
REM Besides checking the filesystem, just do an invoke check.
GIT 2> NUL 1> NUL
IF %ERRORLEVEL% EQU 1 (
    SET Detect_Git=True
) ELSE (
    SET Detect_Git=False
)



REM Robocopy
REM Besides checking the filesystem, just do an invoke check.
REM   Robocopy was never officially added into Windows until Windows Vista and later.
REM   To avoid conflicts with Windows XP and Windows 2000 users, run a check.
ROBOCOPY 2> NUL 1> NUL
IF %ERRORLEVEL% EQU 16 (
    SET Detect_Robocopy=True
) ELSE (
    SET Detect_Robocopy=False
)
REM Finished
REM ----
GOTO :EOF



REM # =============================================================================================
REM # Documentation: Try to automatically detect the HTML Workshop software.
REM # =============================================================================================
:EnvironmentSetup_FindDefault_HTMLWorkshop
IF EXIST "%ProgramFiles%\HTML Help Workshop\hhc.exe" (
    SET "PathMSHTMLWorkShop=%ProgramFiles%\HTML Help Workshop\hhc"
) ELSE (
    SET "PathMSHTMLWorkShop=%ProgramFiles(x86)%\HTML Help Workshop\hhc"
)
GOTO :EOF



REM # =============================================================================================
REM # Documentation: Try to automatically detect the 7Zip software.
REM # =============================================================================================
:EnvironmentSetup_FindDefault_7Zip
IF EXIST "%ProgramFiles%\7-Zip\7z.exe" (
    SET "Path7Zip=%ProgramFiles%\7-Zip\7z.exe"
) ELSE (
    SET "Path7Zip=%ProgramFiles(x86)%\7-Zip\7z.exe"
)
GOTO :EOF



REM # =============================================================================================
REM # Documentation: Try to automatically detect the Inno Setup software.
REM # =============================================================================================
:EnvironmentSetup_FindDefault_InnoSetup
IF EXIST %programfiles%\Inno Setup 5\iscc.exe (
    SET "PathInnoSetup=%programfiles%\Inno Setup 5\iscc.exe"
) ELSE (
    SET "PathInnoSetup=%programfiles(x86)%\Inno Setup 5\iscc.exe"
)
GOTO :EOF



REM # =============================================================================================
REM # Documentation: Try to automatically detect Python version 3.x
REM # =============================================================================================
:EnvironmentSetup_FindDefault_Python3
REM If incase the user allowed Python (or did it themselves) to be included in $PATH.
py --help 2> NUL 1> NUL
IF %ERRORLEVEL% EQU 0 (
    SET PathPython3=py
    SET Detect_Python3=True
) ELSE (
    SET "PathPython3=%SYSTEMDRIVE%\Python33\python.exe"
)
GOTO :EOF



REM # =============================================================================================
REM # Documentation: Try to automatically detect Python version 2.7.x
REM # =============================================================================================
:EnvironmentSetup_FindDefault_Python2
IF EXIST "%SYSTEMDRIVE%\Python27\python.exe" (
    SET Detect_Python2=True
)
SET "PathPython2=%SYSTEMDRIVE%\Python27\python.exe"
GOTO :EOF



REM # =============================================================================================
REM # Documentation: Try to automatically detect all of the .NET framework foundation software.
REM # =============================================================================================
:EnvironmentSetup_Find_dotNETFoundations
REM Check to see if the user has the specified .NET foundations installed within the system
REM ----
REM .NET Framework v1
IF EXIST "%WINDIR%\Microsoft.NET\Framework\v1.0.3705" SET Detect_dotNET1=True
REM ----
REM .NET Framework v1.1
IF EXIST "%WINDIR%\Microsoft.NET\Framework\v1.1.4322" SET Detect_dotNET1.1=True
REM ----
REM .NET Framework v2
IF EXIST "%WINDIR%\Microsoft.NET\Framework\v2.0.50727" SET Detect_dotNET2=True
IF EXIST "%WINDIR%\Microsoft.NET\Framework64\v2.0.50727" SET Detect_dotNET2-64=True
REM ----
REM .NET Framework v3
IF EXIST "%WINDIR%\Microsoft.NET\Framework\v3.0" SET Detect_dotNET3=True
IF EXIST "%WINDIR%\Microsoft.NET\Framework64\v3.0" SET Detect_dotNET3-64=True
REM ----
REM .NET Framework v3.5
IF EXIST "%WINDIR%\Microsoft.NET\Framework\v3.5" SET Detect_dotNET3.5=True
IF EXIST "%WINDIR%\Microsoft.NET\Framework64\v3.5" SET Detect_dotNET3.5-64=True
REM ----
REM .NET Framework v4
IF EXIST "%WINDIR%\Microsoft.NET\Framework\v4.0.30319" SET Detect_dotNET4=True
IF EXIST "%WINDIR%\Microsoft.NET\Framework64\v4.0.30319" SET Detect_dotNET4-64=True
GOTO :EOF



REM # =============================================================================================
REM # Documentation: Determine wither or not the program is executed with administrative access
REM # =============================================================================================
:EnvironmentSetup_CheckEnvironmentPrivileges
REM This merely checks if the program has enough privileges to access a certain directory.
"%SYSTEMROOT%\System32\icacls.exe" "%SYSTEMROOT%\System32\Config\System" > NUL 2>&1
IF %ERRORLEVEL% NEQ 0 (
    REM Executed without Root access
    SET Detect_RootAccess=False
) ELSE (
    REM Executed with Root access
    SET Detect_RootAccess=True
)
GOTO :EOF



REM # =============================================================================================
REM # Documentation: Filter the date and time and store their filtered value into variables.  This will allow other programs to use date and time as filenames.
REM # NOTE: It seems that the 'DATE' will contain the 'Weekday' if the Region Format is set as English.  All other regions does not contain the weekday string.
REM #           For example, German will only contain DD.MM.YY, while United States English will contain: DDD MM/DD/YY.
REM #           While yes, all formatting is user region setting dependent, the weekday is added regardless - so long as the region format is set as 'English'.
REM # =============================================================================================
:EnvironmentSetup_Setup_Time-and-Date
REM These are special statements that are used to clean up the date string so that information can be used within the filesystem as a file or directory.
REM Date
FOR /F "tokens=2-4 delims=/. " %%a IN ("%DATE%") DO SET "core.Date=%%a_%%b_%%c"
REM Time
FOR /F "tokens=1-3 delims=:.," %%a IN ("%TIME%") DO SET "core.Time=%%a-%%b-%%c"
GOTO :EOF



REM # =============================================================================================
REM # Documentation: This function clears out sensitive identifiers from the program.  As Batch does not clear out the identifiers after the program has been terminated, this function will house variables that need to be cleared out before the session ends.
REM # =============================================================================================
:EnvironmentSetup_UninitializeVars
REM 7Zip key
SET SevZipKey=
GOTO :EOF



REM # =============================================================================================
REM # Documentation: This function will check to see how many logical cores the host system has available.  This function is dedicated for 7Zip program, Multithreading functionality.  If the host system does NOT have any multithreading capabilities available, this program will disable the multithreading functionality when 7Zip is being called.
REM # =============================================================================================
:EnvironmentSetup_CheckCPULogicalProcessors
IF %Number_Of_Processors% EQU 0 (
    SET SevZipMultiThreadingCPU=off
) ELSE (
    SET SevZipMultiThreadingCPU=on
)
GOTO :EOF




REM =====================================================================
REM Main Menu
REM ----------------------------
REM The main menu and the main navigation central point of the program.
REM =====================================================================


REM # =============================================================================================
REM # Documentation: Display the main menu screen.
REM # =============================================================================================
:MainScreen
CALL :DashboardDisplay
ECHO Main Menu
ECHO.
ECHO Select the following options:
ECHO %Separator%
ECHO [1] Run Project Modules
ECHO [2] Run External Scripts
ECHO [3] User Configuration
ECHO [4] Documentation
ECHO.
ECHO Other Options
ECHO %SeparatorSmall%
ECHO [S] Settings
ECHO [U] Check for Updates
ECHO [R] Restart Program
ECHO [X] Exit
REM Allow the user to input their request into the program.
CALL :UserInput
REM Inspect their input.
GOTO :MainScreen_UserInput



REM # =============================================================================================
REM # Documentation: Inspect the user's input.
REM # =============================================================================================
:MainScreen_UserInput
REM Read the STDIN and process it
IF "%STDIN%" EQU "1" GOTO :MainScreen_ChoiceRunProjectModule
IF "%STDIN%" EQU "2" GOTO :MainScreen_ChoiceRunExternalScript
IF "%STDIN%" EQU "3" GOTO :MainScreen_ChoiceUserConfiguration
IF "%STDIN%" EQU "4" GOTO :MainScreen_ChoiceDocumentation
IF /I "%STDIN%" EQU "S" GOTO :MainScreen_ChoiceSettings
IF /I "%STDIN%" EQU "U" GOTO :MainScreen_ChoiceUpdates
IF /I "%STDIN%" EQU "R" GOTO :MainScreen_ChoiceRestartProgram
IF /I "%STDIN%" EQU "Restart" GOTO :MainScreen_ChoiceRestartProgram
IF /I "%STDIN%" EQU "X" GOTO :MainScreen_ChoiceExit
IF /I "%STDIN%" EQU "Exit" GOTO :MainScreen_ChoiceExit
IF /I "%STDIN%" EQU "Quit" GOTO :MainScreen_ChoiceExit
CALL :BadInput& GOTO :MainScreen



REM # =============================================================================================
REM # Documentation: This function calls a feature that allows the user to launch scripts that is compatible with the core's environment.
REM # =============================================================================================
:MainScreen_ChoiceRunProjectModule
REM Compile projects
CALL :ClearBuffer 1
CALL :ProjectLoader
CALL :ClearBuffer 1
GOTO :MainScreen



REM # =============================================================================================
REM # Documentation: This function calls the external module and script feature -- these are not core compatible scripts.
REM # =============================================================================================
:MainScreen_ChoiceRunExternalScript
CALL :ClearBuffer 1
CALL :LoadExtScripts
CALL :ClearBuffer 1
GOTO :MainScreen



REM # =============================================================================================
REM # Documentation: Allow the user to manage their own personal saved preset configuration files.
REM # =============================================================================================
:MainScreen_ChoiceUserConfiguration
CALL :ClearBuffer 1
CALL :UserConfiguration
CALL :ClearBuffer 1
GOTO :MainScreen



REM # =============================================================================================
REM # Documentation: Call the Document Viewer tool.
REM # =============================================================================================
:MainScreen_ChoiceDocumentation
CALL :ClearBuffer 1
CALL :Documents
CALL :ClearBuffer 1
GOTO :MainScreen



REM # =============================================================================================
REM # Documentation: Allow the user to make adjustments within the program.
REM # =============================================================================================
:MainScreen_ChoiceSettings
CALL :ClearBuffer 1
CALL :ControlPanel
CALL :ClearBuffer 1
GOTO :MainScreen



REM # =============================================================================================
REM # Documentation: Allows the user to check for program updates; requires an internet connection!
REM # =============================================================================================
:MainScreen_ChoiceUpdates
CALL :ClearBuffer 1
CALL :Updates
CALL :ClearBuffer 1
GOTO :MainScreen



REM # =============================================================================================
REM # Documentation: Restart the program or specifically - refresh the environment variables.
REM # =============================================================================================
:MainScreen_ChoiceRestartProgram
CALL :ClearBuffer 1
CALL :EnvironmentSetup_Switch Restart
CALL :ClearBuffer 1
GOTO :MainScreen



REM # =============================================================================================
REM # Documentation: Terminate the program.
REM # =============================================================================================
:MainScreen_ChoiceExit
CALL :ClearBuffer 1
CALL :KillPrompt
CALL :ClearBuffer 1
GOTO :MainScreen




REM =====================================================================
REM Document Viewer
REM ----------------------------
REM Document Viewer allows the user to open simple text files that is located in the documents directory [ "%DirDocuments%" variable ] and display the contents right in the terminal.
REM This feature by itself is limited and most likely is least used, but it is here for those that may need it.
REM =====================================================================


REM # =============================================================================================
REM # Documentation: This function checks to make sure that the document directory exists.  If the directory does not exist, then simply create it in the filesystem.
REM # =============================================================================================
:DocumentsDirectoryInspect
IF NOT EXIST "%DirDocuments%" MKDIR "%DirDocuments%" || ECHO !ERR_CRIT!: Could not create directory [ %DirDocuments% ] within the local filesystem!
GOTO :EOF



REM # =============================================================================================
REM # Documentation: This function will scan the documents directory and output all of the contents that end with '.txt' as the _whole_ filename.
REM # =============================================================================================
:DocumentsDirectoryViewer
DIR /B "%DirDocuments%" | FINDSTR /E /I ".txt" || ECHO !ERR: Could not find the directory!&
GOTO :EOF



REM # =============================================================================================
REM # Parameters: [{String} ASCIIFile]
REM # Documentation: Display the text file that the user requested.
REM # =============================================================================================
:DocumentViewer_Reader
MORE /E "%~1"
GOTO :EOF



REM # =============================================================================================
REM # Documentation: This function displays the document viewer menu.  This will also do a preview of what files where found within the document directory.
REM # =============================================================================================
:Documents
CALL :DashboardDisplay
CALL :DocumentsDirectoryInspect
ECHO Documents Folder
ECHO.
ECHO Document Directory: %DirDocuments%
ECHO %SeparatorLong%
REM Display a preview of what files were found within the document directory.
CALL :DocumentsDirectoryViewer
ECHO %SeparatorLong%
ECHO.&ECHO.
ECHO Other Options:
ECHO %SeparatorSmall%
ECHO [R] Refresh the list
ECHO [X] Cancel
ECHO %Separator%
ECHO.
ECHO Enter a document filename:
CALL :UserInput
GOTO :Documents_UserInput



REM # =============================================================================================
REM # Documentation: Inspect the user's input and determine wither the document exists or if the user chooses another option.
REM # =============================================================================================
:Documents_UserInput
IF /I "%STDIN%" EQU "Cancel" GOTO :EOF
IF /I "%STDIN%" EQU "X" GOTO :EOF
IF /I "%STDIN%" EQU "Exit" GOTO :EOF
IF /I "%STDIN%" EQU "R" (
    CALL :ClearBuffer 1
    GOTO :Documents
)
IF /I "%STDIN%" EQU "Refresh" (
    CALL :ClearBuffer 1
    GOTO :Documents
)

IF /I EXIST "%DirDocuments%\%STDIN%" CALL :DocumentViewer 0& GOTO :Documents
IF /I EXIST "%DirDocuments%\%STDIN%.txt" CALL :DocumentViewer 1& GOTO :Documents

ECHO Filename could not be found!
PAUSE
CALL :ClearBuffer 1
GOTO :Documents



REM # =============================================================================================
REM # Parameters: [{Int} IncludeFileExtension]
REM # Documentation: Prepare to display the ascii file.
REM # =============================================================================================
:DocumentViewer
IF %1 EQU 1 SET "STDIN=%STDIN%.txt"
CALL :ClearBuffer 0
CALL :DocumentViewer_Body "%STDIN%" "%DirDocuments%\%STDIN%"
CALL :ClearBuffer 1
GOTO :EOF



REM # =============================================================================================
REM # Parameters: [{String} FileName] [{String} FullPathFileName]
REM # Documentation: Display the Document Viewer outlook and call the function to display the actual text file within the terminal.
REM # =============================================================================================
:DocumentViewer_Body
ECHO Opening file named '%~1'...
ECHO.
ECHO %SeparatorLong%
ECHO.
CALL :DocumentViewer_Reader "%~2"
ECHO.
ECHO %SeparatorLong%
ECHO.
ECHO Reached end of file marker from '%~1'!
PAUSE > NUL
GOTO :EOF




REM =====================================================================
REM Check for Updates
REM ----------------------------
REM To make things for the end-user, this allows the user to quickly check for available updates with ease.  Despite there's limitations with Batch, we can not really automatically fetch information and append them.  However, instead, this will open Windows Explorer's functionality to open website pages.  This functionality alone will help the user to determine if there is new updates or if the program that they currently have is still the current latest version.
REM =====================================================================


REM # =============================================================================================
REM # Documentation: This function is a small driver for checking updates.
REM # =============================================================================================
:Updates
CALL :DashboardDisplay
CALL :Updates_InternalInformation
CALL :Updates_OpenWeb
PAUSE
GOTO :EOF



REM # =============================================================================================
REM # Documentation: This will display all of the information necessary to help the user determine if the program is up to date or is outdated.
REM # =============================================================================================
:Updates_InternalInformation
ECHO Current Module Information:
ECHO %Separator%
ECHO Core Name:
ECHO    %ProgramName% [%CodeName%]
ECHO Version:
ECHO    %ProgramVersion%
ECHO Released:
ECHO    %ProgramReleaseDate%
ECHO.&ECHO.
GOTO :EOF



REM # =============================================================================================
REM # Documentation: This function will call Windows Explorer - regardless of the CallExplorer variable from the core -, and go to an official website or forum that will contain information and resources of newer updates and recent changes.
REM # =============================================================================================
:Updates_OpenWeb
CALL :Call_WindowsExplorer "http://forum.drdteam.org/viewtopic.php?p=53914#p53914"
GOTO :EOF




REM =====================================================================
REM Project Loader
REM ----------------------------
REM This feature allows the core to be expandable and execute script modules to perform tedious tasks and to get various operations accomplished - such as compiling software or compiling a game project into a pk3 file.  As script modules are allowed to use Bootless Star's environment, this will allow the script modules to quickly use the end user's programs and settings without having to write the same information again.  For those that remember Bootless Star Beta 7 and before, it used to be hard coded to only compile specific software and nothing further -- Can not easily be expanded and required having to change the core's code.  But, however, now this has changed to allow more tasks to be done and less changes within the core.  The core essentially allows the modules to expand the programs capabilities.
REM Script module directory is managed by this variable [ %DirProjects% ]
REM Scripts that are executed from this environment are allowed to use the core's environment.
REM =====================================================================


REM # =============================================================================================
REM # Documentation: If the script modules directory does not exist, then attempt to create the directory.
REM # =============================================================================================
:ProjectLoaderInspect
IF NOT EXIST "%DirProjects%" MKDIR "%DirProjects%" || ECHO !ERR_CRIT!: Could not create directory [ %DirProjects% ] within the local filesystem!
GOTO :EOF



REM # =============================================================================================
REM # Documentation: Display what scripts can be found and can be used within the script module directory
REM # =============================================================================================
:ProjectLoaderDirectoryViewer
DIR /B %DirProjects% | FINDSTR /E /I ".bat" || ECHO !ERR: Could not find the directory or files!&
GOTO :EOF



REM # =============================================================================================
REM # Documentation: Script Module menu screen
REM # =============================================================================================
:ProjectLoader
CALL :DashboardDisplay
CALL :ProjectLoaderInspect
ECHO Run Project Module
ECHO.
ECHO Projects Directory: %DirProjects%
ECHO %SeparatorLong%
REM Display what contents exist within the script module directory
CALL :ProjectLoaderDirectoryViewer
ECHO %SeparatorLong%
ECHO.&ECHO.
ECHO Select the following options:
ECHO %Separator%
ECHO [I] Install a Project Module
ECHO [R] Refresh lists
ECHO [X] Return to Main Menu
CALL :ProjectLoader_ChoicePrep
GOTO :ProjectLoader_UserInput



REM # =============================================================================================
REM # Documentation: Inspect the users input
REM # =============================================================================================
:ProjectLoader_UserInput
IF /I "%STDIN%" EQU "R" (
    CALL :ClearBuffer 1
    GOTO :ProjectLoader
)
IF /I "%STDIN%" EQU "Refresh" (
    CALL :ClearBuffer 1
    GOTO :ProjectLoader
)
IF /I "%STDIN%" EQU "I" (
    CALL :ClearBuffer 1
    CALL :ProjectLoader_Install
    CALL :ClearBuffer 1
    GOTO :ProjectLoader
)
IF /I "%STDIN%" EQU "Install" (
    CALL :ClearBuffer 1
    CALL :ProjectLoader_Install
    CALL :ClearBuffer 1
    GOTO :ProjectLoader
)
IF /I "%STDIN%" EQU "X" GOTO :EOF
CALL :ProjectLoader_ExecuteProject
CALL :ClearBuffer 1
GOTO :ProjectLoader



REM # =============================================================================================
REM # Documentation: Install a compatible script.  To make things easier for the user, this will forcefully open a new window allowing the user to simply drag and drop a batch script into the directory.
REM # =============================================================================================
:ProjectLoader_Install
IF EXIST "%DirProjects%" (
    CALL :ProjectLoader_Install_Message
    CALL :ProjectLoader_Install_ExplorerDirectory
) ELSE (
    CALL :ProjectLoader_Install_ErrorMessage
)
PAUSE
GOTO :EOF



:ProjectLoader_Install_Message
ECHO Instructions:
ECHO With the newly pop-up directory window, simply drag and drop the project module into that directory.
ECHO This program only accepts 'Batch' [.bat] program scripts!
ECHO.
ECHO.
ECHO Compatibility Notice:
ECHO Be sure that the project module is able to work with %ProgramName% version %ProgramReleaseDate% environment!  Outdated scripts may not function properly or will not be able to take advantage of newer improvements and additions that is offered in the later versions!
ECHO.
ECHO.
ECHO Safety Notice:
ECHO Please insure that the script file _is_safe_before_using_it_!  It is always possible for a script file remove the users data or perform various other malicious executions.  Thus, as a safety precaution, _always_check_user_reviews_and_inspect_the_code_before_blindly_using_them_!
ECHO Make sure that the script is designed for %ProgramName% [version: %ProgramReleaseDate%]!  When a project module is loaded in %ProgramName% environment, the script is not only sharing %ProgramName% environment settings but also the users settings!  Thus, as a result, any sensitive data that was stored from the user, will be accessible to the script!
ECHO.
GOTO :EOF



:ProjectLoader_Install_ExplorerDirectory
CALL :Call_WindowsExplorer "%DirProjects%"
GOTO :EOF



:ProjectLoader_Install_ErrorMessage
CALL :CantInstallScriptErrorMessage
GOTO :EOF



REM # =============================================================================================
REM # Documentation: Select a script module to execute within the environment.
REM # =============================================================================================
:ProjectLoader_ChoicePrep
ECHO.
ECHO %Separator%
ECHO.
ECHO Enter a filename:
CALL :UserInput
GOTO :EOF



REM # =============================================================================================
REM # Documentation: Pass the script module to the ExecuteScript function and cache the exitcode for processing later.  If incase the file was not found, nothing is executed.
REM # =============================================================================================
:ProjectLoader_ExecuteProject
IF /I "%STDIN%" EQU "Cancel" GOTO :EOF
IF /I EXIST "%DirProjects%\%STDIN%" (
    CALL :ProjectLoader_ExecuteScript "%DirProjects%\%STDIN%"
    SET scriptExitCode=%ERRORLEVEL%
    CALL :ProjectLoader_Finished
    GOTO :EOF
)
IF /I EXIST "%DirProjects%\%STDIN%.bat" (
    CALL :ProjectLoader_ExecuteScript "%DirProjects%\%STDIN%.bat"
    SET scriptExitCode=%ERRORLEVEL%
    CALL :ProjectLoader_Finished
    GOTO :EOF
)
ECHO Filename could not be found!
PAUSE
CALL :ClearBuffer 1
GOTO :EOF



REM # =============================================================================================
REM # Parameters: [{String} FullPathFileName]
REM # Documentation: Execute the script file into a new process.
REM # =============================================================================================
:ProjectLoader_ExecuteScript
REM Update the title to include the script name that is going to be executed
CALL :UpdateCoreTitleExecutingScript "%~1"
REM Determine the parameters for START if the user enabled or disabled the Window Sharing
IF %ModuleExecuteSharingWindow% EQU False (
    SET ProcessVarB=
) ELSE (
    SET "ProcessVarB=/B /WAIT"
)
REM The working variable 'ProcessVarA' is captured from the function :UpdateCoreTitleExecutingScript
START "Batch Fork: %ProcessVarA%" %ProcessVarB% CMD /Q /C CALL "%~1"
GOTO :EOF



REM # =============================================================================================
REM # Documentation: After the module has been closed, do the final procedures: checking the exit code of the execution, and resetting some of the core's settings.
REM # =============================================================================================
:ProjectLoader_Finished
REM Check to see if there was an error first
ECHO.&ECHO.
ECHO %SeparatorLong%
ECHO Script has been closed!
ECHO %SeparatorLong%
REM Reset some of the cores environment settings.
CALL :EnvironmentSetup_Switch PartialReset
IF %scriptExitCode% NEQ 0 GOTO :ProjectLoader_ExitWithError
PAUSE
GOTO :EOF



REM # =============================================================================================
REM # Documentation: When the module has been terminated prematurely, then tell the user that the script closed with an error.
REM # =============================================================================================
:ProjectLoader_ExitWithError
ECHO !ERR: A module has been terminated with an error....
PAUSE
GOTO :EOF




REM =====================================================================
REM External Module Launcher
REM ----------------------------
REM This allows the user to utilize outside tools to get the job done that isn't normally provided in the program core.  This functionality gives the user the ability to use customized scripts to either get a few extra jobs finished or even to expand into more operations.  The modules, however, are not code checked.  Thus, if someone wrote 'del %systemdrive%' - then that'll happen.
REM External scripts directory is managed by this variable [ %DirSubScripts% - variable ]
REM Scripts that are executed from this environment are not allowed to use the core's environment.
REM =====================================================================


REM # =============================================================================================
REM # Documentation: If the external scripts directory does not exist within the filesystem, then try to create it.
REM # =============================================================================================
:LoadExtScriptsInspect
IF NOT EXIST "%DirSubScripts%" MKDIR "%DirSubScripts%" || ECHO !ERR_CRIT!: Could not create directory [ %DirSubScripts% ] within the local filesystem!
GOTO :EOF



REM # =============================================================================================
REM # Documentation: Display what scripts can be executed from the external scripts library.
REM # =============================================================================================
:LoadExtScriptsDirectoryViewer
DIR /B "%DirSubScripts%" | FINDSTR /E /I ".bat" || ECHO !ERR: Could not find the directory or files!&
GOTO :EOF



REM # =============================================================================================
REM # Documentation: External scripts menu
REM # =============================================================================================
:LoadExtScripts
CALL :DashboardDisplay
CALL :LoadExtScriptsInspect
ECHO Run External Scripts
ECHO.
ECHO Preset Directory: %DirSubScripts%
ECHO %SeparatorLong%
REM Display what scripts can be executed.
CALL :LoadExtScriptsDirectoryViewer
ECHO %SeparatorLong%
ECHO.&ECHO.
ECHO Other Options:
ECHO %SeparatorSmall%
ECHO [I] Install a External Script
ECHO [R] Refresh the list
ECHO [X] Cancel
ECHO %Separator%
ECHO.
ECHO Enter filename to launch an external module:
CALL :UserInput
GOTO :LoadExtScripts_UserInput



REM # =============================================================================================
REM # Documentation: Inspect the user's input and check if the script file can be executed.  If the latter is true, then simply allow it to be executed by calling the execute script function.
REM # =============================================================================================
:LoadExtScripts_UserInput
IF /I "%STDIN%" EQU "Cancel" GOTO :EOF
IF /I "%STDIN%" EQU "X" GOTO :EOF
IF /I "%STDIN%" EQU "R" (
    CALL :ClearBuffer 1
    GOTO :LoadExtScripts
)
IF /I "%STDIN%" EQU "Refresh" (
    CALL :ClearBuffer 1
    GOTO :LoadExtScripts
)
IF /I "%STDIN%" EQU "I" (
    CALL :ClearBuffer 1
    CALL :LoadExtScripts_Install
    CALL :ClearBuffer 1
    GOTO :LoadExtScripts
)
IF /I "%STDIN%" EQU "Install" (
    CALL :ClearBuffer 1
    CALL :LoadExtScripts_Install
    CALL :ClearBuffer 1
    GOTO :LoadExtScripts
)
IF EXIST "%DirSubScripts%\%STDIN%" (
    CALL :LoadExtScripts_ProjectLoader_ExecuteScript "%DirSubScripts%\%STDIN%"
    CALL :LoadExtScripts_LastStage
    GOTO :LoadExtScripts
)
IF EXIST "%DirSubScripts%\%STDIN%.bat" (
    CALL :LoadExtScripts_ProjectLoader_ExecuteScript "%DirSubScripts%\%STDIN%.bat"
    CALL :LoadExtScripts_LastStage
    GOTO :LoadExtScripts
)
ECHO Filename could not be found!
PAUSE
CALL :ClearBuffer 1
GOTO :LoadExtScripts



REM # =============================================================================================
REM # Documentation: Install a generalized script.  To make things easier for the user, this will forcefully open a new window allowing the user to simply drag and drop a batch script into the directory.
REM # =============================================================================================
:LoadExtScripts_Install
IF EXIST "%DirSubScripts%" (
    CALL :LoadExtScripts_Install_Message
    CALL :LoadExtScripts_Install_ExplorerDirectory
) ELSE (
    CALL :LoadExtScripts_Install_ErrorMessage
)
PAUSE
GOTO :EOF



:LoadExtScripts_Install_Message
ECHO Instructions:
ECHO With the newly pop-up directory window, simply drag and drop the project module into that directory.
ECHO This program only accepts 'Batch' [.bat] program scripts!
ECHO.
ECHO.
ECHO Safety Notice:
ECHO Please insure that the script file _is_safe_before_using_it_!  It is always possible for a script file remove the users data or perform various other malicious executions.  Thus, as a safety precaution, _always_check_user_reviews_and_inspect_the_code_before_blindly_using_them_!
ECHO.
GOTO :EOF



:LoadExtScripts_Install_ExplorerDirectory
CALL :Call_WindowsExplorer "%DirSubScripts%"
GOTO :EOF



:LoadExtScripts_Install_ErrorMessage
CALL :CantInstallScriptErrorMessage
GOTO :EOF



REM # =============================================================================================
REM # Parameters: [{String} FullPathFileName]
REM # Documentation: Execute the external script file into a new process.
REM # =============================================================================================
:LoadExtScripts_ProjectLoader_ExecuteScript
REM Update the title to include the script name that is going to be executed
CALL :UpdateCoreTitleExecutingScript "%~1"
REM Determine the parameters for START if the user enabled or disabled the Window Sharing
IF %ModuleExecuteSharingWindow% EQU False (
    SET ProcessVarB=
) ELSE (
    SET "ProcessVarB=/B /WAIT"
)
REM The working variable 'ProcessVarA' is captured from the function :UpdateCoreTitleExecutingScript
START "Batch External Fork: %ProcessVarA%" %ProcessVarB% /I CMD /C CALL "%~1"
GOTO :EOF



REM # =============================================================================================
REM # Documentation: After a script has been terminated, this will print a notification that the script ended.  Additionally, this will also reset some of the core's environment settings that could have been altered, title - for example.
REM # =============================================================================================
:LoadExtScripts_LastStage
ECHO %SeparatorLong%
ECHO External Module has been closed!
ECHO %SeparatorLong%
PAUSE
REM Reset some of the environment settings
CALL :EnvironmentSetup_Switch PartialReset
CALL :ClearBuffer 1
GOTO :EOF




REM =====================================================================
REM Control Panel Menu
REM ----------------------------
REM Main setting screen; this allows the user to expeditiously modify the program settings and make any other customizations necessary.
REM =====================================================================


REM # =============================================================================================
REM # Documentation: Settings menu
REM # =============================================================================================
:ControlPanel
CALL :DashboardDisplay
ECHO Settings Menu
ECHO.
ECHO Select the following options:
ECHO %Separator%
ECHO [1] Copy Settings
ECHO [2] Directory Setup
ECHO [3] Terminal Sounds
ECHO [4] Logging Settings
ECHO.
ECHO Other Options
ECHO %SeparatorSmall%
ECHO [A] Advanced Settings
ECHO [D] Debug %ProgramName%
ECHO [X] Exit
CALL :UserInput
GOTO :ControlPanel_UserInput



REM # =============================================================================================
REM # Documentation: Inspect the users input
REM # =============================================================================================
:ControlPanel_UserInput
IF "%STDIN%" EQU "1" GOTO :ControlPanel_Choice_Copy
IF "%STDIN%" EQU "2" GOTO :ControlPanel_Choice_DirectorySetup
IF "%STDIN%" EQU "3" GOTO :ControlPanel_Choice_TerminalSounds
IF "%STDIN%" EQU "4" GOTO :ControlPanel_Choice_Logging
IF /I "%STDIN%" EQU "A" GOTO :ControlPanel_Choice_ControlPanelAdvanced
IF /I "%STDIN%" EQU "D" GOTO :ControlPanel_Choice_Debug
IF /I "%STDIN%" EQU "X" GOTO :EOF
IF /I "%STDIN%" EQU "Exit" GOTO :EOF
CALL :BadInput& GOTO :ControlPanel



REM # =============================================================================================
REM # Documentation: Allow the ability for the user to change their preferred duplicating software.
REM # =============================================================================================
:ControlPanel_Choice_Copy
CALL :ClearBuffer 1
CALL :ControlPanel_CopyConfiguration
CALL :ClearBuffer 1
GOTO :ControlPanel



REM # =============================================================================================
REM # Documentation: Allow the ability for the user to change the variable target that hoses either directories or exact file locations.
REM # =============================================================================================
:ControlPanel_Choice_DirectorySetup
CALL :ClearBuffer 1
CALL :ControlPanel_DirectorySetup
CALL :ClearBuffer 1
GOTO :ControlPanel



REM # =============================================================================================
REM # Documentation: Terminal alarm settings.
REM # =============================================================================================
:ControlPanel_Choice_TerminalSounds
CALL :ClearBuffer 1
CALL :ControlPanel_TerminalSound
CALL :ClearBuffer 1
GOTO :ControlPanel



REM # =============================================================================================
REM # Documentation: Allow the user to enable or disable the ability to log.
REM # =============================================================================================
:ControlPanel_Choice_Logging
CALL :ClearBuffer 1
CALL :ControlPanel_LogSettings
CALL :ClearBuffer 1
GOTO :ControlPanel



REM # =============================================================================================
REM # Documentation: Call the debugger setting tool.
REM # =============================================================================================
:ControlPanel_Choice_Debug
CALL :ClearBuffer 1
CALL :DebuggerTool
CALL :ClearBuffer 1
GOTO :ControlPanel



REM # =============================================================================================
REM # Documentation: Call the advanced control panel.
REM # =============================================================================================
:ControlPanel_Choice_ControlPanelAdvanced
CALL :ClearBuffer 1
CALL :ControlPanelAdvanced
CALL :ClearBuffer 1
GOTO :ControlPanel




REM =====================================================================
REM Control Panel Advanced Menu
REM ----------------------------
REM This section allows the user to modify more advanced settings that most users will not generally care about.
REM =====================================================================


REM # =============================================================================================
REM # Documentation: Advanced settings menu
REM # =============================================================================================
:ControlPanelAdvanced
CALL :DashboardDisplay
ECHO Advanced Settings Menu
ECHO For the Power Users!
ECHO.
ECHO Select the following options:
ECHO %Separator%
ECHO [1] General Program Settings
ECHO [2] 7Zip Settings
ECHO [3] Copy Parameter Settings
ECHO.
ECHO Other Options
ECHO %SeparatorSmall%
ECHO [X] Exit
CALL :UserInput
GOTO :ControlPanelAdvanced_UserInput



REM # =============================================================================================
REM # Documentation: Inspect the users input
REM # =============================================================================================
:ControlPanelAdvanced_UserInput
IF "%STDIN%" EQU "1" GOTO :ControlPanelAdvanced_Choice_GeneralProgramConfiguration
IF "%STDIN%" EQU "2" GOTO :ControlPanelAdvanced_Choice_7ZipConfiguration
IF "%STDIN%" EQU "3" GOTO :ControlPanelAdvanced_Choice_CopyParameterConfiguration
IF /I "%STDIN%" EQU "X" GOTO :EOF
IF /I "%STDIN%" EQU "Exit" GOTO :EOF
CALL :BadInput& GOTO :ControlPanelAdvanced



REM # =============================================================================================
REM # Documentation: Call the Advanced Menu for: General Program Settings.
REM # =============================================================================================
:ControlPanelAdvanced_Choice_GeneralProgramConfiguration
CALL :ClearBuffer 1
CALL :ControlPanel_GeneralProgramConfiguration
CALL :ClearBuffer 1
GOTO :ControlPanelAdvanced



REM # =============================================================================================
REM # Documentation: Call the Advanced Menu for: 7Zip Configuration.
REM # =============================================================================================
:ControlPanelAdvanced_Choice_7ZipConfiguration
CALL :ClearBuffer 1
CALL :ControlPanel_7Zip
CALL :ClearBuffer 1
GOTO :ControlPanelAdvanced



REM # =============================================================================================
REM # Documentation: Call the Advanced Menu for: Copy Parameter Configurations menu.
REM # =============================================================================================
:ControlPanelAdvanced_Choice_CopyParameterConfiguration
CALL :ClearBuffer 1
CALL :ControlPanel_CopyBehaviorConfiguration
CALL :ClearBuffer 1
GOTO :ControlPanelAdvanced




REM =====================================================================
REM User Configuration Manager
REM ----------------------------
REM This script allows the user to store and manage their own preset configuration that is located in the [ %DirSavePresets% - variable ].  These configurations files contains the user's personal settings that is used within this program, and is remotely handled within the Initialization block.
REM =====================================================================


REM # =============================================================================================
REM # Documentation: Check to make sure that the Preset directory [ %DirSavePresets% ] exists within the filesystem, if it does not - then simply create the directory.
REM # =============================================================================================
:UserConfigurationDirectoryInspect
IF NOT EXIST "%DirSavePresets%" MKDIR "%DirSavePresets%" || ECHO !ERR_CRIT!: Could not create directory [ %DirSavePresets% ] within the local filesystem!
GOTO :EOF



REM # =============================================================================================
REM # Documentation: Display what batch scripts were detected within the preset directory.
REM # =============================================================================================
:UserConfigurationDirectoryViewer
DIR /B "%DirSavePresets%" | FINDSTR /E /I ".bat" || ECHO !ERR: Could not find the directory or files!&
GOTO :EOF



REM # =============================================================================================
REM # Documentation: User preset configuration menu
REM # =============================================================================================
:UserConfiguration
CALL :DashboardDisplay
REM Check the preset config. menu.
CALL :UserConfigurationDirectoryInspect
ECHO User Configuration Menu
ECHO.
ECHO Preset Directory: %DirSavePresets%
ECHO %SeparatorLong%
REM Preview of all of the scripts found
CALL :UserConfigurationDirectoryViewer
ECHO %SeparatorLong%
ECHO.&ECHO.
ECHO Select the following options:
ECHO %Separator%
ECHO [1] Load Settings
ECHO [2] Save Settings
ECHO [R] Refresh List
ECHO [D] Remove a Saved Configuration
ECHO [X] Return to Main Menu
CALL :UserInput
GOTO :UserConfiguration_UserInput



REM # =============================================================================================
REM # Documentation: Inspect the user's input
REM # =============================================================================================
:UserConfiguration_UserInput
REM Read the STDIN and process it
IF "%STDIN%" EQU "1" (
    CALL :UserConfiguration_SelectFile Load
    CALL :EnvironmentSetup_Switch UserConfigLoad
    CALL :ClearBuffer 1
    GOTO :UserConfiguration
)
IF /I "%STDIN%" EQU "Load" (
    CALL :UserConfiguration_SelectFile Load
    CALL :ClearBuffer 1
    GOTO :UserConfiguration
)
IF "%STDIN%" EQU "2" (
    CALL :UserConfiguration_SelectFile Save
    CALL :ClearBuffer 1
    GOTO :UserConfiguration
)
IF /I "%STDIN%" EQU "Save" (
    CALL :UserConfiguration_SelectFile Save
    CALL :ClearBuffer 1
    GOTO :UserConfiguration
)
IF /I "%STDIN%" EQU "R" (
    CALL :ClearBuffer 1
    GOTO :UserConfiguration
)
IF /I "%STDIN%" EQU "Refresh" (
    CALL :ClearBuffer 1
    GOTO :UserConfiguration
)
IF /I "%STDIN%" EQU "D" (
    CALL :UserConfiguration_SelectFile Delete
    CALL :ClearBuffer 1
    GOTO :UserConfiguration
)
IF /I "%STDIN%" EQU "Delete" (
    CALL :UserConfiguration_SelectFile Delete
    CALL :ClearBuffer 1
    GOTO :UserConfiguration
)
IF /I "%STDIN%" EQU "X" GOTO :EOF
IF /I "%STDIN%" EQU "Exit" GOTO :EOF
CALL :BadInput& GOTO :UserConfiguration



REM # =============================================================================================
REM # Parameters: [{String} Mode]
REM # Documentation: This is a central point when the user wants to either select a file or create a new preset configuration file.
REM # =============================================================================================
:UserConfiguration_SelectFile
ECHO.
ECHO %1 Mode Selected
ECHO %Separator%
ECHO NOTE: Do not include the ^'.bat^' file extension.
ECHO.
ECHO Other Options:
ECHO [Cancel]
ECHO.
ECHO Enter a filename:
CALL :UserInput
CALL :UserConfiguration_SelectFile_UserInput %1
GOTO :EOF



REM # =============================================================================================
REM # Parameters: [{String} Mode]
REM # Documentation: Inspect the user's input and determine what action to perform.
REM # =============================================================================================
:UserConfiguration_SelectFile_UserInput
IF /I "%STDIN%" EQU "Cancel" GOTO :EOF
REM Cache the users input into a working variable
CALL :UserConfiguration_SelectFile_CacheFileName
REM Fix the STDIN variable if necessary
CALL :UserConfiguration_SelectFile_UpdateVariable
REM Save mode
IF %1 EQU Save CALL :UserConfiguration_ChoiceSave& GOTO :EOF
REM Load mode
IF %1 EQU Load CALL :UserConfiguration_ChoiceLoad& GOTO :EOF
REM Expunge mode
IF %1 EQU Delete CALL :UserConfiguration_ChoiceThrash& GOTO :EOF
GOTO :EOF



REM # =============================================================================================
REM # Documentation: If incase the user did not input the file extension, add it for them.
REM # =============================================================================================
:UserConfiguration_SelectFile_UpdateVariable
SET "STDIN=%STDIN%.bat"
GOTO :EOF



REM # =============================================================================================
REM # Documentation: Cache the filename in a temporary working variable; this can be used later - such as defining the filename properly.
REM # =============================================================================================
:UserConfiguration_SelectFile_CacheFileName
SET "ProcessVarA=%STDIN%"
GOTO :EOF



REM # =============================================================================================
REM # Documentation: Load the configuration file into the current environment.
REM # =============================================================================================
:UserConfiguration_ChoiceLoad
IF /I EXIST "%DirSavePresets%\%STDIN%" (
    CALL "%DirSavePresets%\%STDIN%"
    GOTO :EOF
) ELSE (
    ECHO !ERR: Filename could not be found!
    PAUSE
    GOTO :EOF
)



REM # =============================================================================================
REM # Documentation: Save a new configuration file into the filesystem.
REM # =============================================================================================
:UserConfiguration_ChoiceSave
REM Does the file already exist within the filesystem?
IF /I EXIST "%DirSavePresets%\%STDIN%" (
    ECHO !ERR: File named '%STDIN%' already exists!
    PAUSE
    GOTO :EOF
)
CALL :UserConfiguration_CreateSave "%DirSavePresets%\%STDIN%"
REM Load the configuration, this will load the keychain ID and config name into memory.
CALL :UserConfiguration_ChoiceLoad "%DirSavePresets%\%STDIN%"
GOTO :EOF



REM # =============================================================================================
REM # Parameters: [{String} FullPathFileName]
REM # Documentation: Create the header information into the file.
REM # =============================================================================================
:UserConfiguration_CreateSave
REM Notice: This first statement will OVERWRITE the ASCII file!
(ECHO @ECHO OFF) > "%~1"
(ECHO ECHO User Saved Configuration Generated using %ProgramName% Version %ProgramVersion% [%CodeName%]) >> "%~1"
(ECHO ECHO Date created: %Date% - %Time% by %UserName% on system %ComputerName%) >> "%~1"
(ECHO SET UserConfigurationLoaded=%ProcessVarA%) >> "%~1"
(ECHO SET UserConfigurationKeyChainToken=%RANDOM%) >> "%~1"
ECHO REM %SeparatorLong%>> "%~1"
ECHO REM %SeparatorLong%>> "%~1"
(ECHO.) >> "%~1"
REM To avoid redundancy and mistakes of forgotten variables, we'll utilize the EnvironmentSetup functions.
CALL :EnvironmentSetup_Switch UserConfigSave
(ECHO GOTO :EOF) >> "%~1"
GOTO :EOF



REM # =============================================================================================
REM # Documentation: Expunge a preset configuration file from the filesystem.
REM # =============================================================================================
:UserConfiguration_ChoiceThrash
IF /I EXIST "%DirSavePresets%\%STDIN%" (
    REM Prompt the user for confirmation before deleting the file.
    DEL /P "%DirSavePresets%\%STDIN%"
    GOTO :EOF
) ELSE (
    ECHO !ERR: Filename could not be found!
    PAUSE
    GOTO :EOF
)




REM =====================================================================
REM Control Panel: Log Settings
REM ----------------------------
REM This allows the user to toggle the Logfile functionality within this entire program.  This can be useful for debugging or viewing the output from all tasks and operations, such as MSBUILD, XCopy, moving, etc....
REM For faster performance disable this option, however, enable this if you want to know 'every' step that the compiler phase is doing.
REM =====================================================================


REM # =============================================================================================
REM # Documentation: This function is a translator which takes the variable's value and stores a nicer value name to a temporary working variable.
REM # =============================================================================================
:ControlPanel_LogSettings_Translator
IF %ToggleLog% EQU True SET ProcessVarA=Enable& GOTO :EOF
IF %ToggleLog% EQU False SET ProcessVarA=Disable
GOTO :EOF



REM # =============================================================================================
REM # Documentation: Logfile menu
REM # =============================================================================================
:ControlPanel_LogSettings
CALL :DashboardDisplay
REM Translate the actual variable value into another variable with a nicer value.
CALL :ControlPanel_LogSettings_Translator
ECHO Log Settings
ECHO.
ECHO Description
ECHO %SeparatorSmall%
ECHO When compiling projects or tasks are performed for a project, logging will allow the user to view exactly what is being done in the background and even more verbose information that may not be available on the terminal screen.  For faster performance, leave this setting disabled.
ECHO.
ECHO Default Value: Disable
ECHO Logging is currently: %ProcessVarA%
ECHO %Separator%
ECHO [1] Disable Logging
ECHO [2] Enable Logging
ECHO.
ECHO Other Options
ECHO %SeparatorSmall%
ECHO [X] Cancel
CALL :UserInput
GOTO :ControlPanel_LogSettings_UserInput



REM # =============================================================================================
REM # Documentation: Inspect the users input
REM # =============================================================================================
:ControlPanel_LogSettings_UserInput
IF /I "%STDIN%" EQU "X" GOTO :EOF
IF /I "%STDIN%" EQU "Cancel" GOTO :EOF

IF "%STDIN%" EQU "1" (
    CALL :ControlPanel_LogSettings_Toggle False
    CALL :ClearBuffer 1
    GOTO :ControlPanel_LogSettings
)
IF "%STDIN%" EQU "2" (
    CALL :ControlPanel_LogSettings_Toggle True
    CALL :ClearBuffer 1
    GOTO :ControlPanel_LogSettings
)
CALL :BadInput& GOTO :ControlPanel_LogSettings



REM # =============================================================================================
REM # Parameters: [{Bool} SettingType]
REM # Documentation: Adjust the variable value as requested by the user, this will set the STDOUT variable live.
REM # =============================================================================================
:ControlPanel_LogSettings_Toggle
IF %1 EQU True (
    SET ToggleLog=True
    SET STDOUT=%ProgramName%_%core.Date%_%Project%.txt
    GOTO :EOF
) ELSE (
    SET ToggleLog=False
    SET STDOUT=NUL
    GOTO :EOF
)




REM =====================================================================
REM Control Panel: Copy Software
REM ----------------------------
REM This allows the user to switch from one supported mass copying software to another.  This is going to be needed when transporting a file or an entire directory from one place to another within the filesystem.
REM =====================================================================



REM # =============================================================================================
REM # Documentation: Copy software menu
REM # =============================================================================================
:ControlPanel_CopyConfiguration
CALL :DashboardDisplay
ECHO Copying Software Selection
ECHO.
ECHO Description
ECHO %SeparatorSmall%
ECHO To transition abundance of files from one directory to another, modules can call the preferred dedicated copy software [such as the ones listed below] to accomplish the tasks efficiently.
ECHO.
ECHO Default Value: XCopy
ECHO Copying is currently: %CopyMethod%
ECHO %Separator%
ECHO [1] XCopy
ECHO [2] RoboCopy
ECHO     [Requires Administrative Privileges]
ECHO.
ECHO Other Options
ECHO %SeparatorSmall%
ECHO [X] Cancel
CALL :UserInput
GOTO :ControlPanel_CopyConfiguration_UserInput



REM # =============================================================================================
REM # Documentation: Inspect the users input
REM # =============================================================================================
:ControlPanel_CopyConfiguration_UserInput
IF /I "%STDIN%" EQU "X" GOTO :EOF
IF /I "%STDIN%" EQU "Cancel" GOTO :EOF

IF "%STDIN%" EQU "1" (
    CALL :ControlPanel_CopyConfiguration_Toggle xcopy
    CALL :ClearBuffer 1
    GOTO :ControlPanel_CopyConfiguration
)
IF "%STDIN%" EQU "2" (
    REM Call an independent function that makes sure that Robocopy is selectable.
    CALL :ControlPanel_CopyConfiguration_RobocopySetup
    CALL :ClearBuffer 1
    GOTO :ControlPanel_CopyConfiguration
)
CALL :BadInput& GOTO :ControlPanel_CopyConfiguration



REM # =============================================================================================
REM # Parameters: [{String} SettingType]
REM # Documentation: Adjust the variable value as requested by the user.
REM # =============================================================================================
:ControlPanel_CopyConfiguration_Toggle
IF %1 EQU xcopy (
    SET CopyMethod=XCOPY
    SET CopyArg=%XCopyArg%
    GOTO :EOF
)
IF %1 EQU robocopy (
    SET CopyMethod=ROBOCOPY
    SET CopyArg=%RoboCopyArg%
    GOTO :EOF
)



REM # =============================================================================================
REM # Parameters: [{String} SettingType]
REM # Documentation: Check if the program has enough permissions to utilize the copy program.
REM #       ROBOCOPY can only be used with administrator\Root access.
REM # =============================================================================================
:ControlPanel_CopyConfiguration_CheckPermissions
IF %Detect_RootAccess% NEQ True (
    ECHO.&ECHO.
    ECHO ^<!^>    WARNING    ^<!^>
    ECHO %Separator%
    ECHO.
    ECHO The selected duplicating software [%~1] requires Administrative privileges!
    ECHO %ProgramName% must be restarted with Administrative privileges in order to use [%~1]!
    PAUSE
)
GOTO :EOF



REM # =============================================================================================
REM # Documentation: If the ROBOCOPY software does not exist, disallow the user from selecting it.
REM # =============================================================================================
:ControlPanel_CopyConfiguration_RobocopySetup_CheckExists
IF %Detect_Robocopy% NEQ True (
    ECHO.&ECHO.
    ECHO ^<!^>    Robocopy Not Found!    ^<!^>
    ECHO %SeparatorLong%
    ECHO.
    ECHO %ProgramName% was unable to detect Robocopy on the host system!
    PAUSE
    EXIT /B 1
)
EXIT /B 0



REM # =============================================================================================
REM # Documentation: This is an independent function that handles with Robocopy setup procedures; otherwise tieing into one grouped function will become an utter mess and pure frustration....
REM # =============================================================================================
:ControlPanel_CopyConfiguration_RobocopySetup
REM Does robocopy even exists in the system?  -- If not, leave this function
CALL :ControlPanel_CopyConfiguration_RobocopySetup_CheckExists || GOTO :EOF
REM Is the program running with adminstrative\root access?  NOTE: Robocopy requires it due to its nature.
CALL :ControlPanel_CopyConfiguration_CheckPermissions robocopy
REM If everything is okay, set it
CALL :ControlPanel_CopyConfiguration_Toggle robocopy
GOTO :EOF




REM =====================================================================
REM Control Panel: Copy Parameters and Switches Configurations Menu
REM ----------------------------
REM This section allows the user to modify the copying software's behavior and how the data is duplicated.
REM =====================================================================


REM # =============================================================================================
REM # Documentation: Mass Copy Settings Menu
REM # =============================================================================================
:ControlPanel_CopyBehaviorConfiguration
CALL :DashboardDisplay
ECHO Copy Behavior Selection
ECHO.
ECHO Select the following options:
ECHO %Separator%
ECHO [1] COPY [Internal Command]
ECHO [2] XCOPY
ECHO [3] ROBOCOPY
ECHO.
ECHO Other Options
ECHO %SeparatorSmall%
ECHO [X] Exit
CALL :UserInput
GOTO :ControlPanel_CopyBehaviorConfiguration_UserInput



REM # =============================================================================================
REM # Documentation: Inspect the users input
REM # =============================================================================================
:ControlPanel_CopyBehaviorConfiguration_UserInput
IF "%STDIN%" EQU "1" GOTO :ControlPanel_CopyBehaviorConfiguration_Choice_COPYintCMDConfiguration
IF "%STDIN%" EQU "2" GOTO :ControlPanel_CopyBehaviorConfiguration_Choice_XCOPYConfiguration
IF "%STDIN%" EQU "3" GOTO :ControlPanel_CopyBehaviorConfiguration_Choice_ROBOCOPYConfiguration
IF /I "%STDIN%" EQU "X" GOTO :EOF
IF /I "%STDIN%" EQU "Exit" GOTO :EOF
CALL :BadInput& GOTO :ControlPanel_CopyBehaviorConfiguration



REM # =============================================================================================
REM # Documentation: Call the function that allows the user to modify the intCMD COPY's parameters and switches.
REM # =============================================================================================
:ControlPanel_CopyBehaviorConfiguration_Choice_COPYintCMDConfiguration
CALL :ClearBuffer 1
CALL :ControlPanel_intCMDCopyParameterConfiguration
CALL :ClearBuffer 1
GOTO :ControlPanel_CopyBehaviorConfiguration



REM # =============================================================================================
REM # Documentation: Call the function that allows the user to modify XCOPY's parameters and switches.
REM # =============================================================================================
:ControlPanel_CopyBehaviorConfiguration_Choice_XCOPYConfiguration
CALL :ClearBuffer 1
CALL :ControlPanel_XCopyParameterConfiguration
CALL :ClearBuffer 1
GOTO :ControlPanel_CopyBehaviorConfiguration



REM # =============================================================================================
REM # Documentation: Call the function that allows the user to modify ROBOCOPY's parameters and switches.
REM # =============================================================================================
:ControlPanel_CopyBehaviorConfiguration_Choice_ROBOCOPYConfiguration
CALL :ClearBuffer 1
CALL :ControlPanel_RoboCopyParameterConfiguration
CALL :ClearBuffer 1
GOTO :ControlPanel_CopyBehaviorConfiguration




REM =====================================================================
REM Control Panel: IntCMD Copy Behavior
REM ----------------------------
REM This allows the user to change the behavioral of the internal command 'Copy'.  This section merely adjusts what parameters and switches are to be used when using the command.
REM =====================================================================



REM # =============================================================================================
REM # Documentation: Copy [IntCMD] software Behavior Menu
REM # =============================================================================================
:ControlPanel_intCMDCopyParameterConfiguration
CALL :DashboardDisplay
ECHO Copy [Internal Command] Switches Configuration
ECHO.
ECHO Description
ECHO %SeparatorSmall%
ECHO This allows the ability for the user to customize the switches that can be utilized when a module copies data using the internal command 'COPY'
ECHO.
ECHO %Separator%
ECHO [1] Decrypt Files
ECHO     Switch: /D
ECHO     Current: %ParametersCopy.Decrypt%
ECHO [2] Verify Data
ECHO     Switch: /V
ECHO     Current: %ParametersCopy.Verify%
ECHO [3] Suppress Overwrite Messages
ECHO     Switch: /Y
ECHO     Current: %ParametersCopy.Suppress%
ECHO [4] Network Restart Mode
ECHO     Switch: /Z
ECHO     Current: %ParametersCopy.Restart%
ECHO.
ECHO Other Options
ECHO %SeparatorSmall%
ECHO [X] Cancel
CALL :UserInput
GOTO :ControlPanel_intCMDCopyParameterConfiguration_UserInput



REM # =============================================================================================
REM # Documentation: Inspect the users input
REM # =============================================================================================
:ControlPanel_intCMDCopyParameterConfiguration_UserInput
IF /I "%STDIN%" EQU "X" GOTO :EOF
IF /I "%STDIN%" EQU "Cancel" GOTO :EOF
REM The idea here is to change the initial value and then build the entire CopyIntCMDArg
IF "%STDIN%" EQU "1" (
    CALL :ControlPanel_intCMDCopyParameterConfiguration_Toggle_Decrypt
    CALL :ControlPanel_intCMDCopyParameterConfiguration_Builder
    CALL :ControlPanel_intCMDCopyParameterConfiguration_CopyArgUpdate
    CALL :ClearBuffer 1
    GOTO :ControlPanel_intCMDCopyParameterConfiguration
)
IF "%STDIN%" EQU "2" (
    CALL :ControlPanel_intCMDCopyParameterConfiguration_Toggle_Verify
    CALL :ControlPanel_intCMDCopyParameterConfiguration_Builder
    CALL :ControlPanel_intCMDCopyParameterConfiguration_CopyArgUpdate
    CALL :ClearBuffer 1
    GOTO :ControlPanel_intCMDCopyParameterConfiguration
)
IF "%STDIN%" EQU "3" (
    CALL :ControlPanel_intCMDCopyParameterConfiguration_Toggle_Suppress
    CALL :ControlPanel_intCMDCopyParameterConfiguration_Builder
    CALL :ControlPanel_intCMDCopyParameterConfiguration_CopyArgUpdate
    CALL :ClearBuffer 1
    GOTO :ControlPanel_intCMDCopyParameterConfiguration
)
IF "%STDIN%" EQU "4" (
    CALL :ControlPanel_intCMDCopyParameterConfiguration_Toggle_Restart
    CALL :ControlPanel_intCMDCopyParameterConfiguration_Builder
    CALL :ControlPanel_intCMDCopyParameterConfiguration_CopyArgUpdate
    CALL :ClearBuffer 1
    GOTO :ControlPanel_intCMDCopyParameterConfiguration
)
CALL :BadInput& GOTO :ControlPanel_intCMDCopyParameterConfiguration



REM # =============================================================================================
REM # Documentation: This function toggles the value to enable or disable Decrypt
REM # =============================================================================================
:ControlPanel_intCMDCopyParameterConfiguration_Toggle_Decrypt
IF %ParametersCopy.Decrypt% EQU True (
    SET ParametersCopy.Decrypt=False
) ELSE (
    SET ParametersCopy.Decrypt=True
)
GOTO :EOF



REM # =============================================================================================
REM # Documentation: This function toggles the value to enable or disable Verify
REM # =============================================================================================
:ControlPanel_intCMDCopyParameterConfiguration_Toggle_Verify
IF %ParametersCopy.Verify% EQU True (
    SET ParametersCopy.Verify=False
) ELSE (
    SET ParametersCopy.Verify=True
)
GOTO :EOF



REM # =============================================================================================
REM # Documentation: This function toggles the value to enable or disable Suppress Warnings
REM # =============================================================================================
:ControlPanel_intCMDCopyParameterConfiguration_Toggle_Suppress
IF %ParametersCopy.Suppress% EQU True (
    SET ParametersCopy.Suppress=False
) ELSE (
    SET ParametersCopy.Suppress=True
)
GOTO :EOF



REM # =============================================================================================
REM # Documentation: This function toggles the value to enable or disable Restart
REM # =============================================================================================
:ControlPanel_intCMDCopyParameterConfiguration_Toggle_Restart
IF %ParametersCopy.Restart% EQU True (
    SET ParametersCopy.Restart=False
) ELSE (
    SET ParametersCopy.Restart=True
)
GOTO :EOF



REM # =============================================================================================
REM # Documentation: Update the entire CopyIntCMDArg variable.  This works by simply taking all of the supported parameters and updates the main holder variable
REM # =============================================================================================
:ControlPanel_intCMDCopyParameterConfiguration_Builder
REM First, clear the entire variable by uninitializing it
SET CopyIntCMDArg=
REM Build it again with the newer changes
IF %ParametersCopy.Decrypt% EQU True (
    SET CopyIntCMDArg=%CopyIntCMDArg%/D 
)

IF %ParametersCopy.Verify% EQU True (
    SET CopyIntCMDArg=%CopyIntCMDArg%/V 
)

IF %ParametersCopy.Suppress% EQU True (
    SET CopyIntCMDArg=%CopyIntCMDArg%/Y 
)

IF %ParametersCopy.Restart% EQU True (
    SET CopyIntCMDArg=%CopyIntCMDArg%/Z 
)
GOTO :EOF



REM # =============================================================================================
REM # Documentation: If the user has the intCMD COPY as the primary mass copier, then update the CopyArg parameter.
REM # =============================================================================================
:ControlPanel_intCMDCopyParameterConfiguration_CopyArgUpdate
IF %CopyMethod% EQU COPY (
    SET "CopyArg=%CopyIntCMDArg%"
)
GOTO :EOF




REM =====================================================================
REM Control Panel: XCopy Behavior
REM ----------------------------
REM This allows the user to change the behavioral of the external command 'XCopy'.  This section merely adjusts what parameters and switches are to be used when using the command.
REM =====================================================================



REM # =============================================================================================
REM # Documentation: XCopy [ExtCMD] software Behavior Menu
REM # =============================================================================================
:ControlPanel_XCopyParameterConfiguration
CALL :DashboardDisplay
ECHO XCopy Switches Configuration
ECHO.
ECHO Description
ECHO %SeparatorSmall%
ECHO This allows the ability for the user to customize the switches that can be utilized when a module copies data using 'XCOPY'
ECHO.
ECHO %Separator%
ECHO [1] Verify Data
ECHO     Switch: /V
ECHO     Current: %ParametersXCopy.Verify%
ECHO [2] Continue Operation regardless of Errors
ECHO     Switch: /C
ECHO     Current: %ParametersXCopy.Continue%
ECHO [3] Files encrypted stays encrypted (even if destination does not allow it)
ECHO     Switch: /G
ECHO     Current: %ParametersXCopy.Encrypt%
ECHO [4] Suppress Overwrite Messages
ECHO     Switch: /Y
ECHO     Current: %ParametersXCopy.Suppress%
ECHO [5] Network Restart Mode
ECHO     Switch: /Z
ECHO     Current: %ParametersXCopy.Restart%
ECHO.
ECHO Other Options
ECHO %SeparatorSmall%
ECHO [X] Cancel
CALL :UserInput
GOTO :ControlPanel_XCopyParameterConfiguration_UserInput



REM # =============================================================================================
REM # Documentation: Inspect the users input
REM # =============================================================================================
:ControlPanel_XCopyParameterConfiguration_UserInput
IF /I "%STDIN%" EQU "X" GOTO :EOF
IF /I "%STDIN%" EQU "Cancel" GOTO :EOF
REM The idea here is to change the initial value and then build the entire XCopyArg
IF "%STDIN%" EQU "1" (
    CALL :ControlPanel_XCopyParameterConfiguration_Toggle_Verify
    CALL :ControlPanel_XCopyParameterConfiguration_Builder
    CALL :ControlPanel_XCopyParameterConfiguration_CopyArgUpdate
    CALL :ClearBuffer 1
    GOTO :ControlPanel_XCopyParameterConfiguration
)
IF "%STDIN%" EQU "2" (
    CALL :ControlPanel_XCopyParameterConfiguration_Toggle_Continue
    CALL :ControlPanel_XCopyParameterConfiguration_Builder
    CALL :ControlPanel_XCopyParameterConfiguration_CopyArgUpdate
    CALL :ClearBuffer 1
    GOTO :ControlPanel_XCopyParameterConfiguration
)
IF "%STDIN%" EQU "3" (
    CALL :ControlPanel_XCopyParameterConfiguration_Toggle_Encrypt
    CALL :ControlPanel_XCopyParameterConfiguration_Builder
    CALL :ControlPanel_XCopyParameterConfiguration_CopyArgUpdate
    CALL :ClearBuffer 1
    GOTO :ControlPanel_XCopyParameterConfiguration
)
IF "%STDIN%" EQU "4" (
    CALL :ControlPanel_XCopyParameterConfiguration_Toggle_Suppress
    CALL :ControlPanel_XCopyParameterConfiguration_Builder
    CALL :ControlPanel_XCopyParameterConfiguration_CopyArgUpdate
    CALL :ClearBuffer 1
    GOTO :ControlPanel_XCopyParameterConfiguration
)
IF "%STDIN%" EQU "5" (
    CALL :ControlPanel_XCopyParameterConfiguration_Toggle_Restart
    CALL :ControlPanel_XCopyParameterConfiguration_Builder
    CALL :ControlPanel_XCopyParameterConfiguration_CopyArgUpdate
    CALL :ClearBuffer 1
    GOTO :ControlPanel_XCopyParameterConfiguration
)
CALL :BadInput& GOTO :ControlPanel_XCopyParameterConfiguration



REM # =============================================================================================
REM # Documentation: This function toggles the value to enable or disable Continue
REM # =============================================================================================
:ControlPanel_XCopyParameterConfiguration_Toggle_Continue
IF %ParametersXCopy.Continue% EQU True (
    SET ParametersXCopy.Continue=False
) ELSE (
    SET ParametersXCopy.Continue=True
)
GOTO :EOF



REM # =============================================================================================
REM # Documentation: This function toggles the value to enable or disable Encryption to destination
REM # =============================================================================================
:ControlPanel_XCopyParameterConfiguration_Toggle_Encrypt
IF %ParametersXCopy.Encrypt% EQU True (
    SET ParametersXCopy.Encrypt=False
) ELSE (
    SET ParametersXCopy.Encrypt=True
)
GOTO :EOF



REM # =============================================================================================
REM # Documentation: This function toggles the value to enable or disable Verify
REM # =============================================================================================
:ControlPanel_XCopyParameterConfiguration_Toggle_Verify
IF %ParametersXCopy.Verify% EQU True (
    SET ParametersXCopy.Verify=False
) ELSE (
    SET ParametersXCopy.Verify=True
)
GOTO :EOF



REM # =============================================================================================
REM # Documentation: This function toggles the value to enable or disable Suppress Warnings
REM # =============================================================================================
:ControlPanel_XCopyParameterConfiguration_Toggle_Suppress
IF %ParametersXCopy.Suppress% EQU True (
    SET ParametersXCopy.Suppress=False
) ELSE (
    SET ParametersXCopy.Suppress=True
)
GOTO :EOF



REM # =============================================================================================
REM # Documentation: This function toggles the value to enable or disable Restart
REM # =============================================================================================
:ControlPanel_XCopyParameterConfiguration_Toggle_Restart
IF %ParametersXCopy.Restart% EQU True (
    SET ParametersXCopy.Restart=False
) ELSE (
    SET ParametersXCopy.Restart=True
)
GOTO :EOF



REM # =============================================================================================
REM # Documentation: Update the entire XCopyArg variable.  This works by simply taking all of the supported parameters and updates the main holder variable
REM # =============================================================================================
:ControlPanel_XCopyParameterConfiguration_Builder
REM First, clear the entire variable by uninitializing it
SET XCopyArg=
REM Build it again with the newer changes
IF %ParametersXCopy.Verify% EQU True (
    SET XCopyArg=%XCopyArg%/V 
)

IF %ParametersXCopy.Continue% EQU True (
    SET XCopyArg=%XCopyArg%/C 
)

IF %ParametersXCopy.Encrypt% EQU True (
    SET XCopyArg=%XCopyArg%/G 
)

IF %ParametersXCopy.Suppress% EQU True (
    SET XCopyArg=%XCopyArg%/Y 
)

IF %ParametersXCopy.Restart% EQU True (
    SET XCopyArg=%XCopyArg%/Z 
)
GOTO :EOF



REM # =============================================================================================
REM # Documentation: If the user has the extCMD XCOPY as the primary mass copier, then update the CopyArg parameter.
REM # =============================================================================================
:ControlPanel_XCopyParameterConfiguration_CopyArgUpdate
IF %CopyMethod% EQU XCOPY (
    SET "CopyArg=%XCopyArg%"
)
GOTO :EOF




REM =====================================================================
REM Control Panel: Robocopy Behavior
REM ----------------------------
REM This allows the user to change the behavioral of the external command 'Robocopy'.  This section merely adjusts what parameters and switches are to be used when using the command.
REM =====================================================================



REM # =============================================================================================
REM # Documentation: Robocopy [ExtCMD] software Behavior Menu
REM # =============================================================================================
:ControlPanel_RoboCopyParameterConfiguration
CALL :DashboardDisplay
ECHO Robocopy Switches and Parameters Configuration
ECHO.
ECHO Description
ECHO %SeparatorSmall%
ECHO This allows the ability for the user to customize the switches that can be utilized when a module copies data using 'ROBOCOPY'
ECHO.
ECHO %Separator%
ECHO [1] Restartable Mode (backup mode if permission failure)
ECHO     Switch: /ZB
ECHO     Current: %ParametersRobocopy.RestartBackup%
ECHO [2] Disallow Deep Paths (exceeding 256 chars)
ECHO     Switch: /256
ECHO     Current: %ParametersRobocopy.RestrictDeepPaths%
ECHO [3] Exclude Junctions Pointers [RECOMMENDED: True]
ECHO     Switch: /XJ
ECHO     Current: %ParametersRobocopy.NoJunctionPoints%
ECHO [4] Verbose Details
ECHO     Switch: /V
ECHO     Current: %ParametersRobocopy.Verbose%
ECHO [5] Display Long Paths
ECHO     Switch: /FP
ECHO     Current: %ParametersRobocopy.FullPath%
ECHO [6] File Sizes are Displayed as Bytes
ECHO     Switch: /BYTES
ECHO     Current: %ParametersRobocopy.BytesFileSize%
ECHO [7] Do Not Display Progress
ECHO     Switch: /NP
ECHO     Current: %ParametersRobocopy.NoProgress%
ECHO [8] Display Estimated Time of Arrival
ECHO     Switch: /ETA
ECHO     Current: %ParametersRobocopy.ETA%
ECHO.
ECHO Other Options
ECHO %SeparatorSmall%
ECHO [MT] Multithreading
ECHO [Retry] Max of Retires
ECHO [Wait] Wait before retry
ECHO [X] Cancel
CALL :UserInput
GOTO :ControlPanel_RoboCopyParameterConfiguration_UserInput



REM # =============================================================================================
REM # Documentation: Inspect the users input
REM # =============================================================================================
:ControlPanel_RoboCopyParameterConfiguration_UserInput
IF /I "%STDIN%" EQU "X" GOTO :EOF
IF /I "%STDIN%" EQU "Cancel" GOTO :EOF
REM The idea here is to change the initial value and then build the entire RobocopyArg
IF "%STDIN%" EQU "1" (
    CALL :ControlPanel_RoboCopyParameterConfiguration_Toggle_RestartBackup
    CALL :ControlPanel_RoboCopyParameterConfiguration_Builder
    CALL :ControlPanel_RoboCopyParameterConfiguration_CopyArgUpdate
    CALL :ClearBuffer 1
    GOTO :ControlPanel_RoboCopyParameterConfiguration
)
IF "%STDIN%" EQU "2" (
    CALL :ControlPanel_RoboCopyParameterConfiguration_Toggle_RestrictDeepPaths
    CALL :ControlPanel_RoboCopyParameterConfiguration_Builder
    CALL :ControlPanel_RoboCopyParameterConfiguration_CopyArgUpdate
    CALL :ClearBuffer 1
    GOTO :ControlPanel_RoboCopyParameterConfiguration
)
IF "%STDIN%" EQU "3" (
    CALL :ControlPanel_RoboCopyParameterConfiguration_Toggle_NoJunctionPoints
    CALL :ControlPanel_RoboCopyParameterConfiguration_Builder
    CALL :ControlPanel_RoboCopyParameterConfiguration_CopyArgUpdate
    CALL :ClearBuffer 1
    GOTO :ControlPanel_RoboCopyParameterConfiguration
)
IF "%STDIN%" EQU "4" (
    CALL :ControlPanel_RoboCopyParameterConfiguration_Toggle_Verbose
    CALL :ControlPanel_RoboCopyParameterConfiguration_Builder
    CALL :ControlPanel_RoboCopyParameterConfiguration_CopyArgUpdate
    CALL :ClearBuffer 1
    GOTO :ControlPanel_RoboCopyParameterConfiguration
)
IF "%STDIN%" EQU "5" (
    CALL :ControlPanel_RoboCopyParameterConfiguration_Toggle_FullPath
    CALL :ControlPanel_RoboCopyParameterConfiguration_Builder
    CALL :ControlPanel_RoboCopyParameterConfiguration_CopyArgUpdate
    CALL :ClearBuffer 1
    GOTO :ControlPanel_RoboCopyParameterConfiguration
)
IF "%STDIN%" EQU "6" (
    CALL :ControlPanel_RoboCopyParameterConfiguration_Toggle_BytesFileSize
    CALL :ControlPanel_RoboCopyParameterConfiguration_Builder
    CALL :ControlPanel_RoboCopyParameterConfiguration_CopyArgUpdate
    CALL :ClearBuffer 1
    GOTO :ControlPanel_RoboCopyParameterConfiguration
)
IF "%STDIN%" EQU "7" (
    CALL :ControlPanel_RoboCopyParameterConfiguration_Toggle_NoProgress
    CALL :ControlPanel_RoboCopyParameterConfiguration_Builder
    CALL :ControlPanel_RoboCopyParameterConfiguration_CopyArgUpdate
    CALL :ClearBuffer 1
    GOTO :ControlPanel_RoboCopyParameterConfiguration
)
IF "%STDIN%" EQU "8" (
    CALL :ControlPanel_RoboCopyParameterConfiguration_Toggle_ETA
    CALL :ControlPanel_RoboCopyParameterConfiguration_Builder
    CALL :ControlPanel_RoboCopyParameterConfiguration_CopyArgUpdate
    CALL :ClearBuffer 1
    GOTO :ControlPanel_RoboCopyParameterConfiguration
)
IF /I "%STDIN%" EQU "Retry" (
    CALL :ClearBuffer 1
    CALL :ControlPanel_RoboCopyParameterConfiguration_Retry
    CALL :ControlPanel_RoboCopyParameterConfiguration_Builder
    CALL :ControlPanel_RoboCopyParameterConfiguration_CopyArgUpdate
    CALL :ClearBuffer 1
    GOTO :ControlPanel_RoboCopyParameterConfiguration
)
IF /I "%STDIN%" EQU "Wait" (
    CALL :ClearBuffer 1
    CALL :ControlPanel_RoboCopyParameterConfiguration_Wait
    CALL :ControlPanel_RoboCopyParameterConfiguration_Builder
    CALL :ControlPanel_RoboCopyParameterConfiguration_CopyArgUpdate
    CALL :ClearBuffer 1
    GOTO :ControlPanel_RoboCopyParameterConfiguration
)
IF /I "%STDIN%" EQU "MT" (
    CALL :ClearBuffer 1
    CALL :ControlPanel_RoboCopyParameterConfiguration_Multithreading
    CALL :ControlPanel_RoboCopyParameterConfiguration_Builder
    CALL :ControlPanel_RoboCopyParameterConfiguration_CopyArgUpdate
    CALL :ClearBuffer 1
    GOTO :ControlPanel_RoboCopyParameterConfiguration
)
CALL :BadInput& GOTO :ControlPanel_RoboCopyParameterConfiguration



REM # =============================================================================================
REM # Documentation: This function toggles the value to enable or disable Network Restartable Mode (use Backup Mode if permission failure)
REM # =============================================================================================
:ControlPanel_RoboCopyParameterConfiguration_Toggle_RestartBackup
IF %ParametersRobocopy.RestartBackup% EQU True (
    SET ParametersRobocopy.RestartBackup=False
) ELSE (
    SET ParametersRobocopy.RestartBackup=True
)
GOTO :EOF



REM # =============================================================================================
REM # Documentation: This function toggles the value to enable or disable deep paths
REM # =============================================================================================
:ControlPanel_RoboCopyParameterConfiguration_Toggle_RestrictDeepPaths
IF %ParametersRobocopy.RestrictDeepPaths% EQU True (
    SET ParametersRobocopy.RestrictDeepPaths=False
) ELSE (
    SET ParametersRobocopy.RestrictDeepPaths=True
)
GOTO :EOF



REM # =============================================================================================
REM # Documentation: This function toggles the value to enable or disable Follow Junction Pointers (RECOMMEND TO DISABLE THIS!)
REM # =============================================================================================
:ControlPanel_RoboCopyParameterConfiguration_Toggle_NoJunctionPoints
IF %ParametersRobocopy.NoJunctionPoints% EQU True (
    SET ParametersRobocopy.NoJunctionPoints=False
) ELSE (
    SET ParametersRobocopy.NoJunctionPoints=True
)
GOTO :EOF



REM # =============================================================================================
REM # Documentation: This function toggles the value to enable or disable Verbose messages
REM # =============================================================================================
:ControlPanel_RoboCopyParameterConfiguration_Toggle_Verbose
IF %ParametersRobocopy.Verbose% EQU True (
    SET ParametersRobocopy.Verbose=False
) ELSE (
    SET ParametersRobocopy.Verbose=True
)
GOTO :EOF



REM # =============================================================================================
REM # Documentation: This function toggles the value to enable or disable displaying long file paths
REM # =============================================================================================
:ControlPanel_RoboCopyParameterConfiguration_Toggle_FullPath
IF %ParametersRobocopy.FullPath% EQU True (
    SET ParametersRobocopy.FullPath=False
) ELSE (
    SET ParametersRobocopy.FullPath=True
)
GOTO :EOF



REM # =============================================================================================
REM # Documentation: This function toggles the value to enable or disable displaying filesize in bytes
REM # =============================================================================================
:ControlPanel_RoboCopyParameterConfiguration_Toggle_BytesFileSize
IF %ParametersRobocopy.BytesFileSize% EQU True (
    SET ParametersRobocopy.BytesFileSize=False
) ELSE (
    SET ParametersRobocopy.BytesFileSize=True
)
GOTO :EOF



REM # =============================================================================================
REM # Documentation: This function toggles the value to enable or disable displaying Display Progress
REM # =============================================================================================
:ControlPanel_RoboCopyParameterConfiguration_Toggle_NoProgress
IF %ParametersRobocopy.NoProgress% EQU True (
    SET ParametersRobocopy.NoProgress=False
) ELSE (
    SET ParametersRobocopy.NoProgress=True
)
GOTO :EOF



REM # =============================================================================================
REM # Documentation: This function toggles the value to enable or disable displaying Estimated Time of Arrival
REM # =============================================================================================
:ControlPanel_RoboCopyParameterConfiguration_Toggle_ETA
IF %ParametersRobocopy.ETA% EQU True (
    SET ParametersRobocopy.ETA=False
) ELSE (
    SET ParametersRobocopy.ETA=True
)
GOTO :EOF



REM # =============================================================================================
REM # Documentation: Update the entire RobocopyArg variable.  This works by simply taking all of the supported parameters and updates the main holder variable
REM # =============================================================================================
:ControlPanel_RoboCopyParameterConfiguration_Builder
REM First, clear the entire variable by uninitializing it
SET RobocopyArg=
REM Build it again with the newer changes
IF %ParametersRobocopy.RestartBackup% EQU True (
    SET RobocopyArg=%RobocopyArg%/ZB 
)

IF %ParametersRobocopy.RestrictDeepPaths% EQU True (
    SET RobocopyArg=%RobocopyArg%/256 
)

IF %ParametersRobocopy.NoJunctionPoints% EQU True (
    SET RobocopyArg=%RobocopyArg%/XJ 
)

IF %ParametersRobocopy.Verbose% EQU True (
    SET RobocopyArg=%RobocopyArg%/V 
)

IF %ParametersRobocopy.FullPath% EQU True (
    SET RobocopyArg=%RobocopyArg%/FP 
)

IF %ParametersRobocopy.BytesFileSize% EQU True (
    SET RobocopyArg=%RobocopyArg%/BYTES 
)

IF %ParametersRobocopy.NoProgress% EQU True (
    SET RobocopyArg=%RobocopyArg%/NP 
)

IF %ParametersRobocopy.ETA% EQU True (
    SET RobocopyArg=%RobocopyArg%/ETA 
)

REM Statics; always true but values changes
REM ----
REM Maximum Number of Retries for each individual file failure
SET RobocopyArg=%RobocopyArg%/R:%ParametersRobocopy.Retry% 
REM Maximum Numer of Retry Waits
SET RobocopyArg=%RobocopyArg%/W:%ParametersRobocopy.Wait% 
REM Multithreading
SET RobocopyArg=%RobocopyArg%/MT:%ParametersRobocopy.Multithread% 
REM ----
GOTO :EOF



REM # =============================================================================================
REM # Documentation: If the user has the extCMD Robocopy as the primary mass copier, then update the CopyArg parameter.
REM # =============================================================================================
:ControlPanel_RoboCopyParameterConfiguration_CopyArgUpdate
IF %CopyMethod% EQU ROBOCOPY (
    SET "CopyArg=%RobocopyArg%"
)
GOTO :EOF




REM =====================================================================
REM Control Panel: Robocopy Behavior [Extended]
REM ----------------------------
REM This allows the user to change the behavioral of the external command 'Robocopy'.  This section merely adjusts special parameters and switches are to be used when using the command.
REM =====================================================================



REM # =============================================================================================
REM # Documentation: Maximum Wait time (seconds) before retrying
REM # =============================================================================================
:ControlPanel_RoboCopyParameterConfiguration_Wait
CALL :DashboardDisplay
ECHO Robocopy Wait Time
ECHO.
ECHO Description
ECHO %SeparatorSmall%
ECHO Wait time between failed retries
ECHO.
ECHO %Separator%
ECHO Enter a new value in terms of seconds of how long it should take to retry processing the requested data file.
ECHO Current Value: %ParametersRobocopy.Wait%
ECHO.
ECHO Other Options
ECHO %SeparatorSmall%
ECHO [X] Cancel
CALL :UserInput
GOTO :ControlPanel_RoboCopyParameterConfiguration_Wait_UserInput



REM # =============================================================================================
REM # Documentation: Inspect the users input
REM # =============================================================================================
:ControlPanel_RoboCopyParameterConfiguration_Wait_UserInput
IF /I "%STDIN%" EQU "X" GOTO :EOF
IF /I "%STDIN%" EQU "Cancel" GOTO :EOF
REM ----
REM Make sure that the users input is a legal integer
ECHO %STDIN%|FINDSTR /R /C:"^[0-9][0-9]*$" > NUL || (CALL :BadInput& GOTO :ControlPanel_RoboCopyParameterConfiguration_Wait)
REM Set the value if it passed
SET ParametersRobocopy.Wait=%STDIN%
GOTO :EOF



REM =============================================================================
REM =============================================================================
REM -----------------------------------------------------------------------------
REM =============================================================================
REM =============================================================================



REM # =============================================================================================
REM # Documentation: Maximum number of retries for each individual file
REM # =============================================================================================
:ControlPanel_RoboCopyParameterConfiguration_Retry
CALL :DashboardDisplay
ECHO Robocopy Maximum Retries
ECHO.
ECHO Description
ECHO %SeparatorSmall%
ECHO Number of Retries on failed copies.
ECHO.
ECHO %Separator%
ECHO Enter a new value of how many times Robocopy should retry to process the requested file before skipping it.
ECHO Current Value: %ParametersRobocopy.Retry%
ECHO.
ECHO Other Options
ECHO %SeparatorSmall%
ECHO [X] Cancel
CALL :UserInput
GOTO :ControlPanel_RoboCopyParameterConfiguration_Retry_UserInput



REM # =============================================================================================
REM # Documentation: Inspect the users input
REM # =============================================================================================
:ControlPanel_RoboCopyParameterConfiguration_Retry_UserInput
IF /I "%STDIN%" EQU "X" GOTO :EOF
IF /I "%STDIN%" EQU "Cancel" GOTO :EOF
REM ----
REM Make sure that the users input is a legal integer
ECHO %STDIN%|FINDSTR /R /C:"^[0-9][0-9]*$" > NUL || (CALL :BadInput& GOTO :ControlPanel_RoboCopyParameterConfiguration_Retry)
REM Set the value if it passed
SET ParametersRobocopy.Retry=%STDIN%
GOTO :EOF



REM =============================================================================
REM =============================================================================
REM -----------------------------------------------------------------------------
REM =============================================================================
REM =============================================================================



REM # =============================================================================================
REM # Documentation: How many threads should Robocopy process
REM # =============================================================================================
:ControlPanel_RoboCopyParameterConfiguration_Multithreading
CALL :DashboardDisplay
ECHO Robocopy Multithreading
ECHO.
ECHO Description
ECHO %SeparatorSmall%
ECHO Do multi-threaded copies with a number of [1-128] threads
ECHO.
ECHO %Separator%
ECHO Enter a new value of how many threads Robocopy should process [1 through 128 threads possible]
ECHO Current Value: %ParametersRobocopy.Multithread%
ECHO.
ECHO Other Options
ECHO %SeparatorSmall%
ECHO [X] Cancel
CALL :UserInput
GOTO :ControlPanel_RoboCopyParameterConfiguration_Multithreading_UserInput



REM # =============================================================================================
REM # Documentation: Inspect the users input
REM # =============================================================================================
:ControlPanel_RoboCopyParameterConfiguration_Multithreading_UserInput
IF /I "%STDIN%" EQU "X" GOTO :EOF
IF /I "%STDIN%" EQU "Cancel" GOTO :EOF
REM ----
REM Make sure that the users input is a legal integer
ECHO %STDIN%|FINDSTR /R /C:"^[0-9][0-9]*$" > NUL || (CALL :BadInput& GOTO :ControlPanel_RoboCopyParameterConfiguration_Multithreading)
REM ----
REM Make sure that the users input is a legal integer [1 -> 128]
IF %STDIN% GEQ 1 (
    IF %STDIN% LEQ 128 SET ParametersRobocopy.Multithread=%STDIN%& GOTO :EOF
)
CALL :BadInput& GOTO :ControlPanel_RoboCopyParameterConfiguration_Multithreading



REM # =============================================================================================
REM # Documentation: Update the ParametersRobocopy.Multithread variable.  This could have been done in the UserInput function, however to make things easier on myself [with how well nested conditional statements works in Batch Shell], lets just update the value here and properly process it through without mistakenly hitting a few bumps.
REM # =============================================================================================
:ControlPanel_RoboCopyParameterConfiguration_Multithreading_Update
SET ParametersRobocopy.Multithread=%STDIN%
GOTO :EOF




REM =====================================================================
REM Control Panel: Terminal Sounds
REM ----------------------------
REM Within the terminal, it is possible to have a bell [or alarm] signal.  This feature gives the ability to send an alarm to the user if an event happens.  Modules _may_ treat this differently, this is not core specific but module specific.
REM =====================================================================


REM # =============================================================================================
REM # Documentation: This function is a translator which takes the variable's value and stores a nicer value name to a temporary working variable.
REM # =============================================================================================
:ControlPanel_TerminalSound_Translator
IF %UseBell% EQU 0 SET ProcessVarA=Disabled& GOTO :EOF
IF %UseBell% EQU 1 SET ProcessVarA=Enabled [Notify for all notifications]& GOTO :EOF
IF %UseBell% EQU 2 SET ProcessVarA=Enabled [Notify only for errors]
GOTO :EOF



REM # =============================================================================================
REM # Documentation: Terminal sound menu
REM # =============================================================================================
:ControlPanel_TerminalSound
CALL :DashboardDisplay
REM Translate the actual variable value into another variable with a nicer value.
CALL :ControlPanel_TerminalSound_Translator
ECHO Terminal Sound Settings
ECHO.
ECHO Description
ECHO %SeparatorSmall%
ECHO When the program runs into a critical state or an event occurs, this program can alarm the user by supplying a 'Beep' noise.  These notifications, however, can only be played through the system's speakers and not the internal PC Speaker.
ECHO.
ECHO Default Value: Sounds for either successful or failed operations
ECHO Sounds is currently: %ProcessVarA%
ECHO %Separator%
ECHO Notify when:
ECHO [1] Notify for all notifications
ECHO [2] Notify only for errors
ECHO [3] Disabled
ECHO.
ECHO Other Options
ECHO %SeparatorSmall%
ECHO [X] Cancel
CALL :UserInput
GOTO :ControlPanel_TerminalSound_UserInput



REM # =============================================================================================
REM # Documentation: Inspect the users input
REM # =============================================================================================
:ControlPanel_TerminalSound_UserInput
IF /I "%STDIN%" EQU "X" GOTO :EOF
IF /I "%STDIN%" EQU "Cancel" GOTO :EOF

IF "%STDIN%" EQU "1" (
    CALL :ControlPanel_TerminalSound_Toggle All
    CALL :ClearBuffer 1
    GOTO :ControlPanel_TerminalSound
)
IF "%STDIN%" EQU "2" (
    CALL :ControlPanel_TerminalSound_Toggle Error
    CALL :ClearBuffer 1
    GOTO :ControlPanel_TerminalSound
)
IF "%STDIN%" EQU "3" (
    CALL :ControlPanel_TerminalSound_Toggle Off
    CALL :ClearBuffer 1
    GOTO :ControlPanel_TerminalSound
)
CALL :BadInput& GOTO :ControlPanel_TerminalSound



REM # =============================================================================================
REM # Parameters: [{String} SettingType]
REM # Documentation: Adjust the variable value as requested by the user.
REM # =============================================================================================
:ControlPanel_TerminalSound_Toggle
IF %1 EQU All (
    REM Always send an alarm when an event happens
    SET UseBell=1
    GOTO :EOF
)
IF %1 EQU Error (
    REM Send an alarm when an error event happens
    SET UseBell=2
    GOTO :EOF
)
IF %1 EQU Off (
    REM Disallow the entire feature.
    SET UseBell=0
    GOTO :EOF
)




REM =====================================================================
REM Control Panel: Directory Setup
REM ----------------------------
REM This section allows the user to customize the directory or file location of resources that is supported in the program.  This will allow compatible modules to easily take advantage of such resources that can be detect and supported without having to add more redundancy code or making it inconvenient to the user.
REM =====================================================================


REM # =============================================================================================
REM # Documentation: Main directory menu
REM # =============================================================================================
:ControlPanel_DirectorySetup
CALL :DashboardDisplay
REM Check see if the resources exists
CALL :EnvironmentSetup_Switch CheckExternalResources
ECHO Directory Setup
ECHO.
ECHO Description
ECHO %SeparatorSmall%
ECHO In order to compile other projects, there is in need of necessary prerequisites.  Not all of the listed tools maybe required, to be sure what you need in order to compile a project - refer to documentation.
ECHO.
ECHO Choose the following to modify:
ECHO %Separator%
ECHO [1] Microsoft Visual Studio Category
ECHO [2] Microsoft HTML Workshop
ECHO      Detected: [ %Detect_MSHTMLWorkShop% ]
ECHO [3] MinGW
ECHO      Detected: [ %Detect_MinGW% ]
ECHO [4] 7Zip
ECHO      Detected: [ %Detect_7Zip% ]
ECHO [5] Inno Setup
ECHO      Detected: [ %Detect_InnoSetup% ]
ECHO [6] Python v3.x
ECHO      Detected: [ %Detect_Python3% ]
ECHO [7] Python v2.7.x
ECHO      Detected: [ %Detect_Python2% ]
ECHO.
ECHO Other Options
ECHO %SeparatorSmall%
ECHO [X] Cancel
CALL :UserInput
GOTO :ControlPanel_DirectorySetup_UserInput



REM # =============================================================================================
REM # Documentation: Inspect the user's input
REM # =============================================================================================
:ControlPanel_DirectorySetup_UserInput
IF /I "%STDIN%" EQU "X" GOTO :EOF
IF /I "%STDIN%" EQU "Cancel" GOTO :EOF

IF "%STDIN%" EQU "1" (
    CALL :ClearBuffer 1
    CALL :ControlPanel_DirectorySetup_MSVisualStudio
    CALL :ClearBuffer 1
    GOTO :ControlPanel_DirectorySetup
)
IF "%STDIN%" EQU "2" (
    CALL :ClearBuffer 1
    CALL :ControlPanel_DirectorySetup_ChangePathCommon "HTML Workshop" "%PathMSHTMLWorkShop%" "Microsoft HTML Workshop path"
    CALL :ClearBuffer 1
    GOTO :ControlPanel_DirectorySetup
)
IF "%STDIN%" EQU "3" (
    CALL :ClearBuffer 1
    CALL :ControlPanel_DirectorySetup_ChangePathCommon "MinGW" "%PathMinGW%" "MinGW path"
    CALL :ClearBuffer 1
    GOTO :ControlPanel_DirectorySetup
)
IF "%STDIN%" EQU "4" (
    CALL :ClearBuffer 1
    CALL :ControlPanel_DirectorySetup_ChangePathCommon "Seven Zip" "%Path7Zip%" "Seven Zip path"
    CALL :ClearBuffer 1
    GOTO :ControlPanel_DirectorySetup
)
IF "%STDIN%" EQU "5" (
    CALL :ClearBuffer 1
    CALL :ControlPanel_DirectorySetup_ChangePathCommon "Inno Installer" "%PathInnoSetup%" "Inno Installer path"
    CALL :ClearBuffer 1
    GOTO :ControlPanel_DirectorySetup
)
IF "%STDIN%" EQU "6" (
    CALL :ClearBuffer 1
    CALL :ControlPanel_DirectorySetup_ChangePathCommon "Python3" "%PathPython3%" "Python v3 path"
    CALL :ClearBuffer 1
    GOTO :ControlPanel_DirectorySetup
)
IF "%STDIN%" EQU "7" (
    CALL :ClearBuffer 1
    CALL :ControlPanel_DirectorySetup_ChangePathCommon "Python2" "%PathPython2%" "Python v2.7.x path"
    CALL :ClearBuffer 1
    GOTO :ControlPanel_DirectorySetup
)
CALL :BadInput& GOTO :ControlPanel_DirectorySetup



REM =============================================================================
REM -----------------------------------------------------------------------------
REM =============================================================================



REM # =============================================================================================
REM # Documentation: Microsoft Visual Studio Directory setting menu
REM # =============================================================================================
:ControlPanel_DirectorySetup_MSVisualStudio
CALL :DashboardDisplay
REM Check to see if the Microsoft Visual Studio products can be detected.
CALL :EnvironmentSetup_Switch CheckExternalResources
ECHO Directories: Microsoft Visual Studio Versions
ECHO %SeparatorSmall%
ECHO [1] Visual Studio 2005
ECHO      Detected: [ %Detect_MSVS80COMMTOOLS% ]
ECHO [2] Visual Studio 2008
ECHO      Detected: [ %Detect_MSVS90COMMTOOLS% ]
ECHO [3] Visual Studio 2010
ECHO      Detected: [ %Detect_MSVS100COMMTOOLS% ]
ECHO [4] Visual Studio 2012
ECHO      Detected: [ %Detect_MSVS110COMMTOOLS% ]
ECHO [5] Visual Studio 2013
ECHO      Detected: [ %Detect_MSVS120COMMTOOLS% ]
ECHO.
ECHO Other Options
ECHO %SeparatorSmall%
ECHO [X] Cancel
CALL :UserInput
GOTO :ControlPanel_DirectorySetup_MSVisualStudio_UserInput



REM # =============================================================================================
REM # Documentation: Inspect the user's input
REM # =============================================================================================
:ControlPanel_DirectorySetup_MSVisualStudio_UserInput
IF /I "%STDIN%" EQU "X" GOTO :EOF
IF /I "%STDIN%" EQU "Cancel" GOTO :EOF
IF /I "%STDIN%" EQU "Exit" GOTO :EOF

IF "%STDIN%" EQU "1" (
    CALL :ClearBuffer 1
    CALL :ControlPanel_DirectorySetup_ChangePathCommon "Visual Studio 2005" "%PathMSVS2005%" "Microsoft Visual Studio 2005 [Common Tools] path"
    CALL :ClearBuffer 1
    GOTO :ControlPanel_DirectorySetup_MSVisualStudio
)
IF "%STDIN%" EQU "2" (
    CALL :ClearBuffer 1
    CALL :ControlPanel_DirectorySetup_ChangePathCommon "Visual Studio 2008" "%PathMSVS2008%" "Microsoft Visual Studio 2008 [Common Tools] path"
    CALL :ClearBuffer 1
    GOTO :ControlPanel_DirectorySetup_MSVisualStudio
)
IF "%STDIN%" EQU "3" (
    CALL :ClearBuffer 1
    CALL :ControlPanel_DirectorySetup_ChangePathCommon "Visual Studio 2010" "%PathMSVS2010%" "Microsoft Visual Studio 2010 [Common Tools] path"
    CALL :ClearBuffer 1
    GOTO :ControlPanel_DirectorySetup_MSVisualStudio
)
IF "%STDIN%" EQU "4" (
    CALL :ClearBuffer 1
    CALL :ControlPanel_DirectorySetup_ChangePathCommon "Visual Studio 2012" "%PathMSVS2012%" "Microsoft Visual Studio 2012 [Common Tools] path"
    CALL :ClearBuffer 1
    GOTO :ControlPanel_DirectorySetup_MSVisualStudio
)
IF "%STDIN%" EQU "5" (
    CALL :ClearBuffer 1
    CALL :ControlPanel_DirectorySetup_ChangePathCommon "Visual Studio 2013" "%PathMSVS2013%" "Microsoft Visual Studio 2013 [Common Tools] path"
    CALL :ClearBuffer 1
    GOTO :ControlPanel_DirectorySetup_MSVisualStudio
)
CALL :BadInput& GOTO :ControlPanel_DirectorySetup_MSVisualStudio



REM =============================================================================
REM -----------------------------------------------------------------------------
REM =============================================================================



REM # =============================================================================================
REM # Parameters: [{string} ProductName] [{string} FilePath] [{string} LongString] 
REM # Documentation: When inputting a new file location, this function is going to be called.  This will manage all of the external resource file locations and will set the file path - only if the detection is able to locate the file or directory.
REM # =============================================================================================
:ControlPanel_DirectorySetup_ChangePathCommon
CALL :DashboardDisplay
REM Does the file location exists?
CALL :ControlPanel_DirectorySetup_Finder_Status "%~2"
CALL :ControlPanel_DirectorySetup_ChangePathCommon_FixUninitializedVariables "%~2"
ECHO Modifying: %~3
ECHO %SeparatorSmall%
ECHO Current location:
ECHO    %ProcessVarB%
ECHO Detection Status:
ECHO    %ProcessVarA%
ECHO.
CALL :ControlPanel_DirectorySetup_CommonSetupSubMenuDisplay
CALL :UserInput
REM Inspect the users input; does the file or directory exists?
CALL :ControlPanel_DirectorySetup_Finder "%~1" "%STDIN%"
REM If the user wishes to abort
IF %ERRORLEVEL% EQU 2 GOTO :EOF
IF %ERRORLEVEL% EQU 1 (
    CALL :ClearBuffer 1
    GOTO :ControlPanel_DirectorySetup_ChangePathCommon
)
    IF "%~1" EQU "Visual Studio 2005" SET "PathMSVS2005=%STDIN%"& CALL :ClearBuffer 1& GOTO :EOF
    IF "%~1" EQU "Visual Studio 2008" SET "PathMSVS2008=%STDIN%"& CALL :ClearBuffer 1& GOTO :EOF
    IF "%~1" EQU "Visual Studio 2010" SET "PathMSVS2010=%STDIN%"& CALL :ClearBuffer 1& GOTO :EOF
    IF "%~1" EQU "Visual Studio 2012" SET "PathMSVS2012=%STDIN%"& CALL :ClearBuffer 1& GOTO :EOF
    IF "%~1" EQU "Visual Studio 2013" SET "PathMSVS2013=%STDIN%"& CALL :ClearBuffer 1& GOTO :EOF
    IF "%~1" EQU "HTML Workshop" SET "PathMSHTMLWorkShop=%STDIN%"& CALL :ClearBuffer 1& GOTO :EOF
    IF "%~1" EQU "MinGW" SET "PathMinGW=%STDIN%"& CALL :ClearBuffer 1& GOTO :EOF
    IF "%~1" EQU "Seven Zip" SET "Path7Zip=%STDIN%"& CALL :ClearBuffer 1& GOTO :EOF
    IF "%~1" EQU "Inno Installer" SET "PathInnoSetup=%STDIN%"& CALL :ClearBuffer 1& GOTO :EOF
    IF "%~1" EQU "Python3" SET "PathPython3=%STDIN%"& CALL :ClearBuffer 1& GOTO :EOF
    IF "%~1" EQU "Python2" SET "PathPython2=%STDIN%"& CALL :ClearBuffer 1& GOTO :EOF



REM # =============================================================================================
REM # Parameters: [{string} FilePath]
REM # Documentation: If the variable is uninitialized during the initialization phase (such as not having Microsoft Visual Studio 2005 or it's environment variables), then properly display the result on the screen instead of the standalone ECHO message.
REM # =============================================================================================
:ControlPanel_DirectorySetup_ChangePathCommon_FixUninitializedVariables
REM Cache the value so we can determine if it was ever defined at all
SET "ProcessVarB=%~1"
REM Determine how the output is going to be on the screen
IF NOT DEFINED ProcessVarB (
    SET ProcessVarB=!ERROR!
)
GOTO :EOF



REM # =============================================================================================
REM # Parameters: [{string} ProductName] [{string} FilePath]
REM # Documentation: Inspect the users input; if the directory or file exists - then report back a success, if the file or directory does not exist - report an error.  Also manage if the user wishes to cancel or revert a setting.
REM # =============================================================================================
:ControlPanel_DirectorySetup_Finder
REM If incase the user wishes to abort
IF /I "%STDIN%" EQU "X" CALL :ClearBuffer 1& EXIT /B 2
IF /I "%STDIN%" EQU "Cancel" CALL :ClearBuffer 1& EXIT /B 2
IF /I "%STDIN%" EQU "Exit" CALL :ClearBuffer 1& EXIT /B 2
REM Allow the user to restore a variable value target to its default setting.
IF /I "%STDIN%" EQU "Restore" CALL :ControlPanel_DirectorySetup_RestoreDefauts "%~1"& EXIT /B 2

REM The user must specify the _exact_ file.
REM %1 = Program Name or File Name
REM %2 = Program Path Variable or STDIN
IF EXIST "%STDIN%" (
    EXIT /B 0
) ELSE (
    ECHO.
    ECHO !ERR: Could not find the file or program ^'%~1^'
    ECHO       at location: %~2
    PAUSE
    EXIT /B 1
)



REM # =============================================================================================
REM # Parameters: [{string} ProductName]
REM # Documentation: This function will restore the requested target value; this specifically will call the Environment Setup to properly restore the value.
REM # =============================================================================================
:ControlPanel_DirectorySetup_RestoreDefauts
CALL :EnvironmentSetup_Switch PathRestore "%~1"
GOTO :EOF



REM # =============================================================================================
REM # Parameters: [{string} FilePath]
REM # Documentation: This function checks to make sure that the target actually exists.  This will only change the working variable's value that will be used to print the detection status.
REM # =============================================================================================
:ControlPanel_DirectorySetup_Finder_Status
IF EXIST "%~1" (
    SET ProcessVarA=Found!
    GOTO :EOF
) ELSE (
    SET ProcessVarA=Not Found!
    GOTO :EOF
)



REM # =============================================================================================
REM # Documentation: This function merely contains the common information that is used when inputting a new file location.
REM # =============================================================================================
:ControlPanel_DirectorySetup_CommonSetupSubMenuDisplay
ECHO Other Options:
ECHO %SeparatorSmall%
ECHO [Cancel] [Restore]
ECHO.
ECHO  Notes:
ECHO   + Do NOT use quotes
ECHO       For Example, do _NOT_: "C:\Users\Admin\Travra.ps"
ECHO                              ^^                        ^^
ECHO   + Use Absolute Path
ECHO       For Example: C:^\Program Files\RequestedProgram.exe
ECHO   + Include specific filename including file extension
ECHO       For Example: ExecutableFile.exe or MyShellScript.sh
ECHO                                   ^^                   ^^
ECHO.
ECHO Enter new direct location and specific filename
GOTO :EOF




REM =====================================================================
REM Control Panel: General Program Configuration
REM ----------------------------
REM This section houses generalized program settings that the user is able to manipulate.
REM =====================================================================


REM # =============================================================================================
REM # Documentation: Advanced settings menu for General Program Configuration
REM # =============================================================================================
:ControlPanel_GeneralProgramConfiguration
CALL :DashboardDisplay
ECHO General Program Configuration Menu
ECHO.
ECHO Select the following options:
ECHO %Separator%
ECHO [1] Toggle Explorer.exe Calls
ECHO [2] General Priority
ECHO [3] Toggle Dashboard Tool
ECHO [4] Toggle Module Window Sharing
ECHO.
ECHO Other Options
ECHO %SeparatorSmall%
ECHO [X] Exit
CALL :UserInput
GOTO :ControlPanel_GeneralProgramConfiguration_UserInput



REM # =============================================================================================
REM # Documentation: Inspect the users input
REM # =============================================================================================
:ControlPanel_GeneralProgramConfiguration_UserInput
IF "%STDIN%" EQU "1" GOTO :ControlPanel_GeneralProgramConfiguration_Choice_WindowsExplorer
IF "%STDIN%" EQU "2" GOTO :ControlPanel_GeneralProgramConfiguration_Choice_Priority
IF "%STDIN%" EQU "3" GOTO :ControlPanel_GeneralProgramConfiguration_Choice_DashboardViewerTool
IF "%STDIN%" EQU "4" GOTO :ControlPanel_GeneralProgramConfiguration_Choice_ModuleWindowSharing
IF /I "%STDIN%" EQU "X" GOTO :EOF
IF /I "%STDIN%" EQU "Exit" GOTO :EOF
CALL :BadInput& GOTO :ControlPanel_GeneralProgramConfiguration



REM # =============================================================================================
REM # Documentation: Call the Windows Explorer settings.
REM # =============================================================================================
:ControlPanel_GeneralProgramConfiguration_Choice_WindowsExplorer
CALL :ClearBuffer 1
CALL :ControlPanel_WindowsExplorer
CALL :ClearBuffer 1
GOTO :ControlPanel_GeneralProgramConfiguration



REM # =============================================================================================
REM # Documentation:  Call the Windows process priority level.
REM # =============================================================================================
:ControlPanel_GeneralProgramConfiguration_Choice_Priority
CALL :ClearBuffer 1
CALL :ControlPanel_Priority
CALL :ClearBuffer 1
GOTO :ControlPanel_GeneralProgramConfiguration



REM # =============================================================================================
REM # Documentation: Enable or disable the Dashboard Viewer tool.
REM # =============================================================================================
:ControlPanel_GeneralProgramConfiguration_Choice_DashboardViewerTool
CALL :ClearBuffer 1
CALL :ControlPanel_DashboardTool
CALL :ClearBuffer 1
GOTO :ControlPanel_GeneralProgramConfiguration



REM # =============================================================================================
REM # Documentation: Enable or disable the modules being executed in the same window as the core.
REM # =============================================================================================
:ControlPanel_GeneralProgramConfiguration_Choice_ModuleWindowSharing
CALL :ClearBuffer 1
CALL :ControlPanel_ModuleExecuteSharingWindow
CALL :ClearBuffer 1
GOTO :ControlPanel_GeneralProgramConfiguration




REM =====================================================================
REM Control Panel: Windows Explorer
REM ----------------------------
REM This section allows the user to allow or disallow the programs to utilize the Windows Explorer functionality.  This ultimately can be used to open new windows into environment and also can highlight objects within a new window.
REM =====================================================================


REM # =============================================================================================
REM # Documentation: This function is a translator which takes the variable's value and stores a nicer value name to a temporary working variable.
REM # =============================================================================================
:ControlPanel_WindowsExplorer_Translator
IF %CallExplorerCommands% EQU True SET ProcessVarA=Enable& GOTO :EOF
IF %CallExplorerCommands% EQU False SET ProcessVarA=Disable
GOTO :EOF



REM # =============================================================================================
REM # Documentation: Explorer menu
REM # =============================================================================================
:ControlPanel_WindowsExplorer
CALL :DashboardDisplay
REM Translate the actual variable value into another variable with a nicer value.
CALL :ControlPanel_WindowsExplorer_Translator
ECHO Windows Explorer Settings
ECHO.
ECHO Description
ECHO %SeparatorSmall%
ECHO For certain operations or events, this program might call on Windows 'explorer.exe' for certain operations.  Most simply, in terms of operations could be, opening a new window focus, highlighting objects, and small various tasks.
ECHO.
ECHO Default Value: Enable
ECHO Calling Explorer is Currently: %ProcessVarA%
ECHO %Separator%
ECHO [1] Disable
ECHO [2] Enable
ECHO.
ECHO Other Options
ECHO %SeparatorSmall%
ECHO [X] Cancel
CALL :UserInput
GOTO :ControlPanel_WindowsExplorer_UserInput



REM # =============================================================================================
REM # Documentation: Inspect the users input
REM # =============================================================================================
:ControlPanel_WindowsExplorer_UserInput
IF /I "%STDIN%" EQU "X" GOTO :EOF
IF /I "%STDIN%" EQU "Cancel" GOTO :EOF

IF "%STDIN%" EQU "1" (
    CALL :ControlPanel_WindowsExplorer_Toggle Disable
    CALL :ClearBuffer 1
    GOTO :ControlPanel_WindowsExplorer
)
IF "%STDIN%" EQU "2" (
    CALL :ControlPanel_WindowsExplorer_Toggle Enable
    CALL :ClearBuffer 1
    GOTO :ControlPanel_WindowsExplorer
)
CALL :BadInput& GOTO :ControlPanel_WindowsExplorer



REM # =============================================================================================
REM # Parameters: [{Bool} SettingType]
REM # Documentation: Adjust the variable value as requested by the user.
REM # =============================================================================================
:ControlPanel_WindowsExplorer_Toggle
IF %1 EQU Enable (
    SET CallExplorerCommands=True
    GOTO :EOF
) ELSE (
    SET CallExplorerCommands=False
    GOTO :EOF
)




REM =====================================================================
REM Control Panel: Priority Level [Kernel Throttle Request]
REM ----------------------------
REM When external commands are being processed, they are normally set through the kernel as 'Normal' priority level; however, it is possible to change that priority leveling to either a higher level or lower.
REM Refer to this documentation for more information: http://en.wikipedia.org/wiki/Scheduling_(computing)
REM For more details: http://msdn.microsoft.com/en-us/library/windows/desktop/ms685100(v=vs.85).aspx
REM =====================================================================


REM # =============================================================================================
REM # Documentation: Translate the stored value to a working variable.  This will contain a nicer value that will be displayed on the terminal screen.
REM # =============================================================================================
:ControlPanel_Priority_Translator
IF /I "%PriorityGeneral%" EQU "Low" (
    SET ProcessVarA=Low
    GOTO :EOF
)
IF /I "%PriorityGeneral%" EQU "BelowNormal" (
    SET ProcessVarA=Below Normal
    GOTO :EOF
)
IF /I "%PriorityGeneral%" EQU "Normal" (
    SET ProcessVarA=Normal
    GOTO :EOF
)
IF /I "%PriorityGeneral%" EQU "AboveNormal" (
    SET ProcessVarA=Above Normal
    GOTO :EOF
)
IF /I "%PriorityGeneral%" EQU "High" (
    SET ProcessVarA=High
    GOTO :EOF
)
IF /I "%PriorityGeneral%" EQU "RealTime" (
    SET ProcessVarA=LUDICROUS SPEED!
    GOTO :EOF
)



REM # =============================================================================================
REM # Documentation: Priority throttling menu
REM # =============================================================================================
:ControlPanel_Priority
CALL :DashboardDisplay
CALL :ControlPanel_Priority_Translator
ECHO Program Priority Settings
ECHO.
ECHO Description
ECHO %SeparatorSmall%
ECHO It is possible to generally enforce all operations to work either faster or slower, but however, be warned that the faster may not always be better - generally.  For more details, please read Kernel Priority documentation for Windows.
ECHO.
ECHO Default Value: Normal
ECHO Priority Level is Currently: %ProcessVarA%
ECHO %Separator%
ECHO [1] Low
ECHO [2] Below Normal
ECHO [3] Normal
ECHO [4] Above Normal
ECHO [5] High
ECHO [6] LUDICROUS SPEED!
ECHO.
ECHO Other Options
ECHO %SeparatorSmall%
ECHO [X] Cancel
CALL :UserInput
GOTO :ControlPanel_Priority_UserInput



REM # =============================================================================================
REM # Documentation: Inspect the users input
REM # =============================================================================================
:ControlPanel_Priority_UserInput
IF /I "%STDIN%" EQU "X" GOTO :EOF
IF /I "%STDIN%" EQU "Cancel" GOTO :EOF

IF "%STDIN%" EQU "1" (
    CALL :ControlPanel_Priority_Switch Low
    CALL :ClearBuffer 1
    GOTO :ControlPanel_Priority
)
IF "%STDIN%" EQU "2" (
    CALL :ControlPanel_Priority_Switch BelowNormal
    CALL :ClearBuffer 1
    GOTO :ControlPanel_Priority
)
IF "%STDIN%" EQU "3" (
    CALL :ControlPanel_Priority_Switch Normal
    CALL :ClearBuffer 1
    GOTO :ControlPanel_Priority
)
IF "%STDIN%" EQU "4" (
    CALL :ControlPanel_Priority_Switch AboveNormal
    CALL :ClearBuffer 1
    GOTO :ControlPanel_Priority
)
IF "%STDIN%" EQU "5" (
    CALL :ControlPanel_Priority_Switch High
    CALL :ClearBuffer 1
    GOTO :ControlPanel_Priority
)
IF "%STDIN%" EQU "6" (
    CALL :ControlPanel_Priority_Switch RealTime
    CALL :ClearBuffer 1
    GOTO :ControlPanel_Priority
)
CALL :BadInput& GOTO :ControlPanel_Priority



REM # =============================================================================================
REM # Parameters: [{String} SettingType]
REM # Documentation: Adjust the variable value as requested by the user.
REM # =============================================================================================
:ControlPanel_Priority_Switch
IF %1 EQU Low (
    SET PriorityGeneral=LOW
    GOTO :EOF
)
IF %1 EQU BelowNormal (
    SET PriorityGeneral=BELOWNORMAL
    GOTO :EOF
)
IF %1 EQU Normal (
    SET PriorityGeneral=NORMAL
    GOTO :EOF
)
IF %1 EQU AboveNormal (
    SET PriorityGeneral=ABOVENORMAL
    GOTO :EOF
)
IF %1 EQU High (
    SET PriorityGeneral=HIGH
    GOTO :EOF
)
IF %1 EQU RealTime (
    SET PriorityGeneral=REALTIME
    GOTO :EOF
)




REM =====================================================================
REM Control Panel: 7Zip Generalized Settings
REM ----------------------------
REM Within this section houses all of the 7Zip settings.
REM =====================================================================


REM # =============================================================================================
REM # Documentation: Translate the stored value to a working variable.  This will contain a nicer value that will be displayed on the terminal screen.
REM # =============================================================================================
:ControlPanel_7Zip_Password_Translator
IF "%SevZipKey%" EQU "" (
    SET ProcessVarA=Not Set!
    GOTO :EOF
) ELSE (
    SET ProcessVarA=Set!
    GOTO :EOF
)



REM # =============================================================================================
REM # Documentation: This function is the main password setting menu.
REM # =============================================================================================
:ControlPanel_7Zip_Password
CALL :DashboardDisplay
REM Translate the value to a nicer value
CALL :ControlPanel_7Zip_Password_Translator
ECHO 7Zip Password Settings
ECHO.
ECHO Description
ECHO %SeparatorSmall%
ECHO This allows the user to setup a password key for an archive file.
ECHO.
ECHO Password is currently: %ProcessVarA%
ECHO %Separator%
ECHO [Set] Change key
ECHO [Cancel]
CALL :UserInput
GOTO :ControlPanel_7Zip_Password_UserInput



REM # =============================================================================================
REM # Documentation: Inspect the user's input
REM # =============================================================================================
:ControlPanel_7Zip_Password_UserInput
IF /I "%STDIN%" EQU "Cancel" GOTO :EOF

IF /I "%STDIN%" EQU "Set" (
    REM Set a new key
    CALL :ControlPanel_7Zip_Password_Manager
    CALL :ClearBuffer 1
    GOTO :ControlPanel_7Zip_Password
)
CALL :BadInput& GOTO :ControlPanel_7Zip_Password



REM # =============================================================================================
REM # Documentation: Manage the entire password creation procedure process.
REM # =============================================================================================
:ControlPanel_7Zip_Password_Manager
REM Clear the STDIN variable
CALL :ClearSTDIN
REM Fetch the initial key first
CALL :ControlPanel_7Zip_Password_Prompt NewKey
CALL :ControlPanel_7Zip_Password_ManageInput Key
    IF %ERRORLEVEL% GTR 0 GOTO :EOF
REM Clear the STDIN variable
CALL :ClearSTDIN
REM Fetch the confirmation key
CALL :ControlPanel_7Zip_Password_Prompt 1
CALL :ControlPanel_7Zip_Password_ManageInput Confirm
    IF %ERRORLEVEL% GTR 0 GOTO :EOF
REM Clear the STDIN variable
CALL :ClearSTDIN
CALL :ControlPanel_7Zip_Password_CheckInput
REM Clear the working variables that held the key
CALL :ControlPanel_7Zip_Password_ThrashWorkingVariables
GOTO :EOF



REM # =============================================================================================
REM # Parameters: [{string} ModeType]
REM # Documentation: Prompt the user to enter the password.
REM # =============================================================================================
:ControlPanel_7Zip_Password_Prompt
ECHO.
IF %1 EQU NewKey (
    REM Create a new key into memory.
    ECHO Enter password:
    CALL :UserInput
    GOTO :EOF
) ELSE (
    REM Confirm that the key was entered successfully.
    ECHO Confirm password:
    CALL :UserInput
    GOTO :EOF
)



REM # =============================================================================================
REM # Parameters: [{string} ModeType]
REM # Documentation: Store the input into the temporary working variables.
REM # =============================================================================================
:ControlPanel_7Zip_Password_ManageInput
IF /I "%STDIN%" EQU "Cancel" EXIT /B 1

IF %1 EQU Key (
    SET "ProcessVarA=%STDIN%"
    EXIT /B 0
) ELSE (
    SET "ProcessVarB=%STDIN%"
    EXIT /B 0
)



REM # =============================================================================================
REM # Documentation: This function checks the two passwords (that were temporarily stored in the working variables) to be sure that they exactly match, this is case sensitive!
REM # =============================================================================================
:ControlPanel_7Zip_Password_CheckInput
REM Compare the two inputs
IF "%ProcessVarA%" EQU "%ProcessVarB%" (
    CALL :ControlPanel_7Zip_Password_Result 0
    GOTO :EOF
) ELSE (
    CALL :ControlPanel_7Zip_Password_Result 1
    GOTO :EOF
)



REM # =============================================================================================
REM # Parameters: [{bool} Status]
REM # Documentation: This function will set the new key into the SevZipKey variable - if there was a match (determined by the parameter).  If the key did not match, then print an error.
REM # =============================================================================================
:ControlPanel_7Zip_Password_Result
IF %1 EQU 0 (
    REM Key was successfully set
    SET "SevZipKey=%ProcessVarA%"
    GOTO :EOF
) ELSE (
    ECHO !ERR: Mismatch key!
    PAUSE
    GOTO :EOF
)



REM # =============================================================================================
REM # Documentation: This function will thrash the working variables that held the password that was inputted by the user.
REM # =============================================================================================
:ControlPanel_7Zip_Password_ThrashWorkingVariables
REM Uninitialize them
SET ProcessVarA=
SET ProcessVarB=
GOTO :EOF



REM =============================================================================
REM =============================================================================
REM -----------------------------------------------------------------------------
REM =============================================================================
REM =============================================================================



REM # =============================================================================================
REM # Documentation: Archive Format menu
REM # =============================================================================================
:ControlPanel_7Zip_ArchiveFormat
CALL :DashboardDisplay
ECHO 7Zip Archive Format Settings
ECHO.
ECHO Description
ECHO %SeparatorSmall%
ECHO When creating an archive file, 7zip software allows the user to utilize different formats.  These formats differ in compression and general uses, though the most commonly used is Zip and 7Z.
ECHO.
ECHO Default Value: 7Z
ECHO Archive Format is currently: %SevZipArchiveFormat%
ECHO %Separator%
ECHO [1] Zip
ECHO [2] GZip
ECHO [3] BZip2
ECHO [4] 7Z
ECHO [5] XZ
ECHO.
ECHO Other Options
ECHO %SeparatorSmall%
ECHO [X] Cancel
CALL :UserInput
GOTO :ControlPanel_7Zip_ArchiveFormat_UserInput



REM # =============================================================================================
REM # Documentation: Inspect the user's input.
REM # =============================================================================================
:ControlPanel_7Zip_ArchiveFormat_UserInput
IF /I "%STDIN%" EQU "Cancel" GOTO :EOF
IF /I "%STDIN%" EQU "X" GOTO :EOF

IF "%STDIN%" EQU "1" (
    CALL :ControlPanel_7Zip_ArchiveFormat_Switch Zip
    CALL :ClearBuffer 1
    GOTO :ControlPanel_7Zip_ArchiveFormat
)
IF "%STDIN%" EQU "2" (
    CALL :ControlPanel_7Zip_ArchiveFormat_Switch GZip
    CALL :ClearBuffer 1
    GOTO :ControlPanel_7Zip_ArchiveFormat
)
IF "%STDIN%" EQU "3" (
    CALL :ControlPanel_7Zip_ArchiveFormat_Switch BZip2
    CALL :ClearBuffer 1
    GOTO :ControlPanel_7Zip_ArchiveFormat
)
IF "%STDIN%" EQU "4" (
    CALL :ControlPanel_7Zip_ArchiveFormat_Switch SevenZip
    CALL :ClearBuffer 1
    GOTO :ControlPanel_7Zip_ArchiveFormat
)
IF "%STDIN%" EQU "5" (
    CALL :ControlPanel_7Zip_ArchiveFormat_Switch XZ
    CALL :ClearBuffer 1
    GOTO :ControlPanel_7Zip_ArchiveFormat
)
CALL :BadInput& GOTO :ControlPanel_7Zip_ArchiveFormat



REM # =============================================================================================
REM # Parameters: [{String} ArchiveType]
REM # Documentation: Set the primary archive format and file extension.
REM # =============================================================================================
:ControlPanel_7Zip_ArchiveFormat_Switch
IF %1 EQU Zip (
    SET SevZipArchiveFormat=Zip
    SET SevZipFileExtension=zip
    GOTO :EOF
)
IF %1 EQU GZip (
    SET SevZipArchiveFormat=GZip
    SET SevZipFileExtension=gz
    GOTO :EOF
)
IF %1 EQU BZip2 (
    SET SevZipArchiveFormat=BZip2
    SET SevZipFileExtension=bz2
    GOTO :EOF
)
IF %1 EQU SevenZip (
    SET SevZipArchiveFormat=7z
    SET SevZipFileExtension=7z
    GOTO :EOF
)
IF %1 EQU XZ (
    SET SevZipArchiveFormat=XZ
    SET SevZipFileExtension=xz
    GOTO :EOF
)



REM =============================================================================
REM =============================================================================
REM -----------------------------------------------------------------------------
REM =============================================================================
REM =============================================================================



REM # =============================================================================================
REM # Documentation: Translate the stored value to a working variable.  This will contain a nicer value that will be displayed on the terminal screen.
REM # =============================================================================================
:ControlPanel_7Zip_Compression_Translator
REM Translate these variables as hardly anyone is going to understand what these integers mean.
IF %SevZipCompressionPass% EQU 0 (
    SET ProcessVarA=Copy
    GOTO :EOF
)
IF %SevZipCompressionPass% EQU 1 (
    SET ProcessVarA=Low
    GOTO :EOF
)
IF %SevZipCompressionPass% EQU 3 (
    SET ProcessVarA=Below Normal
    GOTO :EOF
)
IF %SevZipCompressionPass% EQU 5 (
    SET ProcessVarA=Normal
    GOTO :EOF
)
IF %SevZipCompressionPass% EQU 7 (
    SET ProcessVarA=Above Normal
    GOTO :EOF
)
IF %SevZipCompressionPass% EQU 9 (
    SET ProcessVarA=High
    GOTO :EOF
)



REM # =============================================================================================
REM # Documentation: Compression ratio menu
REM # =============================================================================================
:ControlPanel_7Zip_Compression
CALL :DashboardDisplay
REM Translate the value to a nicer value
CALL :ControlPanel_7Zip_Compression_Translator
ECHO 7Zip Compression Level Depth Settings
ECHO.
ECHO Description
ECHO %SeparatorSmall%
ECHO During compacting files into an archive file, it is possible to customize the depth of compression for the data within the archive file.  Higher compression - more CPU time is needed but the data is well compressed, Lesser compression - less CPU time is needed but the data is not so well compressed.
ECHO.
ECHO Default Value: Normal
ECHO Compression Depth is currently: %ProcessVarA%
ECHO %Separator%
ECHO [1] Copy
ECHO [2] Low
ECHO [3] Below Normal
ECHO [4] Normal
ECHO [5] Above Normal
ECHO [6] High
ECHO.
ECHO Other Options
ECHO %SeparatorSmall%
ECHO [X] Cancel
CALL :UserInput
GOTO :ControlPanel_7Zip_Compression_UserInput



REM # =============================================================================================
REM # Documentation: Inspect the user's input.
REM # =============================================================================================
:ControlPanel_7Zip_Compression_UserInput
IF /I "%STDIN%" EQU "Cancel" GOTO :EOF
IF /I "%STDIN%" EQU "X" GOTO :EOF

IF "%STDIN%" EQU "1" (
    CALL :ControlPanel_7Zip_Compression_Switch Copy
    CALL :ClearBuffer 1
    GOTO :ControlPanel_7Zip_Compression
)
IF "%STDIN%" EQU "2" (
    CALL :ControlPanel_7Zip_Compression_Switch Low
    CALL :ClearBuffer 1
    GOTO :ControlPanel_7Zip_Compression
)
IF "%STDIN%" EQU "3" (
    CALL :ControlPanel_7Zip_Compression_Switch BelowNormal
    CALL :ClearBuffer 1
    GOTO :ControlPanel_7Zip_Compression
)
IF "%STDIN%" EQU "4" (
    CALL :ControlPanel_7Zip_Compression_Switch Normal
    CALL :ClearBuffer 1
    GOTO :ControlPanel_7Zip_Compression
)
IF "%STDIN%" EQU "5" (
    CALL :ControlPanel_7Zip_Compression_Switch AboveNormal
    CALL :ClearBuffer 1
    GOTO :ControlPanel_7Zip_Compression
)
IF "%STDIN%" EQU "6" (
    CALL :ControlPanel_7Zip_Compression_Switch High
    CALL :ClearBuffer 1
    GOTO :ControlPanel_7Zip_Compression
)
CALL :BadInput& GOTO :ControlPanel_7Zip_Compression



REM # =============================================================================================
REM # Parameters: [{string} CompressionRatio]
REM # Documentation: This function sets the compression ratio.
REM # =============================================================================================
:ControlPanel_7Zip_Compression_Switch
IF %1 EQU Copy (
    REM Compression: Copy, no compression.
    SET SevZipCompressionPass=0
    GOTO :EOF
)
IF %1 EQU Low (
    REM Compression: Low
    SET SevZipCompressionPass=1
    GOTO :EOF
)
IF %1 EQU BelowNormal (
    REM Compression: Below Normal
    SET SevZipCompressionPass=3
    GOTO :EOF
)
IF %1 EQU Normal (
    REM Compression: Normal
    SET SevZipCompressionPass=5
    GOTO :EOF
)
IF %1 EQU AboveNormal (
    REM Compression: Above Normal
    SET SevZipCompressionPass=7
    GOTO :EOF
)
IF %1 EQU High (
    REM Compression: High
    SET SevZipCompressionPass=9
    GOTO :EOF
)



REM =============================================================================
REM =============================================================================
REM -----------------------------------------------------------------------------
REM =============================================================================
REM =============================================================================



REM # =============================================================================================
REM # Documentation: Copy algorithm menu
REM # =============================================================================================
:ControlPanel_7Zip_CopyAlgorithm
CALL :DashboardDisplay
ECHO 7Zip Copy Format Settings
ECHO.
ECHO Description
ECHO %SeparatorSmall%
ECHO When importing files into an archive file, the 7Zip software requires that the data must be imported in a certain way for compression and decompression means.
ECHO.
ECHO Default Value: Deflate
ECHO Copy Format is currently: %SevZipCopyFormat%
ECHO %Separator%
ECHO [1] Copy
ECHO [2] Deflate
ECHO [3] Deflate64
ECHO [4] BZip2
ECHO [5] LZMA
ECHO [6] PPMd
ECHO.
ECHO Other Options
ECHO %SeparatorSmall%
ECHO [X] Cancel
CALL :UserInput
GOTO :ControlPanel_7Zip_CopyAlgorithm_UserInput



REM # =============================================================================================
REM # Documentation: Inspect the user's input.
REM # =============================================================================================
:ControlPanel_7Zip_CopyAlgorithm_UserInput
IF /I "%STDIN%" EQU "Cancel" GOTO :EOF
IF /I "%STDIN%" EQU "X" GOTO :EOF

IF "%STDIN%" EQU "1" (
    CALL :ControlPanel_7Zip_CopyAlgorithm_Switch Copy
    CALL :ClearBuffer 1
    GOTO :ControlPanel_7Zip_CopyAlgorithm
)
IF "%STDIN%" EQU "2" (
    CALL :ControlPanel_7Zip_CopyAlgorithm_Switch Deflate
    CALL :ClearBuffer 1
    GOTO :ControlPanel_7Zip_CopyAlgorithm
)
IF "%STDIN%" EQU "3" (
    CALL :ControlPanel_7Zip_CopyAlgorithm_Switch Deflate64
    CALL :ClearBuffer 1
    GOTO :ControlPanel_7Zip_CopyAlgorithm
)
IF "%STDIN%" EQU "4" (
    CALL :ControlPanel_7Zip_CopyAlgorithm_Switch BZip2
    CALL :ClearBuffer 1
    GOTO :ControlPanel_7Zip_CopyAlgorithm
)
IF "%STDIN%" EQU "5" (
    CALL :ControlPanel_7Zip_CopyAlgorithm_Switch LZMA
    CALL :ClearBuffer 1
    GOTO :ControlPanel_7Zip_CopyAlgorithm
)
IF "%STDIN%" EQU "6" (
    CALL :ControlPanel_7Zip_CopyAlgorithm_Switch PPMd
    CALL :ClearBuffer 1
    GOTO :ControlPanel_7Zip_CopyAlgorithm
)
CALL :BadInput& GOTO :ControlPanel_7Zip_CopyAlgorithm



REM # =============================================================================================
REM # Parameters: [{string} CopyType]
REM # Documentation: This function sets the primary copy algorithm.
REM # =============================================================================================
:ControlPanel_7Zip_CopyAlgorithm_Switch
IF %1 EQU Copy (
    SET SevZipCopyFormat=Copy
    GOTO :EOF
)
IF %1 EQU Deflate (
    SET SevZipCopyFormat=Deflate
    GOTO :EOF
)
IF %1 EQU Deflate64 (
    SET SevZipCopyFormat=Deflate64
    GOTO :EOF
)
IF %1 EQU BZip2 (
    SET SevZipCopyFormat=BZip2
    GOTO :EOF
)
IF %1 EQU LZMA (
    SET SevZipCopyFormat=LZMA
    GOTO :EOF
)
IF %1 EQU PPMd (
    SET SevZipCopyFormat=PPMd
    GOTO :EOF
)



REM =============================================================================
REM =============================================================================
REM -----------------------------------------------------------------------------
REM =============================================================================
REM =============================================================================



REM # =============================================================================================
REM # Documentation: Translate the stored value to a working variable.  This will contain a nicer value that will be displayed on the terminal screen.
REM # =============================================================================================
:ControlPanel_7Zip_Multithread_Translator
IF %SevZipMultiThreadingCPU% EQU on SET ProcessVarA=Enable& GOTO :EOF
IF %SevZipMultiThreadingCPU% EQU off SET ProcessVarA=Disable
GOTO :EOF



REM # =============================================================================================
REM # Documentation: Multiple threading menu
REM # =============================================================================================
:ControlPanel_7Zip_Multithread
CALL :DashboardDisplay
REM Translate the value to a nicer value
CALL :ControlPanel_7Zip_Multithread_Translator
ECHO 7Zip Multithreading Settings
ECHO.
ECHO Description
ECHO %SeparatorSmall%
ECHO 7Zip can utilize all available CPU cores and threads for processing, which - is faster.  If the CPU does _NOT_ have multiple cores or threads, disable this feature.
ECHO.
ECHO Default Value: Enable
ECHO Multithreading is currently: %ProcessVarA%
ECHO %Separator%
ECHO [1] Enable
ECHO [2] Disable
ECHO.
ECHO Other Options
ECHO %SeparatorSmall%
ECHO [X] Cancel
CALL :UserInput
GOTO :ControlPanel_7Zip_Multithread_UserInput



REM # =============================================================================================
REM # Documentation: Inspect the user's input.
REM # =============================================================================================
:ControlPanel_7Zip_Multithread_UserInput
IF /I "%STDIN%" EQU "Cancel" GOTO :EOF
IF /I "%STDIN%" EQU "X" GOTO :EOF

REM First check if the host system has multithreading capabilities available, and then cache that return value.
CALL :ControlPanel_7Zip_Multithread_Evaluate
SET ProcessVarA=%ERRORLEVEL%

IF "%STDIN%" EQU "1" (
    CALL :ControlPanel_7Zip_Multithread_Toggle False %ProcessVarA%
    CALL :ClearBuffer 1
    GOTO :ControlPanel_7Zip_Multithread
)
IF "%STDIN%" EQU "2" (
    CALL :ControlPanel_7Zip_Multithread_Toggle True %ProcessVarA%
    CALL :ClearBuffer 1
    GOTO :ControlPanel_7Zip_Multithread
)
CALL :BadInput& GOTO :ControlPanel_7Zip_Multithread



REM # =============================================================================================
REM # Parameters: [{string} MultithreadingMode] [{bool} Evaluation]
REM # Documentation: This function sets the multithreading setting.
REM # =============================================================================================
:ControlPanel_7Zip_Multithread_Toggle
IF %1 EQU False (
    IF %2 EQU 1 SET SevZipMultiThreadingCPU=on
    GOTO :EOF
) ELSE (
    SET SevZipMultiThreadingCPU=off
    GOTO :EOF
)



REM # =============================================================================================
REM # Documentation: This function will check to see how many logical cores the host system has available.  This function is dedicated for 7Zip program, Multithreading functionality.  If the host system does NOT have any multithreading capabilities available, this program will disable the multithreading functionality when 7Zip is being called.
REM # =============================================================================================
:ControlPanel_7Zip_Multithread_Evaluate
IF %Number_Of_Processors% EQU 0 (
    REM Not possible to utilize Multithreading
    EXIT /B 0
) ELSE (
    REM Multithreading capabilities are possible
    EXIT /B 1
)
GOTO :EOF



REM =============================================================================
REM =============================================================================
REM -----------------------------------------------------------------------------
REM =============================================================================
REM =============================================================================



REM # =============================================================================================
REM # Documentation: Encryption Algorithm menu
REM # =============================================================================================
:ControlPanel_7Zip_Encryption
CALL :DashboardDisplay
ECHO 7Zip Encryption Algorithm Settings
ECHO.
ECHO Description
ECHO %SeparatorSmall%
ECHO When utilizing password protected archive files, this allows the user to select different encryption types that 7Zip supports.  Best encrypted archives, takes more time to break.
ECHO.
ECHO Default Value: ZipCrypto
ECHO Encryption is currently: %SevZipEncryptionAlgorithm%
ECHO %Separator%
ECHO [1] ZipCrypto
ECHO [2] AES128
ECHO [3] AES192
ECHO [4] AES256
ECHO.
ECHO Other Options
ECHO %SeparatorSmall%
ECHO [X] Cancel
CALL :UserInput
GOTO :ControlPanel_7Zip_Encryption_UserInput



REM # =============================================================================================
REM # Documentation: Inspect the user's input.
REM # =============================================================================================
:ControlPanel_7Zip_Encryption_UserInput
IF /I "%STDIN%" EQU "Cancel" GOTO :EOF
IF /I "%STDIN%" EQU "X" GOTO :EOF
IF "%STDIN%" EQU "1" (
    CALL :ControlPanel_7Zip_Encryption_Switch ZipCrypto
    CALL :ClearBuffer 1
    GOTO :ControlPanel_7Zip_Encryption
)
IF "%STDIN%" EQU "2" (
    CALL :ControlPanel_7Zip_Encryption_Switch AES128
    CALL :ClearBuffer 1
    GOTO :ControlPanel_7Zip_Encryption
)
IF "%STDIN%" EQU "3" (
    CALL :ControlPanel_7Zip_Encryption_Switch AES192
    CALL :ClearBuffer 1
    GOTO :ControlPanel_7Zip_Encryption
)
IF "%STDIN%" EQU "4" (
    CALL :ControlPanel_7Zip_Encryption_Switch AES256
    CALL :ClearBuffer 1
    GOTO :ControlPanel_7Zip_Encryption
)
CALL :BadInput& GOTO :ControlPanel_7Zip_Encryption



REM # =============================================================================================
REM # Parameters: [{string} EncryptionType]
REM # Documentation: This function sets the primary encryption type.
REM # =============================================================================================
:ControlPanel_7Zip_Encryption_Switch
IF %1 EQU ZipCrypto (
    SET SevZipEncryptionAlgorithm=ZipCrypto
    GOTO :EOF
)
IF %1 EQU AES128 (
    SET SevZipEncryptionAlgorithm=AES128
    GOTO :EOF
)
IF %1 EQU AES192 (
    SET SevZipEncryptionAlgorithm=AES192
    GOTO :EOF
)
IF %1 EQU AES256 (
    SET SevZipEncryptionAlgorithm=AES256
    GOTO :EOF
)



REM =============================================================================
REM =============================================================================
REM -----------------------------------------------------------------------------
REM =============================================================================
REM =============================================================================



REM # =============================================================================================
REM # Documentation: Translate the stored value to a working variable.  This will contain a nicer value that will be displayed on the terminal screen.
REM # =============================================================================================
:ControlPanel_7Zip_Verify_Translator
IF %SevZipVerify% EQU True SET ProcessVarA=Enable& GOTO :EOF
IF %SevZipVerify% EQU False SET ProcessVarA=Disable
GOTO :EOF



REM # =============================================================================================
REM # Documentation: Integrity checking menu
REM # =============================================================================================
:ControlPanel_7Zip_Verify
CALL :DashboardDisplay
REM Translate the value to a nicer value
CALL :ControlPanel_7Zip_Verify_Translator
ECHO 7Zip Verification Settings
ECHO.
ECHO Description
ECHO %SeparatorSmall%
ECHO After 7Zip finishes generating an archive file [and everything is already compressed], this option enforces 7Zip to verify the archive file for any potential errors.
ECHO.
ECHO Default Value: Enable
ECHO Integrity Checking is currently: %ProcessVarA%
ECHO %Separator%
ECHO [1] Enable
ECHO [2] Disable
ECHO.
ECHO Other Options
ECHO %SeparatorSmall%
ECHO [X] Cancel
CALL :UserInput
GOTO :ControlPanel_7Zip_Verifys_UserInput



REM # =============================================================================================
REM # Documentation: Inspect the user's input.
REM # =============================================================================================
:ControlPanel_7Zip_Verifys_UserInput
IF /I "%STDIN%" EQU "Cancel" GOTO :EOF
IF /I "%STDIN%" EQU "X" GOTO :EOF

IF "%STDIN%" EQU "1" (
    CALL :ControlPanel_7Zip_Verify_Toggle True
    CALL :ClearBuffer 1
    GOTO :ControlPanel_7Zip_Verify
)
IF "%STDIN%" EQU "2" (
    CALL :ControlPanel_7Zip_Verify_Toggle False
    CALL :ClearBuffer 1
    GOTO :ControlPanel_7Zip_Verify
)
CALL :BadInput& GOTO :ControlPanel_7Zip_Verify



REM # =============================================================================================
REM # Parameters: [{string} VerifyMode]
REM # Documentation: This function sets the primary value for the verification process.
REM # =============================================================================================
:ControlPanel_7Zip_Verify_Toggle
IF %1 EQU True (
    SET SevZipVerify=True
    GOTO :EOF
) ELSE (
    SET SevZipVerify=False
    GOTO :EOF
)



REM =============================================================================
REM =============================================================================
REM -----------------------------------------------------------------------------
REM =============================================================================
REM =============================================================================



REM # =============================================================================================
REM # Documentation: Translate the stored value to a working variable.  This will contain a nicer value that will be displayed on the terminal screen.
REM # =============================================================================================
:ControlPanel_7Zip_TogglePassword_Translator
IF %SevZipUseKey% EQU True SET ProcessVarA=Enable& GOTO :EOF
IF %SevZipUseKey% EQU False SET ProcessVarA=Disable
GOTO :EOF



REM # =============================================================================================
REM # Documentation: Toggle password protection menu
REM # =============================================================================================
:ControlPanel_7Zip_TogglePassword
CALL :DashboardDisplay
REM Translate the value to a nicer value
CALL :ControlPanel_7Zip_TogglePassword_Translator
ECHO 7Zip Toggle Passwords Settings
ECHO.
ECHO Description
ECHO %SeparatorSmall%
ECHO A simple switch to enforce archive files to be created with a password.
ECHO.
ECHO Default Value: Disable
ECHO Use Passwords is currently: %ProcessVarA%
ECHO %Separator%
ECHO [1] Enable
ECHO [2] Disable
ECHO.
ECHO Other Options
ECHO %SeparatorSmall%
ECHO [X] Cancel
CALL :UserInput
GOTO :ControlPanel_7Zip_TogglePassword_UserInput



REM # =============================================================================================
REM # Documentation: Inspect the user's input.
REM # =============================================================================================
:ControlPanel_7Zip_TogglePassword_UserInput
IF /I "%STDIN%" EQU "Cancel" GOTO :EOF
IF /I "%STDIN%" EQU "X" GOTO :EOF

IF "%STDIN%" EQU "1" (
    CALL :ControlPanel_7Zip_TogglePassword_Toggle True
    CALL :ClearBuffer 1
    GOTO :ControlPanel_7Zip_TogglePassword
)
IF "%STDIN%" EQU "2" (
    CALL :ControlPanel_7Zip_TogglePassword_Toggle False
    CALL :ClearBuffer 1
    GOTO :ControlPanel_7Zip_TogglePassword
)
CALL :BadInput& 
GOTO :ControlPanel_7Zip_TogglePassword



REM # =============================================================================================
REM # Parameters: [{string} PasswordProtectionMode]
REM # Documentation: This function enables or disables the password protection.
REM # =============================================================================================
:ControlPanel_7Zip_TogglePassword_Toggle
IF %1 EQU False (
    SET SevZipUseKey=False
    GOTO :EOF
)
REM Assume true otherwise, but also check to make sure that there is a key already set.
IF "%SevZipKey%" EQU "" (
    REM If incase this setting was already enabled previously, disable it.
    SET SevZipUseKey=False
    CALL :ControlPanel_7Zip_TogglePassword_NoKeySetError
    GOTO :EOF
) ELSE (
    SET SevZipUseKey=True
    GOTO :EOF
)



REM # =============================================================================================
REM # Documentation: This function will be called when the user attempts to enable the use of the password - when the password was never defined within the program.
REM # =============================================================================================
:ControlPanel_7Zip_TogglePassword_NoKeySetError
ECHO.&ECHO.
ECHO ^<!^>    Password Not Declared!    ^<!^>
ECHO %SeparatorLong%
ECHO.
ECHO !ERR: There is no password yet defined!  Please go to Password Setup within the 7Zip configuration!
ECHO.
PAUSE
GOTO :EOF




REM =====================================================================
REM Control Panel: 7Zip Configuration
REM ----------------------------
REM Within this section, this will allow the user to customize available settings for 7Zip software.
REM =====================================================================


REM # =============================================================================================
REM # Documentation: Settings menu for 7Zip Configuration
REM # =============================================================================================
:ControlPanel_7Zip
CALL :DashboardDisplay
ECHO 7Zip Configuration Menu
ECHO.
ECHO Select the following options:
ECHO %Separator%
ECHO [1] Password
ECHO [2] Toggle Password
ECHO [3] Archive
ECHO [4] Compression Depth
ECHO [5] Copy Format
ECHO [6] Multithread
ECHO [7] Encryption Algorithm
ECHO [8] Verification
ECHO.
ECHO Other Options
ECHO %SeparatorSmall%
ECHO [X] Exit
CALL :UserInput
GOTO :ControlPanel_7Zip_Menu_UserInput



REM # =============================================================================================
REM # Documentation: Inspect the users input
REM # =============================================================================================
:ControlPanel_7Zip_Menu_UserInput
IF "%STDIN%" EQU "1" GOTO :ControlPanel_7Zip_Menu_Choice_Password
IF "%STDIN%" EQU "2" GOTO :ControlPanel_7Zip_Menu_Choice_TogglePassword
IF "%STDIN%" EQU "3" GOTO :ControlPanel_7Zip_Menu_Choice_Archive
IF "%STDIN%" EQU "4" GOTO :ControlPanel_7Zip_Menu_Choice_Compression
IF "%STDIN%" EQU "5" GOTO :ControlPanel_7Zip_Menu_Choice_CopyAlgorithm
IF "%STDIN%" EQU "6" GOTO :ControlPanel_7Zip_Menu_Choice_Multithread
IF "%STDIN%" EQU "7" GOTO :ControlPanel_7Zip_Menu_Choice_Encryption
IF "%STDIN%" EQU "8" GOTO :ControlPanel_7Zip_Menu_Choice_Verify
IF /I "%STDIN%" EQU "X" GOTO :EOF
IF /I "%STDIN%" EQU "Exit" GOTO :EOF
CALL :BadInput& GOTO :ControlPanel_7Zip



REM # =============================================================================================
REM # Documentation: Call the 7Zip setting for setting a new archive password.
REM # =============================================================================================
:ControlPanel_7Zip_Menu_Choice_Password
CALL :ClearBuffer 1
CALL :ControlPanel_7Zip_Password
CALL :ClearBuffer 1
GOTO :ControlPanel_7Zip



REM # =============================================================================================
REM # Documentation: Call the 7Zip setting for enabling or disabling the archive password.
REM # =============================================================================================
:ControlPanel_7Zip_Menu_Choice_TogglePassword
CALL :ClearBuffer 1
CALL :ControlPanel_7Zip_TogglePassword
CALL :ClearBuffer 1
GOTO :ControlPanel_7Zip



REM # =============================================================================================
REM # Documentation: Call the 7Zip setting for changing the archive file format.
REM # =============================================================================================
:ControlPanel_7Zip_Menu_Choice_Archive
CALL :ClearBuffer 1
CALL :ControlPanel_7Zip_ArchiveFormat
CALL :ClearBuffer 1
GOTO :ControlPanel_7Zip



REM # =============================================================================================
REM # Documentation: Call the 7Zip setting for changing the compression rate.
REM # =============================================================================================
:ControlPanel_7Zip_Menu_Choice_Compression
CALL :ClearBuffer 1
CALL :ControlPanel_7Zip_Compression
CALL :ClearBuffer 1
GOTO :ControlPanel_7Zip



REM # =============================================================================================
REM # Documentation: Call the 7Zip setting for changing the copying algorithm.
REM # =============================================================================================
:ControlPanel_7Zip_Menu_Choice_CopyAlgorithm
CALL :ClearBuffer 1
CALL :ControlPanel_7Zip_CopyAlgorithm
CALL :ClearBuffer 1
GOTO :ControlPanel_7Zip



REM # =============================================================================================
REM # Documentation: Call the 7Zip setting for allowing or disallowing multiple thread processing.
REM # =============================================================================================
:ControlPanel_7Zip_Menu_Choice_Multithread
CALL :ClearBuffer 1
CALL :ControlPanel_7Zip_Multithread
CALL :ClearBuffer 1
GOTO :ControlPanel_7Zip



REM # =============================================================================================
REM # Documentation: Call the 7Zip setting for changing the encryption algorithm.
REM # =============================================================================================
:ControlPanel_7Zip_Menu_Choice_Encryption
CALL :ClearBuffer 1
CALL :ControlPanel_7Zip_Encryption
CALL :ClearBuffer 1
GOTO :ControlPanel_7Zip



REM # =============================================================================================
REM # Documentation: Call the 7Zip setting for changing the archive file type.
REM # =============================================================================================
:ControlPanel_7Zip_Menu_Choice_Verify
CALL :ClearBuffer 1
CALL :ControlPanel_7Zip_Verify
CALL :ClearBuffer 1
GOTO :ControlPanel_7Zip




REM =====================================================================
REM Control Panel: Execute Modules Window Process
REM ----------------------------
REM Allow the user to choose wither or not to execute external modules in a new window or in the same [parent] window as the core.  If incase the modules are serious buggy, it is better to launch them in their own window.
REM =====================================================================


REM # =============================================================================================
REM # Documentation: Priority throttling menu
REM # =============================================================================================
:ControlPanel_ModuleExecuteSharingWindow
CALL :DashboardDisplay
ECHO Module Execution Window Sharing Settings
ECHO.
ECHO Description
ECHO %SeparatorSmall%
ECHO When executing modules, it is possible to have them be in their own window and not sharing the same window as %ProgramName%.  When set to [true], this should be helpful for executing multiple modules as well as avoiding serious conflicts with buggy modules.
ECHO.
ECHO Default Value: True
ECHO Window Sharing is Currently: %ModuleExecuteSharingWindow%
ECHO %Separator%
ECHO [1] True
ECHO [2] False
ECHO.
ECHO Other Options
ECHO %SeparatorSmall%
ECHO [X] Cancel
CALL :UserInput
GOTO :ControlPanel_ModuleExecuteSharingWindow_UserInput



REM # =============================================================================================
REM # Documentation: Inspect the users input
REM # =============================================================================================
:ControlPanel_ModuleExecuteSharingWindow_UserInput
IF /I "%STDIN%" EQU "X" GOTO :EOF
IF /I "%STDIN%" EQU "Cancel" GOTO :EOF

IF "%STDIN%" EQU "1" (
    CALL :ControlPanel_ModuleExecuteSharingWindow_UserInput_Switch True
    CALL :ClearBuffer 1
    GOTO :ControlPanel_ModuleExecuteSharingWindow
)
IF "%STDIN%" EQU "2" (
    CALL :ControlPanel_ModuleExecuteSharingWindow_UserInput_Switch False
    CALL :ClearBuffer 1
    GOTO :ControlPanel_ModuleExecuteSharingWindow
)
CALL :BadInput& GOTO :ControlPanel_ModuleExecuteSharingWindow



REM # =============================================================================================
REM # Parameters: [{String} SettingType]
REM # Documentation: Adjust the variable value as requested by the user.
REM # =============================================================================================
:ControlPanel_ModuleExecuteSharingWindow_UserInput_Switch
IF %1 EQU False (
    SET ModuleExecuteSharingWindow=False
    GOTO :EOF
) ELSE (
    SET ModuleExecuteSharingWindow=True
    GOTO :EOF
)




REM =====================================================================
REM Control Panel: Dashboard Viewer Tool
REM ----------------------------
REM Allow the user to configure the dashboard tool.
REM For some modules, disabling this feature might help with over all performances.
REM =====================================================================


REM # =============================================================================================
REM # Documentation: This function is a translator which takes the variable's value and stores a nicer value name to a temporary working variable.
REM # =============================================================================================
:ControlPanel_DashboardTool_Translator
IF %DashboardViewerTool% EQU True SET ProcessVarA=Enable& GOTO :EOF
IF %DashboardViewerTool% EQU False SET ProcessVarA=Disable
GOTO :EOF



REM # =============================================================================================
REM # Documentation: Dashboard Viewer menu
REM # =============================================================================================
:ControlPanel_DashboardTool
CALL :DashboardDisplay
REM Translate the actual variable value into another variable with a nicer value.
CALL :ControlPanel_DashboardTool_Translator
ECHO Dashboard Viewer Settings
ECHO.
ECHO Description
ECHO %SeparatorSmall%
ECHO The Dashboard Viewer tool only displays quick and brief information that the user will likely need to know.
ECHO.
ECHO Default Value: Enable
ECHO Dashboard Viewer is Currently: %ProcessVarA%
ECHO %Separator%
ECHO [1] Disable
ECHO [2] Enable
ECHO.
ECHO Other Options
ECHO %SeparatorSmall%
ECHO [X] Cancel
CALL :UserInput
GOTO :ControlPanel_DashboardTool_UserInput



REM # =============================================================================================
REM # Documentation: Inspect the users input
REM # =============================================================================================
:ControlPanel_DashboardTool_UserInput
IF /I "%STDIN%" EQU "X" GOTO :EOF
IF /I "%STDIN%" EQU "Cancel" GOTO :EOF

IF "%STDIN%" EQU "1" (
    CALL :ControlPanel_DashboardTool_Toggle Disable
    CALL :ClearBuffer 1
    GOTO :ControlPanel_DashboardTool
)
IF "%STDIN%" EQU "2" (
    CALL :ControlPanel_DashboardTool_Toggle Enable
    CALL :ClearBuffer 1
    GOTO :ControlPanel_DashboardTool
)
CALL :BadInput& GOTO :ControlPanel_DashboardTool



REM # =============================================================================================
REM # Parameters: [{Bool} SettingType]
REM # Documentation: Adjust the variable value as requested by the user.
REM # =============================================================================================
:ControlPanel_DashboardTool_Toggle
IF %1 EQU Enable (
    SET DashboardViewerTool=True
    GOTO :EOF
) ELSE (
    SET DashboardViewerTool=False
    GOTO :EOF
)




REM =====================================================================
REM Debugger Tool
REM ----------------------------
REM This section allows the user to use the debugger tool to either print the users configuration or display the code in real time.  This is not for general purposes, but for debugging and finding errors or inspecting the environment within the current session.
REM =====================================================================


REM # =============================================================================================
REM # Documentation: Debugger menu
REM # =============================================================================================
:DebuggerTool
CALL :DashboardDisplay
ECHO Debugger Tool
ECHO.
ECHO Options available:
ECHO %Separator%
ECHO [User] Display User Vars
ECHO [ECHO] Display code in real time
ECHO [X] Cancel
CALL :UserInput
GOTO :DebuggerTool_UserInput



REM # =============================================================================================
REM # Documentation: Inspect the users input
REM # =============================================================================================
:DebuggerTool_UserInput
IF /I "%STDIN%" EQU "X" GOTO :EOF
IF /I "%STDIN%" EQU "Cancel" GOTO :EOF
IF /I "%STDIN%" EQU "User" (
    CALL :ClearBuffer 1
    CALL :DebuggerTool_User
    CALL :ClearBuffer 1
    GOTO :DebuggerTool
)
IF /I "%STDIN%" EQU "ECHO" (
    CALL :DebuggerTool_EchoOperations
    CALL :ClearBuffer 1
    GOTO :DebuggerTool
)
CALL :BadInput& GOTO :DebuggerTool



REM # =============================================================================================
REM # Documentation: If the user requests to enable or disable the 'ECHO' mode, this function will manage that setting.  Within this function, this will set the DebugMode variable and will also toggle the ECHO mode.
REM # =============================================================================================
:DebuggerTool_EchoOperations
IF "%DebugMode%" EQU "False" (
    SET DebugMode=True
    ECHO ON
    GOTO :EOF
) ELSE (
    SET DebugMode=False
    ECHO OFF
    GOTO :EOF
)



REM # =============================================================================================
REM # Documentation: When this function is called, this will output the user's current configuration on to the terminal screen.  This will use the EnvironmentSetup section in order to properly display all of the results.
REM # =============================================================================================
:DebuggerTool_User
ECHO User Variables
ECHO %Separator%
ECHO.
CALL :EnvironmentSetup_Switch DebugUser
CALL :DebuggerTool_FinishedOut
GOTO :EOF



REM # =============================================================================================
REM # Documentation: This function will be executed when the debug mode or debug request is finished.
REM # =============================================================================================
:DebuggerTool_FinishedOut
ECHO.
ECHO %SeparatorLong%
ECHO Finished
PAUSE
GOTO :EOF




REM =====================================================================
REM Terminate Program
REM ----------------------------
REM This entire section allows the program to properly exit and do any extra procedures necessary before the program terminates completely.
REM Exit Code:
REM   0 = Clean Exit
REM   1 = Environment Hooking
REM   2 = Incorrect Parameters or Syntax Error
REM   3 = Premature Termination or Crash
REM   4 = Incompatible Operating System
REM =====================================================================


REM # =============================================================================================
REM # Parameters: [{String} Mode]
REM # Documentation: This function primarily deals with error termination procedures.
REM #   Incompatible OS
REM #   Environment Hooking
REM #   Incorrect Parameters or Syntax error.
REM # =============================================================================================
:Kill
IF %IncompatibleOS% EQU True (
    REM Because the Windows 9x and ME Operating Systems do not call a subroutine with parameters, we still have to check by a variable.
    REM Remember, to stay compatible within the ancient Windows Operating Systems.
    SET ExitCode=4
    ECHO !ERR_CRIT!: The host Operating System is not compatible with this program.
    GOTO :Terminator
)
REM --------------
REM Environment Hooking failed
IF %1 EQU Hook_Operation (
    SET ExitCode=1
    ECHO !ERR_CRIT!: Could not successfully modify the users working directory!
    CALL :EnvironmentSetup_Switch Thrash
    GOTO :Terminator
)
REM Bad parameter or incorrect syntax
IF %1 EQU BadParameter (
    SET ExitCode=2
    ECHO !ERR_CRIT!: This program was invoked with incorrect parameters.
    CALL :Terminator
)



REM # =============================================================================================
REM # Documentation: When the user requests to terminate the program from the Main Menu, this this function will be called.
REM # =============================================================================================
:KillPrompt
ECHO ^(?^)   End Program   ^(?^)
ECHO %Separator%
ECHO.
ECHO Are you sure you want to end this program?
ECHO.
ECHO [Y] Yes
ECHO [N] Cancel
CALL :UserInput
GOTO :KillPrompt_UserInput



REM # =============================================================================================
REM # Documentation: Inspect the user's input.
REM # =============================================================================================
:KillPrompt_UserInput
IF /I "%STDIN%" EQU "Y" GOTO :KillPrompt_ChoiceYes
IF /I "%STDIN%" EQU "Yes" GOTO :KillPrompt_ChoiceYes
IF /I "%STDIN%" EQU "Exit" GOTO :KillPrompt_ChoiceYes
IF /I "%STDIN%" EQU "Quit" GOTO :KillPrompt_ChoiceYes
IF /I "%STDIN%" EQU "N" GOTO :KillPrompt_ChoiceNo
IF /I "%STDIN%" EQU "No" GOTO :KillPrompt_ChoiceNo
CALL :BadInput& GOTO :KillPrompt



REM # =============================================================================================
REM # Documentation: If the user wishes to terminate the program, then prepare to terminate the program.
REM # =============================================================================================
:KillPrompt_ChoiceYes
SET ExitCode=0
REM Thrash anything that might be sensitive
CALL :EnvironmentSetup_Switch Thrash
REM Revert the user's Working Directory to its original state.
CALL :ClientWorkingDirectorySetup_RevertChange
GOTO :Terminator



REM # =============================================================================================
REM # Documentation: If the user does not want to terminate the program, then return the main menu.
REM # =============================================================================================
:KillPrompt_ChoiceNo
CALL :ClearBuffer 1
GOTO :MainScreen



REM # =============================================================================================
REM # Documentation: Terminate the program.
REM # =============================================================================================
:Terminator
ECHO Closing program...
CALL :ClearBuffer 1
EXIT %ExitCode%